package agent;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.EnumSet;
import java.util.Random;
import java.util.TreeSet;

import radar.Package;
import radar.Package.HeaderType;
import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Civilian;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.standard.messages.AKSpeak;
import rescuecore2.worldmodel.Entity;
import rescuecore2.worldmodel.EntityID;
import worldModel.Area;

public class AmbulanceTeamAgent extends ThinkAgent<AmbulanceTeam> {
	public ArrayList<Human> done = new ArrayList<Human>();
	public ArrayList<Human> humans = new ArrayList<Human>();
	protected ArrayList<Building> endedBuildings = new ArrayList<Building>();
	ArrayList<Human> haveEnoughSupport = new ArrayList<Human>();

	protected EntityID target = null;
	protected EntityID myNextTarget = null;
	protected EntityID aimPosition = null;
	protected EntityID lastPosition = null;
	protected EntityID myTargetPosition = null;
	protected EntityID lastHeard = null;
	// private Random random = new Random(50000);
	private Civilian civilianOnBoard = null;
	public Human myTarget = null;

	private int aimIndex = -1;
	protected int myIndex = -1;
	protected boolean isChert = false;
	private boolean isHeard = false;
	private boolean lastIsHeard = false;
	private boolean shouldListen = true;
	boolean isInsetHuman = false;

	protected void postConnect() {
		super.postConnect();
	}

	protected void act() throws ActionCommandException {
		// log("in koor mibine  :  " +
		// worldModel.changeSet.getChangedEntities());
		if (time < 3)
			rest();
		// log("TAARGET:" + myTarget);
		// if (myTarget != null && myTarget.isPositionDefined())
		// log("DT:" + myTarget.deadtime + "--" + myTarget.getPosition());
		// log("myTarPOS  :  " + myTargetPosition);
		// log("GETMYPOS" + getMyPos());
		// if (myTarget != null && myTarget.isPositionDefined())
		// log("  pos:" + myTarget.getPosition() + "   "
		// + myTarget.haveEnoughSupport);
		me().feedback = false;
		isInsetHuman = false;
		me().isReachable = true;
		isChert = false;

		// lastIsHeard = isHeard;
		if ((!lowCommi && !noCommi) || (lowCommi && time % 7 == 5)) {
			// log("lowCommi  :  " + lowCommi);
			// log("!noCommi  :  " + !noCommi);
			// log("time % 7 == 5  :  " + (time % 7 == 5));
			// log("time % 7 == 6  :  " + (time % 7 == 6));
			// log("!lastIsHeard  :  " + !lastIsHeard);
			// log("nulesh kard!!");
			isHeard = false;
			aimPosition = null;
		}

		// check
		// for (EntityID eI : worldModel.changeSet.getChangedEntities()) {
		// Entity e = worldModel.getEntity(eI);
		// if (e instanceof Civilian)
		// log("---------------------->Id: "
		// + e.getID().getValue()
		// + "Pos: "
		// + ((Civilian) e).getPosition().getValue()
		// + " Deadtime : "
		// + +me().estimatedDeathTime(((Civilian) e).getHP(),
		// ((Civilian) e).getDamage(), time));
		// }
		for (AmbulanceTeam a : worldModel.ambulanceTeams)
			if (me().assignIndex.get(a) == null)
				me().assignIndex.put(a, -1);

		if (worldModel.reachableBuildings.size() <= 5)
			counterForFeedBack++;

		hearAmbulance();
		lastIsHeard = isHeard;
		// log("Folan: " + isHeard);
		if (aimPosition == null
				&& ((!noCommi && !lowCommi) || (lowCommi && time % 7 == 6))) {
			counterForFeedBack = 0;
		}

		if (worldModel.getEntity(me().getPosition()) instanceof Building
				|| worldModel.getEntity(me().getPosition()) instanceof Road)
			setEmpty();
		calcutingStucks();
		if (amIStucking) {
			counterFeedBackStuck++;
			if (aimPosition != null && !isReachable(aimPosition)
					&& counterFeedBackStuck >= 3) {
				counterFeedBackStuck = 0;
				me().feedback = true;
				me().isReachable = false;
				aimPosition = null;
			}
			// log("feedback: " + me().feedback);
		}
		randomWalkComputations();
		setCivilianOnBoard();

		if (me().hasBuriedness) {
			setTarget(null);
			if (isHeard && aimPosition != null) {
				me().feedback = true;
				me().isReachable = false;
			}
			rest();
		}

		if (myTarget != null && !goodEnough(myTarget))
			setTarget(null);

		if (noCommi/* || lowCommi */)
			setHuman();

		if ((lastHeardTime + 21 < time || !shouldListen) && !noCommi) {
			shouldListen = false;
			setHuman();
		}

		// log("++++++++++++++++++++++++++: " + isHeard);
		if (!isHeard) {
			// log("there!!!!");
			if (myTarget != null || myTargetPosition != null) {
				// log("go to normal work");
				normalWork();
			}
		} else {
			// log("^^^^^^");
			// log("aimPosition  :  " + aimPosition);
			// if (aimPosition != null)
			// log("is reachablr$$  :  " + isReachable(aimPosition));
			// log("size reachable  :  " +
			// worldModel.reachableBuildings.size());
			// log("counter  :  " + counterForFeedBack);
			if (aimPosition != null
					&& !isReachable(aimPosition)
					&& (worldModel.reachableBuildings.size() > 5 || counterForFeedBack >= 3)) {
				// log("$$$$$$$$$$$$$$$$$$$$$");
				counterForFeedBack = 0;
				me().feedback = true;
				me().isReachable = false;
				aimPosition = null;
			}
			// log("aimPosition" + aimPosition);
			if (aimPosition != null
					&& !goodEnough(
							((rescuecore2.standard.entities.Area) worldModel
									.getEntity(aimPosition)).area,
							aimIndex)) {
				// log("%%%%%%%%%%%%%%%%%%%%%%");
				counterForFeedBack = 0;
				me().feedback = true;
				isChert = true;
				aimPosition = null;

				// DANGER!
				setTarget(null);
			} else {
				// TODO setTarget Tor
				// log("!!!!!!!!!!!!!");
				myTargetPosition = aimPosition;
				myIndex = aimIndex;
			}
		}
		normalWork();
	}

	private int howManyAmbsAreNeeded(Human cv) {
		int bank = 1;
		for (worldModel.Refuge refuge : worldModel.refuges)
			refuge.checkForAmbForBFS = true;
		me().updateDistance(worldModel);
		int timeToReachRef = 0;
		if (worldModel.reachableRefuges.size() != 0)
			timeToReachRef = me().distance.get(worldModel.reachableRefuges
					.get(0));
		while (bank <= worldModel.ambulanceTeams.size())
			if (cv.deadtime < ((cv.getBuriedness() / bank) + timeToReachRef + time))
				bank++;
			else
				break;
		return bank;
	}

	private void normalWork() throws ActionCommandException {
		if (myTargetPosition != null) {
			if (!me().getPosition().equals(myTargetPosition)) {
				// log("normalWork:" + myTarget + "--" + myTargetPosition + "--"
				// + me().getPosition());
				if (isReachable(myTargetPosition))
					move(myTargetPosition);
				else
					search();
			}
			ArrayList<Human> atTargetPosCv = new ArrayList<Human>();
			ArrayList<Human> atTargetPosAgent = new ArrayList<Human>();
			for (Human se : worldModel.agents) {
				Human h = (Human) se;
				if (h.isPositionDefined() && h.isBuriednessDefined()
						&& h.getPosition().equals(myTargetPosition)
						&& h.getBuriedness() > 0 && goodEnough(h)
						&& h.getID().getValue() % cvRecognizer == myIndex) {
					atTargetPosAgent.add(h);
				}
			}
			for (Human h : worldModel.getCivilians()) {
				if (h.isPositionDefined()
						&& h.getPosition().equals(myTargetPosition)
						&& goodEnough(h)
						&& h.getID().getValue() % cvRecognizer == myIndex)
					atTargetPosCv.add(h);
			}
			if (atTargetPosAgent.size() != 0) {
				Collections.sort(atTargetPosAgent, newComparator);
				for (Human h : atTargetPosAgent)
					setTarget(h);
			} else if (atTargetPosCv.size() != 0) {
				Collections.sort(atTargetPosCv, newComparator);
				for (Human h : atTargetPosCv)
					setTarget(h);
			}
			/*
			 * System.out.println("Re1scue:" + myTarget); log("Re1scue:" +
			 * myTarget);
			 */
			Rescue(myTarget);
		}
		search();
	}

	public float getTheta(float x, float y) {
		return (float) Math.atan2(y, x);
	}

	private void setHuman() throws ActionCommandException {
		if (myTarget != null) {
			if (myTarget.isPositionDefined()
					&& getMyPos().getID().equals(myTarget.getPosition())) {
				// log("Reside");
				Entity human = null;
				int size = 0;
				final int indexOfMe = worldModel.ambulanceTeams.indexOf(me());
				ArrayList<Integer> neededAmbs = new ArrayList<Integer>();
				TreeSet<Integer> indexes = new TreeSet<Integer>();
				ArrayList<Human> helpNeededs = new ArrayList<Human>();
				for (EntityID ei : worldModel.changeSet.getChangedEntities()) {
					human = worldModel.getEntity(ei);
					if (human instanceof AmbulanceTeam
							&& ((AmbulanceTeam) human).getPosition().getValue() == me()
									.getPosition().getValue()
							&& (((AmbulanceTeam) human).isAlive || !((AmbulanceTeam) human).hasBuriedness)) {
						indexes.add(worldModel.ambulanceTeams.indexOf(human));
					} else if (human instanceof Human
							&& ((Human) human).getPosition().getValue() == getMyPos()
									.getID().getValue()
							&& goodEnough((Human) human)
							&& (((Human) human).hasBuriedness || human instanceof Civilian))
						helpNeededs.add((Human) human);
				}
				Collections.sort(helpNeededs, newComparator);
				done: for (Human hu : helpNeededs) {
					size = indexes.size();
					neededAmbs.add(howManyAmbsAreNeeded(hu));
					// log("CV:" + cv + "   need:"
					// + neededAmbs.get(civs.indexOf(cv)) + "   indexes:"
					// + indexes);
					for (int i = 0; i < Math.min(
							neededAmbs.get(helpNeededs.indexOf(hu)), size); i++) {
						if (indexes.first() == indexOfMe) {
							setTarget(hu);
							hu.haveEnoughSupport = false;
							// log("Entekhab shodam!:))" + cv);
							break done;
						} else {
							hu.haveEnoughSupport = true;
							setTarget(null);
						}
						indexes.remove(indexes.first());
					}
				}
			}
		} else {
			// log("my tar is null!!");
			setTarget(null);

			ArrayList<Human> nowTarAgent = new ArrayList<Human>();
			ArrayList<Human> nowTarCv = new ArrayList<Human>();
			// log("agent Tor");
			for (Human h : worldModel.agents) {
				// log("goodEnough(h)  :  " + goodEnough(h));
				if (goodEnough(h) && isReachable(h.getPosition())
						&& !h.equals(me())) {
					nowTarAgent.add(h);
					// log("add to them!: " + h + " reachable: "
					// + isReachable(h.getPosition()));
				}
			}
			// log("cv Tor");
			for (Human h : worldModel.getCivilians()) {
				Civilian cv = (Civilian) h;
				if (goodEnough(cv)
						&& isReachable(cv.getPosition())
						&& cv.getPosition(worldModel) instanceof rescuecore2.standard.entities.Area) {
					nowTarCv.add(cv);
					// log("add to them!: " + cv + " reachable: "
					// + isReachable(cv.getPosition()));
				}
			}

			Collections.sort(nowTarAgent, newComparator);
			Collections.sort(nowTarCv, newComparator);
			Random rnd = new Random(getID().getValue() + time);
			int random = 0;
			if (nowTarAgent.size() != 0) {
				random = rnd.nextInt(Math.min(10, nowTarAgent.size()));
				setTarget(nowTarAgent.get(random));
			} else if (nowTarCv.size() != 0) {
				random = rnd.nextInt(Math.min(10, nowTarCv.size()));
				setTarget(nowTarCv.get(random));
			}
			if (myTarget != null) {
				isInsetHuman = true;
				// Rescue(myTarget);
			} else
				search();
		}
	}

	private boolean goodEnough(worldModel.Area area, int index) {
		return (((area instanceof worldModel.Building && !((worldModel.Building) area)
				.isOnFire()) || area instanceof worldModel.Road)
				&& !(area instanceof worldModel.Refuge)
				&& (isReachable(area.getID()) || (counterForFeedBack < 3 && worldModel.reachableBuildings
						.size() <= 5)) && !area.isEmpty[index] && area.canBeVisited);
	}

	protected boolean goodEnough(Human h) {
		return goodEnough(h, true);
	}

	protected boolean goodEnough(Human h, boolean shouldCheckIsEmpty) {
		if (worldModel.refuges.size() == 0
				&& model.getEntity(h.getPosition()) instanceof Road)
			return false;
		int saverNum = 4;
		if (!noCommi)
			saverNum = worldModel.ambulanceTeams.size();
		if (time > 200 && worldModel.ambulanceTeams.size() > 2)
			saverNum = worldModel.ambulanceTeams.size() - 2;
		// Behin joon dooset darim:)
		// log("^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^");
		// log("h  :  " + h.getID().getValue());
		// log("h.hasBuriedness  :  " + h.hasBuriedness);
		// log("h.isPositionDefined()  :  " + h.isPositionDefined());
		// log("!isOnFire(h.getPosition(worldModel))  :  "
		// + !isOnFire(h.getPosition(worldModel)));
		// log("!(model.getEntity(h.getPosition()) instanceof rescuecore2.standard.entities.Area && !worldModel.getArea(h.getPosition()).canBeVisited)  :  "
		// + !(model.getEntity(h.getPosition()) instanceof
		// rescuecore2.standard.entities.Area && !worldModel
		// .getArea(h.getPosition()).canBeVisited));
		// log("h.isBuriednessDefined()  :  " + h.isBuriednessDefined());
		// if (h.hasBuriedness)
		// log("h.deadtime > time + (h.getBuriedness() / saverNum)  :  "
		// + (h.deadtime > time + (h.getBuriedness() / saverNum)));
		// log("(model.getEntity(h.getPosition()) instanceof Building || (model.getEntity(h.getPosition()) instanceof Road && h.isDamageDefined() && h.getDamage() != 0))  :  "
		// + (model.getEntity(h.getPosition()) instanceof Building || (model
		// .getEntity(h.getPosition()) instanceof Road
		// && h.isDamageDefined() && h.getDamage() != 0)));
		// // if (h.getPosition() != null)
		// log("isReachable(h.getPosition())  :  "
		// + isReachable(h.getPosition()));
		// // log("(!shouldCheckIsEmpty  :  " + !shouldCheckIsEmpty);
		// log("!(worldModel.getArea(h.getPosition())).isEmpty[h.getID().getValue()% cvRecognizer])  :  "
		// + !(worldModel.getArea(h.getPosition())).isEmpty[h.getID()
		// .getValue() % cvRecognizer]);
		// log("!isInRefuge(h)  :  " + !isInRefuge(h));
		// log("!done.contains(h)  :  " + !done.contains(h));
		if ((h.hasBuriedness || h instanceof Civilian)
				&& h.isPositionDefined()
				&& !isOnFire(h.getPosition(worldModel))
				&& !(model.getEntity(h.getPosition()) instanceof rescuecore2.standard.entities.Area && !worldModel
						.getArea(h.getPosition()).canBeVisited)
				&& h.isBuriednessDefined()
				&& h.deadtime > time + (h.getBuriedness() / saverNum)
				&& (model.getEntity(h.getPosition()) instanceof Building || (model
						.getEntity(h.getPosition()) instanceof Road
						&& h.isDamageDefined() && h.getDamage() != 0))
				&& isReachable(h.getPosition())
				&& (!shouldCheckIsEmpty || !(worldModel
						.getArea(h.getPosition())).isEmpty[h.getID().getValue()
						% cvRecognizer]) && !isInRefuge(h) && !done.contains(h)
				&& !h.haveEnoughSupport) {
			// log("fahmid goode hooraaa!!!");
			return true;
		}
		return false;
	}

	public boolean isInRefuge(Human h) {
		if (worldModel.getEntityByInt(h.getPosition().getValue()) instanceof rescuecore2.standard.entities.Refuge)
			return true;
		return false;
	}

	public boolean isOnFire(Entity building) {
		if (building instanceof Building
				&& ((((Building) building).isFierynessDefined()
						&& ((Building) building).getFieryness() > 0 && ((Building) building)
						.getFieryness() != 4) || ((worldModel.Building) ((Building) building).area).stFire == 1))
			return true;
		return false;
	}

	private void setCivilianOnBoard() throws ActionCommandException {
		civilianOnBoard = null;
		for (Civilian civilian : worldModel.getCivilians()) {
			if (civilian.isPositionDefined()
					&& civilian.getPosition().equals(getID())) {
				civilianOnBoard = civilian;
				if (civilian.getHP() != 0) {
					Rescue(civilianOnBoard);
				} else {
					if (civilian.deadCounter > 3) {
						me().feedback = true;
						isChert = true;
						unLoad();
					} else {
						civilian.deadCounter++;
						Rescue(civilianOnBoard);
					}
				}
				break;
			}
		}
	}

	protected void printHumanDetails(Human h) {
		// if (h.hasBuriedness)
		// log("buriedness dare");
		// if (h.isPositionDefined())
		// log("h.isPositionDefined()");
		// if (isReachable(h.getPosition()))
		// log("isReachable");
		// if (isOnFire(model.getEntity(h.getPosition())))
		// log("isonfire");
		// if (model.getEntity(h.getPosition()) instanceof Building
		// || (model.getEntity(h.getPosition()) instanceof Road))
		// log("posOK:D");
		// if (h.isDamageDefined() && h.getDamage() != 0)
		// log("damage " + h.getDamage());
	}

	worldModel.Refuge destRef = null;

	public void goToRefuge() throws ActionCommandException {
		int minLts = Integer.MAX_VALUE;
		if (destRef != null && destRef.getLTS() == time)
			destRef = null;
		if (destRef == null)
			for (worldModel.Refuge ref : worldModel.refuges) {
				if (ref.getLTS() < minLts) {
					minLts = ref.getLTS();
					destRef = ref;
				}
			}
		// log("move2:" + destRef);
		move(destRef);

	}

	protected void Rescue(Human human) throws ActionCommandException {
		if (human == null) {
			return;
		}
		if (civilianOnBoard == null) {
			// log("RESCUE:" + human);
			if (human.isPositionDefined()
					&& me().getPosition().getValue() != human.getPosition()
							.getValue()) {
				// log("move3:" + human.getPosition());
				move(human.getPosition());
			}

			// for (EntityID g : worldModel.changeSet.getChangedEntities()) {
			// Entity j = worldModel.getEntity(g);
			// if (j instanceof Civilian
			// && ((Civilian) j).getPosition().getValue() == human
			// .getPosition().getValue()
			// && ((Civilian) j).getID().getValue() % cvRecognizer == human
			// .getID().getValue() % cvRecognizer)
			// log("$$$$$$$$$$$$$$$$$$$$$$$" + worldModel.getEntity(g));
			// }
			if (!worldModel.isInChangeSet(human.getID())) {
				done.add(human);
				setTarget(null);
				if (human instanceof Civilian) {
					// System.err
					// .println("YOU SHOULD NOT SEE HERE! IF YOU SEE KILL
					// SHIVA");
					human.undefinePosition();
					sendingAUndifinededPositionCV((Civilian) human);
				}
				// log("JJJJJJJJJJJJJJJJJJj");
				return;
			}
			// log("444444444");
			if (human.getBuriedness() > 0) {
				if (!(human instanceof Civilian) && human.getBuriedness() == 1) {
					me().feedback = true;
					isChert = true;
				}

				rescue(human.getID());
			}

			if (!(done.contains(human)))
				done.add(human);

			if (!(human instanceof Civilian)) {
				setTarget(null);
				return;
			}

			int id = me().getID().getValue();
			// TODO : assignINdex kharabe! (dorost shod! :D)

			if (noCommi || isInsetHuman/* || lowCommi */) {
				for (Human h : worldModel.ambulanceTeams)
					if (h.isPositionDefined()
							&& h.getPosition().equals(human.getPosition())
							&& worldModel.isInChangeSet(h.getID())) {
						id = h.getID().getValue();
						break;
					}

			} else
				for (Human a : worldModel.ambulanceTeams) {
					if (a.isPositionDefined()
							&& a.getPosition().equals(human.getPosition())
							&& me().assignIndex.get((AmbulanceTeam) a) == myIndex) {
						id = a.getID().getValue();
						break;
					}
				}

			if (me().getID().getValue() == id) {
				load(human.getID());
			} else {
				setTarget(null);
				lastPosition = me().getPosition();
				me().feedback = true;
				isChert = true;
			}
		} else {
			EntityID refugeID = null;
			int minDis = Integer.MAX_VALUE;
			for (worldModel.Refuge ref : worldModel.reachableRefuges) {
				if (minDis > ref.distanceFromSelf) {
					minDis = ref.distanceFromSelf;
					refugeID = ref.getID();
				}
			}

			if (refugeID == null) {
				if (worldModel.refuges.size() > 0) {
					// goToRefuge();
					// } else {
					search();
				} else if (worldModel.reachableRoads.size() > 0)
					refugeID = worldModel.reachableRoads.iterator().next()
							.getID();
				else if (worldModel.reachableBuildings.size() > 0) {
					refugeID = worldModel.reachableBuildings.iterator().next()
							.getID();
					if (worldModel.reachableBuildings.contains(me()
							.getPosition()))
						refugeID = me().getPosition();
				}
				if (refugeID == null) {
					rest();
				}
			}
			if (me().getPosition().getValue() != refugeID.getValue()) {
				// log("refugeID");
				move(refugeID);
			} else {
				setTarget(null);
				me().feedback = true;
				isChert = true;
				unLoad();
			}
		}
	}

	public void setEmpty() {
		Civilian c = null;
		int counter[] = new int[cvRecognizer];
		Human buildhumans[] = new Human[cvRecognizer];

		Area area = worldModel.getArea(me().getPosition());
		for (int i = 0; i < cvRecognizer; i++)
			area.isEmpty[i] = true;

		for (StandardEntity ent : model
				.getEntitiesOfType(StandardEntityURN.CIVILIAN)) {
			c = (Civilian) ent;
			if (c.isPositionDefined()
					&& c.getPosition(model).getID().getValue() == area.getID()
							.getValue() && goodEnough(c, false)) {
				int id = c.getID().getValue() % cvRecognizer;
				area.isEmpty[id] = false;
				counter[id]++;
				buildhumans[id] = c;
			}
		}

		for (Human h : worldModel.agents)
			if (h.isPositionDefined()
					&& h.getPosition().getValue() == area.getID().getValue()
					&& h.hasBuriedness && h.getBuriedness() > 0
					&& goodEnough(h, false)) {
				int id = h.getID().getValue() % cvRecognizer;
				area.isEmpty[id] = false;
				counter[id]++;
				buildhumans[id] = h;
			}

		for (int i = 0; i < counter.length; i++)
			if (counter[i] == 1) {
				ArrayList<AmbulanceTeam> y = new ArrayList<AmbulanceTeam>();
				for (AmbulanceTeam a : worldModel.ambulanceTeams) {
					if (a.isPositionDefined()
							&& a.getPosition().getValue() == area.getID()
									.getValue()
							&& me().assignIndex.get(a).equals(i))
						y.add(a);
				}
				int z = 0;
				if (y.contains(me()))
					z = y.indexOf(me()) + 1;
				else
					z = y.size() + 1;

				if (z != 1 && buildhumans[i].getBuriedness() < z)
					area.isEmpty[i] = true;

			}
	}

	public Comparator<Entity> newComparator = new Comparator<Entity>() {
		public int compare(Entity a1, Entity a2) {
			// double m = 0;
			double m = 1.0;
			// TODO maptype
			// if (map == MapType.Kobe || map == MapType.VC)
			// m = 2.0;
			if (/* lowCommi || */noCommi)
				m = 0.025;
			Human hu1 = (Human) a1;
			Human hu2 = (Human) a2;
			double d1 = worldModel.getArea(hu1.getPosition()).distanceFromSelf;
			double d2 = worldModel.getArea(hu2.getPosition()).distanceFromSelf;
			double f1 = ((hu1.deadtime) * m + d1);
			double f2 = ((hu2.deadtime) * m + d2);
			// if (hu1 instanceof Civilian && hu2 instanceof Civilian) {
			// if (hu1.deadtime > time && hu2.deadtime <= time)
			// return 1;
			// if (hu2.deadtime > time && hu1.deadtime <= time)
			// return -1;
			// }

			if (f1 == f2) {
				f1 = hu1.getID().getValue();
				f2 = hu2.getID().getValue();
			}

			if (f1 > f2)
				return 1;
			if (f2 > f1)
				return -1;
			return 0;
		}
	};

	int lastHeardTime = 0;

	protected void hearAmbulance() {
		if (heard != null && heard.size() > 0) {
			byte[] recivedSpeak = null;
			for (rescuecore2.messages.Command cmd : heard) {
				Entity entity = worldModel.getEntity(cmd.getAgentID());
				if (cmd instanceof AKSpeak && entity != null
						&& !(entity instanceof Civilian)) {
					AKSpeak as = (AKSpeak) cmd;
					recivedSpeak = as.getContent();
					if (recivedSpeak.length > 0) {
						Package p = new Package(worldModel);
						p.hear(recivedSpeak);
						HeaderType header = p.tellHeader();
						if (header == HeaderType.ACenter) {
							boolean isTargetInRoad = false;
							// isHeard = true;
							int messageSize = worldModel.buildings.size();
							if (p.getInt(2) == 1) {
								isTargetInRoad = true;
								messageSize = worldModel.areas.size();
							}
							ArrayList<AmbulanceTeam> workers = new ArrayList<AmbulanceTeam>();
							if (lowCommi) {
								// log("IIIIIIIIIIIIIIII: " + lastIsHeard);
								if (time % 7 == 5) {
									// log("555555555555555555");
									for (int i = 0; i < worldModel.ambulanceTeams
											.size() / 2; i++) {
										workers.add(worldModel.ambulanceTeams
												.get(i));
										if (me().getID().getValue() == worldModel.ambulanceTeams
												.get(i).getID().getValue())
											isHeard = true;
									}
								} else if (time % 7 == 6) {
									if (lastIsHeard)
										isHeard = true;

									// log("6666666666666666666666666");
									for (int i = worldModel.ambulanceTeams
											.size() / 2; i < worldModel.ambulanceTeams
											.size(); i++) {
										workers.add(worldModel.ambulanceTeams
												.get(i));
										if (me().getID().getValue() == worldModel.ambulanceTeams
												.get(i).getID().getValue())
											isHeard = true;
									}
								} else if (lastIsHeard) {
									isHeard = true;
								}
							} else {
								workers.addAll(worldModel.ambulanceTeams);
								isHeard = true;
							}
							// log("XXXX: " + isHeard);
							for (AmbulanceTeam a : workers) {
								int cvRec = -1;
								Area area = null;
								int myWork = p.getInt(messageSize + 1);
								if (myWork == 0) {
									me().assignIndex.put(a, -1);
								} else {
									if (isTargetInRoad)
										area = worldModel.areas.get(myWork - 1);
									else
										area = worldModel.buildings
												.get(myWork - 1);
									cvRec = p.getInt(cvRecognizer);
									me().assignIndex.put(a, cvRec);
								}
								if (a.getID().getValue() == me().getID()
										.getValue()) {
									lastHeardTime = time;
									if (area == null)
										aimPosition = null;
									else
										aimPosition = area.getID();
									// log("(*_*):" + aimPosition);
									aimIndex = cvRec;
								}
							}
						}
					}
				}
			}
		}
	}

	// boolean lastFeedback = false;
	// Package lastInfoPack = null;

	protected void sendInfo() {
		if (time > 2 && me().feedback) {
			// log("ganna feedback" + me().feedback);
			radar.Package p = new radar.Package(worldModel);
			p.addHeader(HeaderType.Info);
			if (me().isReachable) {
				// log("is*****");
				p.addInt(1, 2);
			} else {
				// log("not****");
				p.addInt(0, 2);
			}
			if (isChert) {
				p.addInt(1, 2);
			} else
				p.addInt(0, 2);
			speak(time, HeaderType.Info, p.send());
			if (lowCommi) {
				for (int i = 0; i < 3; i++)
					speak(time, HeaderType.Info, p.send());
			}

			if (lowCommi) {
				me().isReachable = true;
				isChert = false;
			}
			// lastInfoPack = p;
			// lastFeedback = true;
		} /*
		 * else if (time > 2 && lastFeedback) { speak(time, HeaderType.Info,
		 * lastInfoPack.send()); if (lowCommi) { for (int i = 0; i < 3; i++)
		 * speak(time, HeaderType.Info, lastInfoPack.send()); } if (time % 7 ==
		 * 4 || time % 7 == 5 || time % 7 == 6) return; lastFeedback = false; }
		 */
	}

	protected EnumSet<StandardEntityURN> getRequestedEntityURNsEnum() {
		return EnumSet.of(StandardEntityURN.AMBULANCE_TEAM);
	}

	protected worldModel.Building searchTarget = null;

	protected void setTarget(Human hum) {
		myTarget = hum;
		if (hum != null) {
			// log("setTarget:" + hum + "  :" + myTargetPosition);
			myTargetPosition = hum.getPosition();
			myIndex = hum.getID().getValue() % cvRecognizer;
		} else {
			myTargetPosition = null;
			myIndex = -1;
		}
	}
}