package agent;

import java.util.ArrayList;
import java.util.HashSet;

import radar.Package;
import radar.Package.HeaderType;
import rescuecore2.messages.Command;
import rescuecore2.standard.entities.Civilian;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.PoliceForce;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.messages.AKSpeak;
import rescuecore2.worldmodel.Entity;
import utilities.Logger;
import worldModel.Area;
import worldModel.Building;
import worldModel.Refuge;
import worldModel.WorldModel;

public class CenterForPolice {
	public boolean shouldMatchAgain = false;
	// private HashSet<Area> tasksAreas = new HashSet<Area>();
	private HashSet<Area> doneFireTasksAreas = new HashSet<Area>();
	private HashSet<Area> doneSearchAroundTasksAreas = new HashSet<Area>();
	public ThinkAgent<StandardEntity> agent = null;
	public WorldModel worldModel = null;
	// public int sizeOfOKPolices = 0;
	protected int maxDistanceForMakingGroups = 0;
	protected ArrayList<GroupForPolice> stuckGroupsForPolices = new ArrayList<GroupForPolice>();
	protected ArrayList<GroupForPolice> lastStuckGroupsForPolices = new ArrayList<GroupForPolice>();
	private ArrayList<PoliceForce> assignedForStucks = new ArrayList<PoliceForce>();
	protected ArrayList<PoliceForce> OKPolices = new ArrayList<PoliceForce>();
	private ArrayList<PoliceForce> availablePFs = new ArrayList<PoliceForce>();
	private HashSet<PoliceForce> LastCycleAvailablePFS = new HashSet<PoliceForce>();
	public ArrayList<FireTask> tasks = new ArrayList<FireTask>();
	private FireZoneBuilder fireZoneBuilder = null;
	private ArrayList<FireZone> needSearchAround = new ArrayList<FireZone>();
	Logger logger = null;

	public CenterForPolice(ThinkAgent<StandardEntity> agent,
			utilities.Logger logger) {
		this.agent = agent;
		worldModel = agent.getWorldModel();
		fireZoneBuilder = new FireZoneBuilder(worldModel, agent.bigMap,
				agent.averageOfSurfaces, logger, agent.noCommi);
		this.logger = logger;
	}

	public void log(String msg) {
		// logger.log(msg);
	}

	protected void hearInfo(Entity e, Package p) {
		PoliceForce pf = (PoliceForce) e;

		if (pf.fireTask != null) {
			if (!pf.fireTask.isForSearchAroundZone) {
				boolean checkDone = true;
				for (PoliceForce pfAll : worldModel.policeForces) {
					if (pfAll.getID().getValue() != pf.getID().getValue()
							&& pfAll.fireTask != null
							&& pfAll.fireTask.agentPart.id == pf.fireTask.agentPart.id
							&& pfAll.fireTask.firedBuildingPart.id == pf.fireTask.firedBuildingPart.id) {
						checkDone = false;
						break;
					}
				}
				if (checkDone)
					if (pf.fireTask.headOrTail == 1) // tof :)
						doneFireTasksAreas.add((pf.fireTask.firedBuildingPart));
				pf.fireTask = null;
			} else {
				for (FireZone fz : needSearchAround)
					if (fz.buildings.contains(pf.fireTask.firedBuildingPart)) {
						doneSearchAroundTasksAreas
								.add(pf.fireTask.firedBuildingPart);
					}
				pf.fireTask = null;
			}
		} else if (pf.stuckTarget != null) {
			pf.stuckTarget = null;
		}
	}

	void hears() {
		if (agent.heard != null && agent.heard.size() > 0) {
			byte[] recivedSpeak = null;
			for (Command cmd : agent.heard) {
				Entity entity = worldModel.getEntity(cmd.getAgentID());
				if (cmd instanceof AKSpeak && entity != null
						&& !(entity instanceof Civilian)) {
					AKSpeak as = (AKSpeak) cmd;
					recivedSpeak = as.getContent();
					if (recivedSpeak.length > 0) {
						Package p = new Package(worldModel);
						p.hear(recivedSpeak);
						HeaderType h = p.tellHeader();
						if (h == radar.Package.HeaderType.Info
								&& entity instanceof PoliceForce) {
							hearInfo(entity, p);
						}
					}
				}
			}
		}
	}

	private boolean searchAroundZoneComputations() {

		ArrayList<Area> notDoneAreas = new ArrayList<Area>();
		for (FireZone fz : fireZoneBuilder.modelZones) {
			for (Area a : doneSearchAroundTasksAreas) {
				if (fz.buildings.contains(a)) {
					notDoneAreas.add(a);
				}
			}
		}
		doneSearchAroundTasksAreas.removeAll(notDoneAreas);

		// needSearchAround.clear();
		// done: for (FireZone lastfz : fireZoneBuilder.zoneChanging) {
		// for (FireZone fz : fireZoneBuilder.modelZones) {
		// if (fz.buildings.contains(lastfz.buildings.get(0))) {
		// continue done;
		// }
		// }
		// needSearchAround.add(lastfz);
		// }

		boolean newSearchAroundZone = false;
		done: for (FireZone fZ : fireZoneBuilder.lastModelZones) {
			for (Building b : fZ.buildings)
				if (b.stFire == 1) {
					continue done;
				}
			for (FireZone ffz : needSearchAround)
				if (ffz.buildings.contains(fZ.buildings.get(0)))
					continue done;
			needSearchAround.add(fZ);
			newSearchAroundZone = true;
		}

		ArrayList<FireZone> toRemove = new ArrayList<FireZone>();
		done: for (FireZone nSAFZ : needSearchAround) {
			for (Building b : nSAFZ.buildings) {
				if (b.fireZoneNum != -1 || b.stFire == 1) {
					toRemove.add(nSAFZ);
					continue done;
				}
			}
		}

		done: for (FireZone fz : needSearchAround) {
			for (Area b : doneSearchAroundTasksAreas) {
				if (fz.buildings.contains(b)) {
					toRemove.add(fz);
					continue done;
				}
			}
		}
		needSearchAround.removeAll(toRemove);

		if (newSearchAroundZone)
			return true;
		return false;

	}

	// ArrayList<FireZone> lastNeedSearchAroundZone = new ArrayList<FireZone>();
	// private boolean searchAroundZoneComputations() {
	// lastNeedSearchAroundZone.clear();
	// lastNeedSearchAroundZone.addAll(needSearchAround);
	// //lastNeedSearchAroundZone = needSearchAround;
	//
	// for (FireZone fz: needSearchAround){
	// for(Building b: fz.buildings){
	// if (lastNeedSearchAroundZone.)
	// }
	// }
	// // if (lastNeedSearchAroundZone.equals(needSearchAround))
	// // return false;
	// return true;
	// }

	private void resetAvailablePFs() {
		availablePFs.clear();
		for (PoliceForce pf : OKPolices) {
			if (pf.refugeTarget == null) {
				pf.stuckTarget = null;
				pf.fireTask = null;
				availablePFs.add(pf);
			}
		}
	}

	private void fillAvailablePFs() {
		LastCycleAvailablePFS.clear();
		LastCycleAvailablePFS.addAll(availablePFs);
		availablePFs.clear();

		for (PoliceForce pf : OKPolices) {
			pf.lastRefugeTarget = null;
			pf.lastStuckGroup = null;
			pf.lastFireTask = null;

			if (pf.refugeTarget != null)
				pf.lastRefugeTarget = pf.refugeTarget;
			else if (pf.fireTask != null)
				pf.lastFireTask = pf.fireTask;
			else if (pf.stuckTarget != null)
				pf.lastStuckTarget = pf.stuckTarget;
			else {
				availablePFs.add(pf);
			}
		}
	}

	private boolean doneTasksComputation() {
		if (LastCycleAvailablePFS.size() != availablePFs.size()) {
			return true;
		}

		for (PoliceForce pf : availablePFs)
			if (!LastCycleAvailablePFS.contains(pf))
				return true;

		return false;
	}

	private boolean fireTaskComputation() {

		ArrayList<Area> finishedFireTasks = new ArrayList<Area>();
		for (FireZone fz : needSearchAround)
			for (Area a : doneFireTasksAreas)
				if (fz.buildings.contains(a))
					finishedFireTasks.add(a);
		doneFireTasksAreas.removeAll(finishedFireTasks);

		for (FireZone fZ : fireZoneBuilder.modelZones) {
			int sum = 0;
			for (Building b : fZ.buildings)
				sum += b.getGroundArea();
			fZ.surface = sum;
		}

		done: for (PoliceForce pf : worldModel.policeForces) {
			if (pf.lastFireTask != null) {
				for (FireZone fz : fireZoneBuilder.modelZones) {
					if (fz.buildings
							.contains(pf.lastFireTask.firedBuildingPart)) {
						fz.assigned = true;
						continue done;
					}
				}
			}
		}

		done: for (FireZone fz : fireZoneBuilder.modelZones) {
			if (!fz.assigned) {
				// for (Area b : doneFireTasksAreas)
				// if (fz.buildings.contains(b))
				// continue done;
				return true;
			}
		}

		done: for (FireZone fz : fireZoneBuilder.modelZones) {
			for (FireZone lfz : fireZoneBuilder.lastModelZones) {
				if (fz.buildings.contains(lfz.buildings.get(0))) {
					fz.lastCycleSurface = lfz.surface;

					if (fz.surface == 0) {
						int sum = 0;
						for (Building b : fz.buildings)
							sum += b.getGroundArea();
						fz.surface = sum;
					}

					// log("ThisB: " + fz);
					// log("LastB: " + ffz);
					// log("thisCycle: " + fz.surface / surfaceRange);
					// log("lastCycle: " + fz.lastCycleSurface / surfaceRange);
					// log("size " + fz.buildings.size());
					if (fz.lastCycleSurface / surfaceRange != fz.surface
							/ surfaceRange)
						return true;
					break done;
				}
			}
		}
		return false;
	}

	private int surfaceRange = 0;

	private void setSurfaceRange() {
		int surface = 0;
		for (Building b : worldModel.buildings)
			surface += b.getGroundArea();

		surfaceRange = surface / worldModel.policeForces.size();
		// log("surface: " + surface);
		// log("surfaceRange " + surfaceRange);

	}

	protected void act() {
		fireZoneBuilder.executeModelZones(null);

		if (surfaceRange == 0)
			setSurfaceRange();

		if (agent.time > 3)
			hears();

		if (agent.time < 5)
			return;

		selectOkPolices();
		// log("availables1: " + availablePFs.size());

		fillAvailablePFs();
		// log("availables2: " + availablePFs.size());

		if (agent.time == 5)
			setRefugeTarget();

		boolean doneTasksComputations = doneTasksComputation();
		boolean searchAroundComputations = searchAroundZoneComputations();
		boolean stuckedGroupsComputations = setStuckedGroupsChanges();
		boolean fireTaskComputations = fireTaskComputation();

		if (fireTaskComputations || stuckedGroupsComputations
				|| searchAroundComputations || doneTasksComputations) {

			resetAvailablePFs();
			// log("availables3: " + availablePFs.size());

			setFireTask();
			// log("availables4: " + availablePFs.size());

			makingAndMatchingGroups();
			// log("availables5: " + availablePFs.size());

			setStuckTarget();
			// log("availables6: " + availablePFs.size());
		}
		agent.sendTask();

	}

	@SuppressWarnings("unused")
	private void setGreedyStuckTarget() { // DOTO: Optimized!
		HashSet<Area> toBeRescued = new HashSet<Area>();
		for (PoliceForce pf : availablePFs) {
			pf.stuckTarget = null;
			Area areaOfPolice = worldModel.getArea(pf.getPosition());
			double minDist = Integer.MAX_VALUE;
			Area nearestStuck = null;
			for (int a : agent.trapped.values()) {
				Area areaOfStuck = worldModel.getAreaByInt(a);
				double dist = Math.hypot(
						areaOfPolice.getX() - areaOfStuck.getX(),
						areaOfPolice.getY() - areaOfStuck.getY());
				if (minDist > dist && !toBeRescued.contains(areaOfStuck)) {
					minDist = dist;
					nearestStuck = areaOfStuck;
				}
			}
			if (nearestStuck != null) {
				toBeRescued.add(nearestStuck);
				pf.stuckTarget = nearestStuck;
			}
		}
	}

	private void setFireTask() {
		ArrayList<FireZone> goodFireZones = new ArrayList<FireZone>();

		goodFireZones.addAll(fireZoneBuilder.modelZones);
		// done: for (FireZone fz : fireZoneBuilder.modelZones)
		// for (Area area : doneFireTasksAreas)
		// if (fz.buildings.contains(area)) {
		// log("fz deleted " + fz);
		// goodFireZones.remove(fz);
		// continue done;
		// }

		fillFireTasks(goodFireZones);
		fillSearchAroundTasks();

	}

	private void fillFireTasks(ArrayList<FireZone> fireZones) {
		HashSet<PoliceForce> used = new HashSet<PoliceForce>();
		for (FireZone fz : fireZones) {

			// tailor
			double minDist = Integer.MAX_VALUE;
			int policeNeededNum = fz.surface / surfaceRange + 1;

			// albate tu in sharayet dige bayad berim bemirim! :))
			if (policeNeededNum > worldModel.policeForces.size())
				policeNeededNum = worldModel.policeForces.size();

			for (int i = 0; i < policeNeededNum; i++) {
				minDist = Integer.MAX_VALUE;
				PoliceForce nearestTailor = null;
				for (PoliceForce tailorPF : availablePFs) {
					double dist = Math.hypot(fz.centerX - tailorPF.getX(),
							fz.centerY - tailorPF.getY());
					if (tailorPF.lastFireTask != null
							&& fz.buildings
									.contains(tailorPF.lastFireTask.firedBuildingPart)) {
						dist *= 0.5;
						if (tailorPF.lastFireTask.headOrTail == 1)
							dist *= 0.7;
					}

					if (dist < minDist && !used.contains(tailorPF)) {
						minDist = dist;
						nearestTailor = tailorPF;
					}
				}
				if (nearestTailor != null) {
					used.add(nearestTailor);
					Area bestBuild = getBestBuilding(fz, nearestTailor);
					nearestTailor.fireTask = new FireTask(bestBuild, bestBuild,
							false);
					if (nearestTailor.getID().getValue() == agent.getID()
							.getValue()) {
						nearestTailor.realFireTask = new FireTask(bestBuild,
								bestBuild, false);
						nearestTailor.realFireTask.headOrTail = 1;
					}
					// tasks.add(new FireTask(fz.buildings.get(0),
					// fz.buildings
					// .get(0), false));
					nearestTailor.fireTask.headOrTail = 1;
				}
			}
			// header
			minDist = Integer.MAX_VALUE;
			FireBrigade nearestFireBrigade = null;
			for (FireBrigade fb : worldModel.fireBrigades) {
				if (fb.hasBuriedness)
					continue;
				double dist = Math.hypot(fz.centerX - fb.getX(), fz.centerY
						- fb.getY());
				if (dist < minDist) {
					minDist = dist;
					nearestFireBrigade = fb;
				}
			}
			if (nearestFireBrigade != null) {
				double minDistFromPolice = Integer.MAX_VALUE;
				PoliceForce nearestHeader = null;
				for (PoliceForce headerPf : availablePFs) {
					double dist = Math.hypot(headerPf.getX()
							- nearestFireBrigade.getX(), headerPf.getY()
							- nearestFireBrigade.getY());
					if (headerPf.lastFireTask != null
							&& fz.buildings
									.contains(headerPf.lastFireTask.firedBuildingPart)) {
						dist *= 0.5;
						if (headerPf.lastFireTask.headOrTail == 0)
							dist *= 0.7;
					}

					if (dist < minDistFromPolice && !used.contains(headerPf)) {
						minDistFromPolice = dist;
						nearestHeader = headerPf;
					}
				}
				if (nearestHeader != null) {
					used.add(nearestHeader);
					nearestHeader.fireTask = new FireTask(
							worldModel
									.getArea(nearestFireBrigade.getPosition()),
							getBestBuilding(fz, nearestFireBrigade), false);
					if (nearestHeader.getID().getValue() == agent.getID()
							.getValue()) {
						nearestHeader.realFireTask = new FireTask(
								worldModel.getArea(nearestFireBrigade
										.getPosition()), getBestBuilding(fz,
										nearestFireBrigade), false);
						nearestHeader.realFireTask.headOrTail = 0;
					}

					// tasks.add(new FireTask(worldModel
					// .getArea(nearestFireBrigade.getPosition()),
					// getBestBuilding(fz, nearestFireBrigade), false));
					nearestHeader.fireTask.headOrTail = 0;
				}
			}
		}
		availablePFs.removeAll(used);
	}

	private Area getBestBuilding(FireZone fz, Human h) {
		Area best = null;
		double minDist = Integer.MAX_VALUE;
		for (Area a : fz.simulatedAroundsWithSetGood) {
			double dist = Math.hypot(h.getX() - a.getX(), h.getY() - a.getY());
			if (dist < minDist) {
				minDist = dist;
				best = a;
			}
		}

		return best;
	}

	// private Area getNearestBuilding(FireZone fz, PoliceForce pf) {
	// Area best = null;
	// double minDist = Double.MAX_VALUE;
	// for (Area a : fz.buildings) {
	// double dist = Math
	// .hypot(fb.getX() - a.getX(), fb.getY() - a.getY());
	// if (dist < minDist) {
	// minDist = dist;
	// best = a;
	// }
	// }
	//
	// return best;
	// }

	private void fillSearchAroundTasks() {
		if (needSearchAround.size() == 0)
			return;

		HashSet<PoliceForce> used = new HashSet<PoliceForce>();
		for (FireZone fz : needSearchAround) {
			Building b = agent.getBestBuildingForSearchArondZone(fz);
			// if (!tasks.contains(b)) {
			double minDistFromPolice = Integer.MAX_VALUE;
			PoliceForce nearestPolice = null;
			for (PoliceForce pf : availablePFs) {
				double dist = Math.hypot(pf.getX() - b.getX(),
						pf.getY() - b.getY());
				if (dist < minDistFromPolice && !used.contains(pf)) {
					minDistFromPolice = dist;
					nearestPolice = pf;
				}
			}
			if (nearestPolice != null) {
				nearestPolice.fireTask = new FireTask(b, b, true);
				used.add(nearestPolice);
			}
			// }
		}
		availablePFs.removeAll(used);
	}

	private void setRefugeTarget() {
		ArrayList<Refuge> targetRefuges = new ArrayList<>();
		if (worldModel.refuges.size() <= OKPolices.size() / 2)
			targetRefuges.addAll(worldModel.refuges);
		else
			for (int i = 0; i < OKPolices.size() / 2; i++) {
				// TODO Try to make it half near refuges
				targetRefuges.add(worldModel.refuges.get(i));
			}
		for (Refuge r : targetRefuges) {
			double minDist = Integer.MAX_VALUE;
			PoliceForce nearest = null;
			for (PoliceForce pf : OKPolices) {
				double dist = r.distance(worldModel.getArea(pf.getPosition()));
				if (dist < minDist && pf.refugeTarget == null) {
					minDist = dist;
					nearest = pf;
				}
			}
			if (nearest != null) {
				nearest.refugeTarget = r;
			}
		}
		// HungarianAlgorithm ha = new HungarianAlgorithm();
		// ha.executeRefugesForPolice(targetRefuges, OKPolices);
		// for (int i = 0; i < OKPolices.size(); i++)
		// if (ha.getMatchedNum(i) != -1) {
		// OKPolices.get(i).refugeTarget = targetRefuges.get(ha
		// .getMatchedNum(i));
		// }
		// String refugeTarg = "";
		// for (PoliceForce pf : worldModel.policeForces) {
		// if (pf.refugeTarget != null) {
		// refugeTarg += pf.getID().getValue() + " " + pf.refugeTarget.id
		// + " ";
		// }
		// }
		// log("refugetargets: " + refugeTarg);
	}

	private void setStuckTarget() {
		ArrayList<PoliceForce> used = new ArrayList<PoliceForce>();
		for (PoliceForce pf : assignedForStucks) {
			if (!availablePFs.contains(pf))
				continue;

			pf.stuckTarget = null;
			Area areaOfPolice = worldModel.getArea(pf.getPosition());
			double minDist = Integer.MAX_VALUE;
			Human nearestStuck = null;
			for (Human stuck : stuckGroupsForPolices.get(pf.groupNum).stuckAgents) {
				Area areaOfStuck = worldModel.getAreaByInt(agent.trapped
						.get(stuck.getID().getValue()));
				double dist = Math.hypot(
						areaOfPolice.getX() - areaOfStuck.getX(),
						areaOfPolice.getY() - areaOfStuck.getY());
				if (minDist > dist) {
					minDist = dist;
					nearestStuck = stuck;
				}
			}
			pf.stuckTarget = worldModel.getAreaByInt(agent.trapped
					.get(nearestStuck.getID().getValue()));
			used.add(pf);

		}
		availablePFs.removeAll(used);
	}

	private void makingAndMatchingGroups() {
		// String stuckss = "";
		// for (GroupForPolice gfp : stuckGroupsForPolices) {
		// for (Human stuck : gfp.stuckAgents) {
		// stuckss += stuck + " ";
		// stuck.lastStuckGroup = gfp;
		// }
		// }
		// log("stuckkkssssss " + stuckss);

		shouldMatchAgain = hasStuckGroupsChanged() || hasStuckersChange();

		if (shouldMatchAgain) {
			assignedForStucks.clear();
			for (Human hu : worldModel.agents)
				hu.lastStuckGroup = null;
			for (PoliceForce p : worldModel.policeForces)
				p.groupNum = -1;
		}

		if (stuckGroupsForPolices.size() > 0 && shouldMatchAgain
				&& availablePFs.size() > 0) {
			HungarianAlgorithm matchingGroup = new HungarianAlgorithm();
			matchingGroup.executePG(stuckGroupsForPolices, availablePFs,
					worldModel, agent.time);
			for (PoliceForce pf : worldModel.policeForces)
				pf.stuckTarget = null;
			setPolicesGroupNum(matchingGroup);

		}
		lastStuckGroupsForPolices.clear();
		lastStuckGroupsForPolices.addAll(stuckGroupsForPolices);
	}

	private boolean hasStuckersChange() {
		for (PoliceForce pf : availablePFs)
			if (!assignedForStucks.contains(pf))
				return true;
		return false;
	}

	private boolean hasStuckGroupsChanged() {
		if (stuckGroupsForPolices.size() != lastStuckGroupsForPolices.size())
			return true;
		else {
			for (int i = 0; i < stuckGroupsForPolices.size(); i++) {
				for (Human hu : stuckGroupsForPolices.get(i).stuckAgents) {
					if (!lastStuckGroupsForPolices.get(i).stuckAgents
							.contains(hu)) {
						return true;
					}
				}
			}
		}
		return false;
	}

	private boolean setStuckedGroupsChanges() {
		stuckGroupsForPolices.clear();
		for (Human h : worldModel.agents)
			h.pogNum = -1;
		for (int id : agent.trapped.keySet())
			((Human) worldModel.getEntityByInt(id)).bfsPoliceMark = false;
		for (int id : agent.trapped.keySet()) {
			Human hu = (Human) worldModel.getEntityByInt(id);
			if (hu.pogNum == -1)
				setGroupOfStuckAgentForPolicesBybfs(hu);
		}
		return hasStuckGroupsChanged();
	}

	private void setPolicesGroupNum(HungarianAlgorithm ha) {
		// ArrayList<PoliceForce> toBeUnavailable = new
		// ArrayList<PoliceForce>();
		for (int i = 0; i < availablePFs.size(); i++) {
			availablePFs.get(i).groupNum = ha.getMatchedNum(i);
			if (availablePFs.get(i).groupNum != -1) {
				// toBeUnavailable.add(availablePFs.get(i));
				assignedForStucks.add(availablePFs.get(i));
			}
		}
		// availablePFs.removeAll(toBeUnavailable);
	}

	private void selectOkPolices() {
		OKPolices = new ArrayList<PoliceForce>();
		for (PoliceForce pf : worldModel.policeForces) {
			if (pf.isOK && !pf.hasBuriedness) {
				OKPolices.add(pf);
			}
		}
	}

	private void setGroupOfStuckAgentForPolicesBybfs(Human a) {
		maxDistanceForMakingGroups = worldModel.setRange() / 2;
		HashSet<Human> layer = new HashSet<Human>();
		layer.add(a);
		GroupForPolice pog = new GroupForPolice();
		pog.stuckAgents.add(a);
		pog.pogNum = stuckGroupsForPolices.size();
		a.pogNum = stuckGroupsForPolices.size();
		while (layer.size() > 0) {
			HashSet<Human> newLayer = new HashSet<>();
			for (Human stuckAgent : layer) {
				Area areaOfStuck = worldModel.getArea(stuckAgent.getPosition());
				for (int id : agent.trapped.keySet()) {
					if (stuckAgent.getID().getValue() == id)
						continue;
					rescuecore2.worldmodel.Entity nearStuckAgent = worldModel
							.getEntityByInt(id);
					Area areaOfNearStuck = worldModel
							.getArea(((Human) nearStuckAgent).getPosition());
					int maxDist = maxDistanceForMakingGroups;
					if (stuckAgent.lastStuckGroup != null
							&& stuckAgent.lastStuckGroup.stuckAgents
									.contains(nearStuckAgent))
						maxDist = maxDistanceForMakingGroups + 10000;

					double dist = Math.hypot(areaOfStuck.getX()
							- areaOfNearStuck.getX(), areaOfStuck.getY()
							- areaOfNearStuck.getY());

					if (((Human) nearStuckAgent).pogNum == -1
							&& dist + pog.totalDist < maxDist) {
						newLayer.add((Human) nearStuckAgent);
						pog.stuckAgents.add((Human) nearStuckAgent);
						pog.totalDist += dist;
						((Human) nearStuckAgent).pogNum = pog.pogNum;
					}
				}
			}
			layer = newLayer;
		}

		stuckGroupsForPolices.add(pog);
		// if (pog.stuckAgents.size() > 2)
		// stuckGroupsForPolices.add(pog);
	}
}
