package agent;

import geometry.Mathematic;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashSet;

import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.GasStation;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.worldmodel.EntityID;
import worldModel.Area;
import worldModel.Building;

public class FireBrigadeAgentNoHear {
	private worldModel.Building extTarget;
	private worldModel.Building beingExtinguished;
	private worldModel.Building myBuilding;
	private FireZone myZone = null;

	FireBrigadeAgent agent = null;

	// private final double w1 = 100, w2 = 5, w3 = -2.5, w4 = -5;

	private int counter = 10;

	private worldModel.Building selectTarget() {
		if (myZone == null) {
			return null;
		}
		if (extTarget == null || !agent.buildingReachability(extTarget)
				|| extTarget.stFire == 0 || counter >= 5) {
			counter = 0;

			double minValue = Integer.MAX_VALUE;
			worldModel.Building minBuil = null;
			ArrayList<worldModel.Building> aroundReachable = new ArrayList<>();
			for (worldModel.Building building : myZone.simulatedAroundsWithSetGood)
				if (agent.buildingReachability(building))
					aroundReachable.add(building);
			if (aroundReachable.size() != 0) {
				for (worldModel.Building buil : aroundReachable)
					if ((minValue == Integer.MAX_VALUE || buil.value < minValue)) {
						minValue = buil.value;
						minBuil = buil;
					}
			} else {
				FireZone tmpZone = new FireZone(myZone.fireZoneNum);
				for (worldModel.Building building : myZone.ignitedBuilds) {
					// agent.log("is reachable?: " + building + "   r: "
					// + agent.buildingReachability(building));
					if (agent.buildingReachability(building))
						tmpZone.ignitedBuilds.add(building);
				}
				// agent.log("myZone.ignited: " + myZone.ignitedBuilds);
				// agent.log("tmpZone: " + tmpZone);
				if (tmpZone.ignitedBuilds.size() != 0)
					tmpZone.reconstructedBuildings();
				for (worldModel.Building building : tmpZone.simulatedAroundsWithSetGood)
					setValueForBuildings(building);
				if (tmpZone.simulatedAroundsWithSetGood.size() != 0)
					for (worldModel.Building building : tmpZone.simulatedAroundsWithSetGood) {
						if ((minValue == Integer.MAX_VALUE || building.value < minValue)
								&& agent.buildingReachability(building)) {
							minValue = building.value;
							minBuil = building;
						}
					}
				else
					minBuil = null;
			}
			return minBuil;
		}
		return extTarget;
	}

	private void setWorkersNum() {
		for (FireZone fireZone : agent.fireZoneBuilder.modelZones) {
			if (fireZone.valueForWorkwerNum > 22)
				fireZone.workersNum = 15;
			if (fireZone.valueForWorkwerNum <= 17)
				fireZone.workersNum = 9;
			if (fireZone.valueForWorkwerNum <= 12)
				fireZone.workersNum = 6;
			if (fireZone.valueForWorkwerNum <= 7)
				fireZone.workersNum = 3;
			if (agent.bigMap)
				fireZone.workersNum *= 2;
		}
	}

	private void simulator(worldModel.Building building) {
		for (worldModel.Building building2 : building.nearBuildings) {
			if (building2.stFire == 0)
				building.nearForSimulator.add(building2);

		}
	}

	private void setVolumeSimulator(worldModel.Building buil) {
		buil.volume = 0;
		for (worldModel.Building hf : buil.nearForSimulator) {
			buil.volume += hf.getFloors() * hf.getGroundArea()
					/ agent.maxVolumeOfAllBuildings;
		}
	}

	private void moveAndExtinguish(worldModel.Building fireTarget)
			throws ActionCommandException {
		if (fireTarget != null) {
			if (!agent.noCommi)
				((FireBrigadeAgent) agent).beforeExt(fireTarget);
			if (agent.worldModel.isInChangeSet(fireTarget.getID())
					&& canExtinguish(fireTarget) && !agent.IamOnfire) {
				if (myZone.buildings.contains(fireTarget))
					myZone.extinguishedByMe = true;
				beingExtinguished = fireTarget;
				agent.lastInNoHear = agent.time;
				if (agent.noCommi)
					((FireBrigadeAgent) agent).beforeExt(fireTarget);
				agent.extinguish(fireTarget.getID(), agent.maxPower);
			}
			agent.moveToFire(fireTarget);
		}
	}

	private boolean zoneChange() throws ActionCommandException {
		if (myZone == null || agent.lastInNoHear < agent.time - 1)
			return true;
		ArrayList<FireZone> modelZonesCopy = new ArrayList<FireZone>();
		boolean tof = myZone.extinguishedByMe;
		FireZone myZoneCopy = myZone;
		FireZone lastZone = myZone;
		selectMyZone(true);
		modelZonesCopy.addAll(agent.fireZoneBuilder.modelZones);
		if (agent.fireZoneBuilder.modelZones.size() == 0)
			myZoneCopy = null;
		if (modelZonesCopy.size() != agent.fireZoneBuilder.lastModelZones
				.size()) {
			extTarget = null;
			return true;
		}
		for (FireZone fireZone : agent.fireZoneBuilder.lastModelZones) {
			int counter = 0;
			for (int i = 0; i < modelZonesCopy.size(); i++)
				if (modelZonesCopy.get(i).buildings.contains(fireZone.buildings
						.get(0))) {
					if (agent.bigMap) {
						if (Math.abs(fireZone.assignedWorkerNum
								- modelZonesCopy.get(i).assignedWorkerNum) > 21) {
							extTarget = null;
							return true;
						}
					} else if (Math.abs(fireZone.assignedWorkerNum
							- modelZonesCopy.get(i).assignedWorkerNum) > 7) {
						extTarget = null;
						return true;
					}
					counter++;
					if ((fireZone.buildings.get(0)).getID().getValue() == myBuilding
							.getID().getValue())
						myZoneCopy = modelZonesCopy.get(i);
					modelZonesCopy.remove(i);
					i--;
				}
			if (counter == 0) {
				extTarget = null;
				return true;
			}
		}
		if (!lastZone.hibitor && myZoneCopy.hibitor) {
			extTarget = null;
			return true;
		}
		myZone = myZoneCopy;
		myZone.extinguishedByMe = tof;
		return false;
	}

	private boolean zoneFinish() {
		for (FireZone fireZone : agent.fireZoneBuilder.modelZones)
			if (fireZone.buildings.contains(myBuilding)) {
				return false;
			}
		return true;
	}

	protected void act() throws ActionCommandException {
		for (FireZone fz : agent.fireZoneBuilder.modelZones) {
			for (Building b : fz.buildings) {
				if (b.serverArea instanceof GasStation && b.isOnFire()
						&& !b.itWasSimulated) {
					b.itWasSimulated = true;
					for (StandardEntity sE : agent.worldModel.getModel()
							.getObjectsInRange(b.getID(), 50000)) {
						if (sE instanceof rescuecore2.standard.entities.Building)
							((Building) ((rescuecore2.standard.entities.Area) sE).area).stFire = 1;

					}
				}
			}
		}
		for (worldModel.Area ar : agent.worldModel.areas)
			ar.fireBrigades.clear();
		for (FireBrigade fire : agent.worldModel.fireBrigades) {
			if (fire.hasBuriedness)
				continue;
			worldModel.Area area = agent.worldModel.getArea(fire.getPosition());
			area.fireBrigades.add(fire);
		}
		if (myZone != null)
			myBuilding = myZone.buildings.get(0);

		for (worldModel.Building building : agent.worldModel.buildings)
			building.nearForSimulator.clear();
		setValueForAroundBuildings();
		setWorkersNum();
		if (myZone != null && myZone.buildings.size() <= 12 && zoneFinish()
				&& myZone.extinguishedByMe)
			myZone = null;
		FireZone exZone = null;
		done: for (FireZone fz : agent.fireZoneBuilder.modelZones)
			for (worldModel.Building b : fz.buildings)
				if (agent.me().aim != null && agent.me().aim.id == b.id) {
					exZone = myZone;
					break done;
				}

		if (agent.noCommi && agent.fireZoneBuilder.modelZones.size() != 0) {
			selectMyZoneForNoCommi();
		} else if (agent.fireZoneBuilder.modelZones.size() != 0
				&& (myZone == null || myZone.emergency || zoneChange())) {
			selectMyZone(false);
		}
		if (agent.fireZoneBuilder.modelZones.size() == 0)
			myZone = null;
		if (exZone != null
				&& myZone != null
				&& ((myZone.hibitor && !exZone.hibitor) || (extTarget != null
						&& !myZone.ignitedBuilds.contains(extTarget) && myZone.value < exZone.value))) {
			extTarget = null;
			beingExtinguished = null;
		}
		if (myZone != null)
			counter++;
		worldModel.Building fireTarget = selectTargetNew();
		if (fireTarget != null) {
			extTarget = fireTarget;
			if (!agent.noCommi)
				agent.lastZone = agent.fireZoneBuilder.modelZones
						.get(fireTarget.fireZoneNum);
			moveAndExtinguish(fireTarget);
		}
		agent.lastInNoHear = agent.time;
	}

	private worldModel.Building selectTargetNew() {
		if (myZone == null || agent.me().hasBuriedness) {
			return null;
		}
		if (extTarget != null
				&& (extTarget.stFire == 0
						|| (extTarget.owners.size() >= extTarget.toBeAssignedNum && !extTarget.owners
								.contains(agent.me().getID().getValue())) || !agent
							.buildingReachability(extTarget))) {
			extTarget = null;
		}
		if (extTarget == null || counter >= 5) {
			counter = 0;
			ArrayList<worldModel.Building> suitableAround = new ArrayList<worldModel.Building>();
			// String A = "";
			for (worldModel.Building building : myZone.simulatedAroundsWithSetGood) {
				// A += building.getID().getValue() + " ";
				if (agent.buildingReachability(building)
						&& building.owners.size() < building.toBeAssignedNum) {
					suitableAround.add(building);
				}
			}
			// agent.log("Around in 2012 : " + A);
			double minValue = Integer.MAX_VALUE;
			worldModel.Building minBuil = null;
			if (suitableAround.size() != 0) {
				for (worldModel.Building buil : suitableAround)
					if ((/* minevalue == Double.MAX_VALUE || */buil.value < minValue)) {
						minValue = buil.value;
						minBuil = buil;
					}
			} else {
				FireZone tmpZone = new FireZone(myZone.fireZoneNum);
				for (worldModel.Building building : myZone.ignitedBuilds)
					if (agent.buildingReachability(building))
						tmpZone.ignitedBuilds.add(building);
				if (tmpZone.ignitedBuilds.size() != 0)
					tmpZone.reconstructedBuildings();
				for (worldModel.Building building : tmpZone.simulatedAroundsWithSetGood)
					setValueForBuildings(building);
				if (tmpZone.simulatedAroundsWithSetGood.size() != 0)
					for (worldModel.Building building : tmpZone.simulatedAroundsWithSetGood) {

						if ((minValue == Integer.MAX_VALUE || building.value < minValue)
								&& agent.buildingReachability(building)
								&& building.owners.size() < building.toBeAssignedNum) {
							minValue = building.value;
							minBuil = building;
						}
					}
			}
			if (minBuil != null) {
				return minBuil;
			} else {
				return selectTarget();
			}
		}
		return extTarget;
	}

	private HashSet<FireBrigade> bFSForFire() {
		HashSet<worldModel.Entrance> laye = new HashSet<>();
		HashSet<FireBrigade> list = new HashSet<FireBrigade>();
		agent.worldModel.clearAreas();
		list.add((FireBrigade) agent.me());
		for (worldModel.Entrance enterance : agent.worldModel.myEntrances) {
			if (!enterance.area.checkSituation4Fire
					&& enterance.area.fireBrigades != null
					&& enterance.area.fireBrigades.size() > 0) {
				enterance.area.checkSituation4Fire = true;
				list.addAll(enterance.area.fireBrigades);
			}

			laye.add(enterance);
		}
		while (laye.size() > 0) {
			HashSet<worldModel.Entrance> newLaye = new HashSet<>();
			for (worldModel.Entrance enterance : laye) {
				worldModel.Entrance neighbourE = enterance.neighbour;
				if (!neighbourE.area.checkSituation4Fire
						&& enterance.isItConnectedToNeighbour) {
					if (neighbourE.area.fireBrigades != null
							&& neighbourE.area.fireBrigades.size() != 0)
						list.addAll(neighbourE.area.fireBrigades);
				}
				enterance.mark = true;
				neighbourE.area.checkSituation4Fire = true;
				neighbourE.mark = true;
				for (worldModel.Entrance internal : neighbourE.internalEntrances)
					if (!internal.mark)
						newLaye.add(internal);
			}

			laye = newLaye;
		}
		return list;
	}

	private void selectMyZoneForNoCommi() throws ActionCommandException {
		ArrayList<FireZone> hibitorFireZones = new ArrayList<FireZone>();
		for (FireZone firezone : agent.fireZoneBuilder.modelZones)
			if (firezone.hibitor)
				hibitorFireZones.add(firezone);
		if (hibitorFireZones.size() > 0) {
			for (FireZone fireZone : hibitorFireZones) {
				double distToZone = Integer.MAX_VALUE;
				for (worldModel.Building buil : fireZone.simulatedArounds) {
					int distToFire = agent.getDistToFire(buil);
					if (distToFire < distToZone)
						distToZone = distToFire;
				}
				fireZone.distToFire = distToZone;
			}
			Collections.sort(hibitorFireZones, zoneComparatorbydist);
			myZone = hibitorFireZones.get(0);
			if (myZone != null && myZone.emergency)
				unemploymentSituation(myZone);
		} else {
			for (FireZone fireZone : agent.fireZoneBuilder.modelZones) {
				double distToZone = Integer.MAX_VALUE;
				for (worldModel.Building buil : fireZone.simulatedArounds) {
					int dist = agent.getDistToFire(buil);
					if (dist < distToZone)
						distToZone = dist;
				}
				fireZone.distToFire = distToZone;
			}
			Collections.sort(agent.fireZoneBuilder.modelZones,
					zoneComparatorbydist);
			myZone = agent.fireZoneBuilder.modelZones.get(0);
			if (myZone != null && myZone.emergency)
				unemploymentSituation(myZone);
		}
	}

	private Comparator<FireBrigade> idComparator = new Comparator<FireBrigade>() {
		public int compare(FireBrigade a, FireBrigade b) {
			if (a.getID().getValue() > b.getID().getValue())
				return 1;
			if (a.getID().getValue() < b.getID().getValue())
				return -1;
			return 0;
		}
	};

	private Comparator<FireZone> zoneComparator = new Comparator<FireZone>() {
		public int compare(FireZone a, FireZone b) {
			if (a.value > b.value)
				return 1;
			if (a.value < b.value)
				return -1;
			return 0;
		}
	};

	private Comparator<FireZone> zoneComparatorbydist = new Comparator<FireZone>() {
		public int compare(FireZone a, FireZone b) {
			if (a.distToFire > b.distToFire)
				return 1;
			if (a.distToFire < b.distToFire)
				return -1;
			return 0;
		}
	};

	private int valueForFireZone(double value) {
		int[] arr = { 3, 6, 10, 15, 25 };
		for (int i = 0; i < arr.length; i++)
			if (value <= arr[i])
				return i;
		return arr.length;
	}

	// private boolean hasReachables(FireZone fz) {
	// for (worldModel.Building b : fz.ignitedBuilds)
	// if (agent.buildingReachability(b))
	// return true;
	// return false;
	// }

	private void selectMyZone(boolean isCalledByZoneChange)
			throws ActionCommandException {
		ArrayList<FireZone> sortedZone = new ArrayList<FireZone>();
		ArrayList<FireBrigade> fireBrigades = new ArrayList<FireBrigade>();
		ArrayList<FireZone> hibitorFireZones = new ArrayList<FireZone>();
		ArrayList<FireZone> otherZones = new ArrayList<FireZone>();
		if (agent.me().hasBuriedness)
			return;
		for (FireBrigade brigade : bFSForFire())
			if (!brigade.hasBuriedness)
				fireBrigades.add(brigade);
		myZone = null;
		for (FireZone fireZone : agent.fireZoneBuilder.modelZones) {
			fireZone.value = 0;
			fireZone.assignedWorkerNum = 0;
			for (worldModel.Building building : fireZone.buildings)
				fireZone.value += building.getGroundArea()
						/ agent.averageOfSurfaces;
			fireZone.value = valueForFireZone(fireZone.value);
			int dist = (int) Math.hypot(agent.getX() - fireZone.centerX,
					agent.getY() - fireZone.centerY);
			fireZone.value = fireZone.value * 4 + dist
					/ agent.worldModel.setRange();
		}
		for (FireZone fireZone : agent.fireZoneBuilder.modelZones) {
			if (fireZone.hibitor)
				hibitorFireZones.add(fireZone);
			else
				otherZones.add(fireZone);
		}

		for (FireBrigade FB : fireBrigades)
			FB.distToFire = new ArrayList<Double>();
		Collections.sort(fireBrigades, idComparator);
		boolean selectNearestHibitor = false;
		if (agent.bigMap) {
			Collections.sort(hibitorFireZones, zoneComparator);
			sortedZone.addAll(hibitorFireZones);
			Collections.sort(otherZones, zoneComparator);
			sortedZone.addAll(otherZones);
			for (FireZone fireZone : sortedZone) {
				for (FireBrigade fireB : fireBrigades) {
					double distToZone = Integer.MAX_VALUE;
					for (worldModel.Building buil : fireZone.simulatedAroundsWithSetGood) {
						if (((Double) Math.hypot(buil.getX() - fireB.getX(),
								buil.getY() - fireB.getY())) < distToZone)
							distToZone = ((Double) Math.hypot(buil.getX()
									- fireB.getX(), buil.getY() - fireB.getY()));
					}
					fireB.distToFire.add(distToZone);
				}
			}
			done: for (int g = 0; g < sortedZone.size(); g++) {
				for (int i = 0; i < sortedZone.get(g).workersNum; i++) {
					double min = -1;
					FireBrigade f = null;
					for (int j = 0; j < fireBrigades.size(); j++)
						if (fireBrigades.get(j).distToFire.get(g) < min
								|| min == -1) {
							min = fireBrigades.get(j).distToFire.get(g);
							f = fireBrigades.get(j);
						}
					if (agent.me().getID().getValue() == f.getID().getValue()) {
						myZone = sortedZone.get(g);
						if (myZone != null && !isCalledByZoneChange
								&& myZone.emergency) {
							unemploymentSituation(myZone);
						}
						if (myZone.hibitor)
							selectNearestHibitor = true;
					}
					if (f.getID().getValue() != agent.me().getID().getValue()
							|| !selectNearestHibitor) {
						sortedZone.get(g).assignedWorkerNum++;
					}
					fireBrigades.remove(f);
					if (fireBrigades.size() == 0)
						break done;
				}
			}
			if (selectNearestHibitor) {
				double minDist = Integer.MAX_VALUE;
				int save = 0;
				for (int i = 0; i < agent.me().distToFire.size(); i++)
					if (agent.me().distToFire.get(i) < minDist
							&& sortedZone.get(i).hibitor) {
						minDist = agent.me().distToFire.get(i);
						save = i;
					}
				sortedZone.get(save).assignedWorkerNum++;
				myZone = sortedZone.get(save);
				if (myZone != null && !isCalledByZoneChange && myZone.emergency) {
					unemploymentSituation(myZone);
				}
				return;
			}
			if (myZone != null)
				return;
		} else {
			Collections.sort(hibitorFireZones, zoneComparator);
			sortedZone.addAll(hibitorFireZones);
			Collections.sort(otherZones, zoneComparator);
			sortedZone.addAll(otherZones);

			for (FireZone fireZone : sortedZone) {
				for (FireBrigade fireB : fireBrigades) {
					double distToZone = Integer.MAX_VALUE;
					for (worldModel.Building buil : fireZone.simulatedAroundsWithSetGood) {
						if (((Double) Math.hypot(buil.getX() - fireB.getX(),
								buil.getY() - fireB.getY())) < distToZone)
							distToZone = ((Double) Math.hypot(buil.getX()
									- fireB.getX(), buil.getY() - fireB.getY()));
					}
					fireB.distToFire.add(distToZone);
				}
			}
			done: for (int g = 0; g < sortedZone.size(); g++) {
				for (int i = 0; i < sortedZone.get(g).workersNum + 2; i++) {
					double min = Integer.MAX_VALUE;
					FireBrigade f = null;
					for (int j = 0; j < fireBrigades.size(); j++)
						if (fireBrigades.get(j).distToFire.get(g) < min) {
							min = fireBrigades.get(j).distToFire.get(g);
							f = fireBrigades.get(j);
						}
					if (agent.me().getID().getValue() == f.getID().getValue()) {
						myZone = sortedZone.get(g);
						if (myZone != null && !isCalledByZoneChange
								&& myZone.emergency)
							unemploymentSituation(myZone);
						if (myZone.hibitor)
							selectNearestHibitor = true;
					}
					fireBrigades.remove(f);
					if (f.getID().getValue() == f.getID().getValue()
							&& !selectNearestHibitor)
						sortedZone.get(g).assignedWorkerNum++;
					if (fireBrigades.size() == 0)
						break done;
				}
			}
			if (selectNearestHibitor) {
				double minDist = Integer.MAX_VALUE;
				int save = 0;
				for (int i = 0; i < agent.me().distToFire.size(); i++)
					if (agent.me().distToFire.get(i) < minDist
							&& sortedZone.get(i).hibitor) {
						minDist = agent.me().distToFire.get(i);
						save = i;
					}
				sortedZone.get(save).assignedWorkerNum++;
				myZone = sortedZone.get(save);
				if (myZone != null && myZone.emergency && !isCalledByZoneChange)
					unemploymentSituation(myZone);
				return;
			}
		}
		if (myZone != null)
			return;
		FireZone minZone = null;
		double minDist = Integer.MAX_VALUE, dist;
		for (FireZone z : agent.fireZoneBuilder.modelZones) {
			dist = Math.hypot((agent.me()).getX() - z.centerX,
					(agent.me()).getY() - z.centerY);
			if (dist <= minDist) {
				minDist = dist;
				minZone = z;
			}
		}
		myZone = minZone;
		if (myZone != null && !isCalledByZoneChange && myZone.emergency)
			unemploymentSituation(myZone);
	}

	@SuppressWarnings("unused")
	private int distToFire(int v) {
		int[] arr = { 10, 20, 30, 40, 50, 60 };
		for (int i = 0; i < arr.length; i++)
			if (v <= arr[i])
				return i;

		return arr.length;
	}

	@SuppressWarnings("static-access")
	private boolean canExtinguish(worldModel.Building target) {
		// agent.log("MaxDis: " + agent.maxDistanceExtinguish);
		// agent.log("Dist : "
		// + Mathematic.getDistance(target.getX(), target.getY(),
		// (agent.me()).getX(), (agent.me()).getY()));
		return Mathematic.getDistance(target.getX(), target.getY(),
				(agent.me()).getX(), (agent.me()).getY()) < agent.maxDistanceExtinguish;
	}

	private void setValueForBuildings(worldModel.Building build) {
		int w5 = 0;
		if (beingExtinguished != null
				&& build.getID().getValue() == beingExtinguished.getID()
						.getValue())
			w5 = -5;
		build.value = agent.getDistToFire(build);/*
												 * w1 (build.getGroundArea() *
												 * build.getFloors() /
												 * agent.maxVolumeOfAllBuildings
												 * ) + w2 *
												 * distToFire(agent.getDistToFire
												 * (build)) + w3
												 * (valueForNotIgnited
												 * (build.nearForSimulator
												 * .size())) + w4 build.volume +
												 * w5;
												 */

	}

	// private int valueForNotIgnited(int v) {
	// int[] arr = { 0, 1, 5, 10, 15, 20, 30, 40, 70 };
	// for (int i = 0; i < arr.length; i++)
	// if (v <= arr[i])
	// return i;
	// return arr.length;
	// }

	private void setValueForAroundBuildings() {
		for (FireZone fireZone : agent.fireZoneBuilder.modelZones)
			for (worldModel.Building build : fireZone.simulatedArounds) {
				if (agent.buildingReachability(build)) {
					simulator(build);
					setVolumeSimulator(build);
					setValueForBuildings(build);
				}
			}
	}

	private worldModel.Building tar1 = null;

	public void checkUnemploymentExtinguish(boolean checkBuildingReachability)
			throws ActionCommandException {
		worldModel.Building buil1 = null;
		int maxLast = 0;
		for (StandardEntity e : agent.worldModel.getAreasInRange(
				agent.getMyPos(), agent.maxDistanceExtinguish)) {
			if (e instanceof rescuecore2.standard.entities.Building) {
				worldModel.Building build = ((worldModel.Building) (((rescuecore2.standard.entities.Building) e).area));
				if (build.stFire > 0
						&& agent.canExtinguish(build)
						&& (!agent.buildingReachability(build) || !checkBuildingReachability)
						&& build.getLTS() > maxLast
						&& agent.hasBeenRecentlySeen(build)) {
					maxLast = build.getLTS();
					buil1 = build;
				}
			}
		}
		if (buil1 != null) {
			agent.extinguish(buil1.getID(), agent.maxPower);
		}
	}

	private void unemploymentSituation(FireZone FZ)
			throws ActionCommandException {
		agent.lastInNoHear = agent.time;
		checkUnemploymentExtinguish(true);
		int maxheard = 0;
		worldModel.Building tar = null;
		for (worldModel.Building building : FZ.buildings)
			if (agent.unreachableAndIgnitedBuildings.contains(building)
					&& building.getLTS() > maxheard) {
				maxheard = building.getLTS();
				tar = building;
			}
		if (tar1 == null || tar1.stFire == 0 || !FZ.buildings.contains(tar1))
			tar1 = tar;
		if (tar1 != null) {
			ArrayList<Area> path = agent.unEmploymentSituationPath(tar1);
			if (path != null && path.size() != 0) {
				worldModel.Area target = path.get(path.size() - 1);
				ArrayList<EntityID> pathEntityID = new ArrayList<>();
				for (worldModel.Area a : path)
					pathEntityID.add(a.getID());
				// agent.log("in unemployment : move : " + path);
				agent.move(pathEntityID, target.getX(), target.getY(), false);
			}
		}
	}

}
