package agent;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;

import rescuecore2.standard.entities.FireBrigade;
import shapeReconstruction.AlphaShape;
import shapeReconstruction.KOrderAlphaShapes;
import shapeReconstruction.Point;
import worldModel.Area;
import worldModel.Building;
import worldModel.WorldModel;

public class FireZone {
	public int tedad = 0;
	public int fireZoneNum = -1;
	public int centerX = 0;
	public int centerY = 0;
	public int workersNum;
	public boolean hibitor = false;
	public double value = 0;
	public double valueForWorkwerNum = 0;
	public ArrayList<Building> buildings = new ArrayList<>();
	public boolean extinguish = false;
	public HashSet<GroupForFire> fireGroups = new HashSet<>();
	public ArrayList<Building> ignitedBuilds = new ArrayList<>();
	public HashSet<FireBrigade> fireAgents = new HashSet<>();
	public boolean emergency = false;
	public ArrayList<Building> simulatedArounds = new ArrayList<>();
	public ArrayList<Building> simulatedAroundsWithSetGood = new ArrayList<Building>();
	public ArrayList<Building> realArounds = new ArrayList<Building>();
	public ArrayList<Building> realAroundsWithSetGood = new ArrayList<Building>();
	public HashSet<Building> allArounds = new HashSet<Building>();
	public HashSet<Building> allAroundsWithSetGood = new HashSet<Building>();

	public int maxInfo = Integer.MIN_VALUE;
	public ArrayList<FireBrigade> fireBrigadesOfFireZone = new ArrayList<FireBrigade>();
	// variables for nohear
	boolean extinguishedByMe = false;
	double distToFire = 0.00;
	int assignedWorkerNum = 0;
	public boolean assigned;
	public int surface = 0;
	public int lastCycleSurface = 0;
	
	private HashMap<Building, Integer> nearArounds = null;

	public FireZone(int num) {
		this.fireZoneNum = num;
	}

	public FireZone() {
	}

	public String toString() {
		String s = "";
		// for (Building b : this.buildings) {
		// s = s + b.id + " ";
		// }
		// s += "; ";
		return s;
	}

	private HashSet<Point> buildToPoint(Collection<Building> buildings) {
		HashSet<Point> buidingPoints = new HashSet<Point>();
		if (buildings.size() < 50) {
			for (worldModel.Building build : buildings) {
				for (int i = 0; i < build.serverArea.getApexList().length; i += 2) {
					Point buildingPoint = new Point(
							build.serverArea.getApexList()[i],
							build.serverArea.getApexList()[i + 1], build);
					if (!buidingPoints.contains(buildingPoint))
						buidingPoints.add(buildingPoint);
				}
			}

		} else {
			for (worldModel.Building build : buildings) {
				Point buildingPoint = new Point(build.getX(), build.getY(),
						build);
				if (!buidingPoints.contains(buildingPoint))
					buidingPoints.add(buildingPoint);
			}
		}
		return buidingPoints;
	}

	public void reconstructedBuildings(Collection<Building> buildings) {
		reconstructedBuildings(buildToPoint(buildings), 0, 80000);
	}

	private ArrayList<Building> ignitedBuildsWith8Fireness() {
		ArrayList<Building> fireness8 = new ArrayList<Building>();
		ArrayList<Building> copy = new ArrayList<Building>();

		copy.addAll(buildings);
		copy.removeAll(ignitedBuilds);
		fireness8.addAll(ignitedBuilds);

		for (Building building : copy) {
			if (building.fireness() == 8) {
				fireness8.add(building);
			}
		}
		return fireness8;
	}

	public void reconstructedBuildings() {
		reconstructedBuildings(buildToPoint(ignitedBuildsWith8Fireness()), 0,
				80000);
		remove8Fireness();
		if (simulatedArounds.size() == 0) {
			simulatedArounds.addAll(ignitedBuilds);
		}
	}

	private void remove8Fireness() {
		ArrayList<Building> toRemove = new ArrayList<Building>();
		for (Building building : simulatedArounds) {
			if (building.fireness() == 8) {
				toRemove.add(building);
			}
		}
		simulatedArounds.removeAll(toRemove);

	}

	private void reconstructedBuildings(HashSet<Point> points, int k, double r) {
		simulatedArounds = new ArrayList<>();
		ArrayList<worldModel.Building> finalBuilding = new ArrayList<worldModel.Building>();
		AlphaShape alphaS = KOrderAlphaShapes.bruteForce(points, k, r);
		if (alphaS != null) {
			for (shapeReconstruction.Edge e : alphaS.edges) {
				if (!finalBuilding.contains(e.start.building))
					finalBuilding.add(e.start.building);
				if (!finalBuilding.contains(e.end.building))
					finalBuilding.add(e.end.building);
			}

			simulatedArounds.addAll(finalBuilding);
		}
		if (finalBuilding.size() == 0 && ignitedBuilds.size() == 1)
			simulatedArounds.addAll(ignitedBuilds);
	}

	public void setGoodArounds(WorldModel worldModel, int numMidst,
			int groundMidst) {
		HashSet<Building> copyOfArounds = new HashSet<Building>();
		copyOfArounds.addAll(simulatedArounds);
		simulatedAroundsWithSetGood.clear();

		if (ignitedBuilds.size() < 10) {
			simulatedAroundsWithSetGood.addAll(simulatedArounds);
			return;
		}

		nearArounds = new HashMap<Building, Integer>();
		for (Building build : simulatedArounds) {
			int sum = 0;
			build.nearNotIgnitedBuildings = new ArrayList<Building>();

			for (int i : build.areasInRange) {
				Area e = worldModel.areas.get(i);
				Building bu = null;
				if (e instanceof Building) {
					bu = ((Building) e);
					if (bu.stFire == 0 && bu.fireness() <= 0
							&& bu.isIgnitable()) {
						sum += bu.getGroundArea();
						build.nearNotIgnitedBuildings.add(bu);
					}
				}
			}
			nearArounds.put(build, sum);
		}

		// remove kardane namonaseb ha
		for (Building building : nearArounds.keySet()) {
			if (isGoodToRemove(building, nearArounds.get(building), worldModel,
					numMidst, groundMidst))
				copyOfArounds.remove(building);
		}

		simulatedAroundsWithSetGood.addAll(copyOfArounds);

		Comparator<Building> aroundComparator = new Comparator<Building>() {
			public int compare(Building b1, Building b2) {
				if (nearArounds.get(b1) < nearArounds.get(b2))
					return 1;
				if (nearArounds.get(b2) < nearArounds.get(b1))
					return -1;
				if (b2.getGroundArea() < b1.getGroundArea())
					return 1;
				if (b1.getGroundArea() < b2.getGroundArea())
					return -1;
				return 0;
			}
		};

		Collections.sort(simulatedAroundsWithSetGood, aroundComparator);
		Collections.sort(simulatedArounds, aroundComparator);

		if (simulatedAroundsWithSetGood.size() == 0)
			simulatedAroundsWithSetGood = simulatedArounds;
	}

	private boolean isGoodToRemove(Building building,
			int nearNotIgnitedBuildingsSurface, WorldModel worldModel,
			int numMidst, int groundMidst) {
		if (building.nearNotIgnitedBuildings.size() == 0)
			return true;

		if (building.nearNotIgnitedBuildings.size() > (numMidst * 2 / 5)
				|| nearNotIgnitedBuildingsSurface > (groundMidst * 2 / 5))
			return false;

		int sum = 0;
		int num = 0;
		for (Building build : building.nearNotIgnitedBuildings) {
			for (int i : build.areasInRange) {
				Area e = worldModel.areas.get(i);
				Building bu = null;
				if (e instanceof Building) {
					bu = ((Building) e);
					if (bu.stFire == 0 && bu.fireness() <= 0) {
						num++;
						sum += bu.getGroundArea();
					}
				}
			}
		}
		int sabetG = (int) (building.nearNotIgnitedBuildings.size()
				* groundMidst * 0.75);
		int sabetN = (int) (building.nearNotIgnitedBuildings.size() * numMidst * 0.75);

		if (sum < sabetG && num < sabetN)
			return true;

		return false;
	}

	public void setZoneCenter() {
		int allX = 0, allY = 0;
		for (Building building : buildings) {
			allX += building.getX();
			allY += building.getY();
		}
		centerX = allX / buildings.size();
		centerY = allY / buildings.size();
	}

	public void setZoneSurface(double averageOfSurfaces) {
		for (Building building : ignitedBuilds) {
			if (!building.isSimulatedForFire)
				valueForWorkwerNum += building.getGroundArea()
						/ averageOfSurfaces;
		}
	}
}
