package agent;

import java.util.ArrayList;
import java.util.Random;

import worldModel.Building;

import com.vividsolutions.jts.geom.Coordinate;

public class Point {

	private double x = 0;
	private double y = 0;
	private int cluster_number = 0;
	public Building building;
	public worldModel.Area area;

	public Point(double x, double y) {
		this.setX(x);
		this.setY(y);
	}

	public void setX(double x) {
		this.x = x;
	}

	public double getX() {
		return this.x;
	}

	public void setY(double y) {
		this.y = y;
	}

	public double getY() {
		return this.y;
	}

	public void setCluster(int n) {
		this.cluster_number = n;
	}

	// Calculates the distance between two points.
	protected static double distance(Point p, Point centroid) {
		return Math.sqrt(Math.pow((centroid.getY() - p.getY()), 2)
				+ Math.pow((centroid.getX() - p.getX()), 2));
	}

	// Creates random point
	protected static Point createRandomPoint(int minX, int maxX, int maxY,
			int minY, ArrayList<Building> buildings,
			ArrayList<Point> centroids, int index) {
		Random r = new Random();
		r.setSeed(index * centroids.size());
		double x = minX + (maxX - minX) * r.nextGaussian();
		double y = minY + (maxY - minY) * r.nextGaussian();
		double minDist = Integer.MAX_VALUE;
		Building neaBuilding = null;
		done: for (Building b : buildings)
			if (b.distance(new Coordinate(x, y)) < minDist) {
				for (Point p : centroids) {
					if (p.getX() == b.getX() && p.getY() == b.getY())
						continue done;

				}
				minDist = b.distance(new Coordinate(x, y));
				neaBuilding = b;
			}
		Point p = new Point(neaBuilding.getX(), neaBuilding.getY());
		p.building = neaBuilding;
		return p;
	}

	protected static ArrayList<Point> createRandomPoints(int minX, int maxX,
			int maxY, int minY, int number, ArrayList<Building> buildings) {
		ArrayList<Point> points = new ArrayList<Point>(number);
		for (int i = 0; i < number; i++) {
			// points.add(createRandomPoint(minX, maxX, maxX, minY, buildings));
		}
		return points;
	}
}