package agent;

import geometry.Mathematic;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.EnumSet;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map.Entry;
import java.util.TreeSet;

import radar.Package.HeaderType;
import rescuecore2.misc.geometry.GeometryTools2D;
import rescuecore2.misc.geometry.Line2D;
import rescuecore2.misc.geometry.Point2D;
import rescuecore2.misc.geometry.Vector2D;
import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.Blockade;
import rescuecore2.standard.entities.Civilian;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.PoliceForce;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.standard.messages.StandardMessageURN;
import rescuecore2.worldmodel.Entity;
import rescuecore2.worldmodel.EntityID;
import worldModel.Area;
import worldModel.Building;
import worldModel.Entrance;
import worldModel.GeometryTools;
import worldModel.Road;

import com.vividsolutions.jts.geom.Coordinate;
import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.geom.GeometryFactory;
import com.vividsolutions.jts.geom.LineSegment;

public class PoliceForceAgent extends ThinkAgent<PoliceForce> {

	int nearCVPos = -1;
	int nearTrapped = -1;
	int nearRefuge = -1;
	worldModel.Refuge nearRefugeForFire = null;
	worldModel.Area nearAreaForFire = null;
	int minimumClear = 1000;
	boolean checkForArea = false;
	boolean checkForRefuge = false;
	boolean haveReachableRefuge = false;
	private int clearDist;
	private int clearRad;
	private int REPAIR_RATE_KEY;
	protected ArrayList<Integer> clearedIDs = new ArrayList<Integer>();
	public static final int MAX_DIST_FOR_HELP = 30000;

	ArrayList<Building> aroundOuterBuilding = new ArrayList<Building>();
	ArrayList<Area> path = new ArrayList<Area>();

	public Area start;
	private worldModel.Blockade lastBlock = null;

	private double REPAIR_COST_FACTOR;

	@SuppressWarnings("unused")
	private double REPAIR_DISTANCE_KEY;
	@SuppressWarnings("unused")
	private double REPAIR_RAD_KEY;

	protected void postConnect() {
		super.postConnect();
		clearDist = config.getIntValue("clear.repair.distance");
		REPAIR_RAD_KEY = config.getIntValue("clear.repair.rad");
		REPAIR_DISTANCE_KEY = config.getIntValue("clear.repair.distance");
		REPAIR_RATE_KEY = config.getIntValue("clear.repair.rate");
		REPAIR_COST_FACTOR = 0.000001; // config.getValue(""") //;
		clearRad = config.getIntValue("clear.repair.rad");
	}

	protected EnumSet<StandardEntityURN> getRequestedEntityURNsEnum() {
		return EnumSet.of(StandardEntityURN.POLICE_FORCE);
	}

	protected void sendInfo() {
		radar.Package p = new radar.Package(worldModel);
		p.addHeader(HeaderType.Info);
		speak(time, HeaderType.Info, p.send());
	}

	// private int distToFire(worldModel.Building building) {
	// ArrayList<Area> visionAreas = new ArrayList<Area>();
	// visionAreas.addAll(building.visionRoads.keySet());
	// visionAreas.addAll(building.visionBuildings.keySet());
	// int minDist = Integer.MAX_VALUE;
	// for (Area a : visionAreas)
	// if (a.distFromeSelfWOB < minDist)
	// minDist = a.distFromeSelfWOB;
	//
	// return minDist;
	// }
	//
	// private void logs1() {
	// log("center for police: " + centerForPolice);
	// log("MeID: " + me().getID().getValue());
	// log("MyZone: ");
	// if (noCommi) {
	// String s = " ";
	// for (Building b : myHum().noCommiSectorZone.buildings) {
	// s += b.getID().getValue() + " ";
	// }
	// log("myZone:" + s);
	// }
	// // String s = null;
	// // for (Building b : me().sectorZone.buildings) {
	// // s += " " + b.getID();
	// // }
	// // log(s);
	// // s = "";
	// // for (SectorZone sz : sectorZones) {
	// // for (Building b : sz.buildings) {
	// // s += " " + b.id;
	// // }
	// // s += "; ";
	// // }
	// // log("all sectorzones: " + s);
	// if (getMyPos() instanceof Road)
	// log("My Position: " + getMyPos() + " instanceof ROAD");
	// else if (getMyPos() instanceof Building)
	// log("My Position: " + getMyPos() + " instance of BUILDING");
	// log("isBigMap = " + bigMap);
	// log("MapType = " + worldModel.map);
	// log("My Damage: " + me().getDamage());
	// log("My Buriedness: " + me().getBuriedness());
	// log("My DeadTime: " + myHum().deadtime);
	// if (me().refugeTarget != null && !addToClearedIDs(me().refugeTarget))
	// log("refuge target: " + me().refugeTarget);
	// else
	// log("null refuge target");
	// if (me().fireTask != null)
	// log("Fire Task: " + me().fireTask.agentPart + " "
	// + me().fireTask.firedBuildingPart + "head or tail : "
	// + me().fireTask.headOrTail);
	// else
	// log("null Fire Task");
	// if (me().stuckTarget != null)
	// log("stuck target: " + me().stuckTarget);
	// else
	// log("null stuck target");
	// }
	//
	// // @SuppressWarnings("unused")
	//

	// private void logs2() {
	// // -Xss10m -XX:+AggressiveHeap -Xmx3G -Xms3G
	// log("LOGS: -->");
	// log("================================================================");
	// String str1 = "";
	// for (Building i : worldModel.buildings) {
	// if (i.stFire == 1)
	// str1 = str1 + i.getID().getValue() + " ";
	// }
	// log("buildings with stFire == 1 " + str1);
	// log("Around Buildings & ModelZones");
	// if (fireZoneBuilder.modelZones == null)
	// log("ModelZones & Around Buildings is null");
	// else if (fireZoneBuilder.modelZones.size() == 0)
	// log(" ModelZones & Around Buildings has nothing");
	// else {
	// String str2 = "";
	// for (FireZone i : fireZoneBuilder.modelZones) {
	// for (Building j : i.buildings) {
	// str2 = str2 + j.getID().getValue() + " ";
	// }
	// str2 = str2 + " ; ";
	// }
	// log(" ModelZones: " + str2);
	// }
	// for (FireZone i : fireZoneBuilder.modelZones) {
	// String aroundswsg = "", arounds = "";
	// for (Building j : i.simulatedAroundsWithSetGood) {
	// aroundswsg += " " + j.getID().getValue();
	// }
	// for (Building j : i.simulatedArounds) {
	// arounds += j;
	// }
	// log(" arounds with set good: " + aroundswsg);
	// log(" arounds wo wsg: " + arounds);
	// }
	// log("================================================================");
	// log("<-- :LOGS");
	// }

	protected void fireTaskNoHearComputations() {

		if (me().fireTask != null && me().fireTask.isForSearchAroundZone)
			return;

		// if (me().fireTask != null)
		// log("is for search around zone: "
		// + me().fireTask.isForSearchAroundZone);
		// log(" fireTaskNoHearComputations");
		me().fireTask = null;
		me().realFireTask = null;
		boolean shouldFireTask = false;
		Building onFire = null;
		FireZone myFireZone = null;
		ArrayList<Building> zoneToFireTask = new ArrayList<Building>();
		zoneToFireTask.addAll(me().noCommiSectorZone.buildings); // 0_o
		for (Building b : zoneToFireTask)
			if (b.stFire > 0) {
				onFire = b;
				shouldFireTask = true;
				break;
			}

		if (!shouldFireTask)
			Done: for (Building b : zoneToFireTask)
				for (Area a : b.nearAreas50000) {
					if (a instanceof Building) {
						if (((Building) a).stFire > 0) {
							onFire = (Building) a;
							shouldFireTask = true;
							break Done;
						}

						if (((Building) a).fireness() > 0) {
							for (FireZone fZ : fireZoneBuilder.modelZones)
								if (fZ.buildings.contains(a)) {
									onFire = (Building) a;
									shouldFireTask = true;
									break Done;
								}

						}
					}
				}
		if (shouldFireTask) {
			for (FireZone fz : fireZoneBuilder.modelZones)
				if (fz.buildings.contains(onFire)) {
					myFireZone = fz;
				}
		}
		if (myFireZone != null) {
			int minDist = Integer.MAX_VALUE;
			Building bestBuilding = null;
			for (Building b : myFireZone.simulatedAroundsWithSetGood)
				if (b.distance(getMyPos()) < minDist) {
					minDist = (int) b.distance(getMyPos());
					bestBuilding = b;
				}
			me().fireTask = new FireTask(bestBuilding, bestBuilding, 1, false);
			me().realFireTask = new FireTask(me().fireTask.agentPart,
					me().fireTask.firedBuildingPart, me().fireTask.headOrTail,
					false);
		}
		// log("firetask: " + me().fireTask);
	}

	private ArrayList<Area> doneSearchAroundZoneAreas = new ArrayList<Area>();
	private ArrayList<FireZone> needSearchAround = new ArrayList<FireZone>();

	private boolean searchAroundZoneComputations() {
		// lastNeedSearchAroundZone.clear();
		// lastNeedSearchAroundZone.addAll(needSearchAround);
		done: for (FireZone fZ : fireZoneBuilder.lastModelZones) {
			for (Building b : fZ.buildings)
				if (b.stFire == 1) {
					continue done;
				}
			needSearchAround.add(fZ);
		}

		ArrayList<FireZone> toRemove = new ArrayList<FireZone>();
		done: for (FireZone nSAFZ : needSearchAround) {
			for (Building b : nSAFZ.buildings) {
				if (b.fireZoneNum != -1) {
					toRemove.add(nSAFZ);
					continue done;
				}
			}
		}

		done: for (FireZone fz : needSearchAround) {
			for (Area a : doneSearchAroundZoneAreas) {
				if (fz.buildings.contains(a)) {
					toRemove.add(fz);
					continue done;
				}
			}
		}

		needSearchAround.removeAll(toRemove);
		if (needSearchAround.size() > 0)
			return true;
		return false;
	}

	// private boolean buildingLTSSmallerThanTimeOfStart() {
	// for (Building b : ((PoliceForce) me()).searchAroundZoneBuilds)
	// if (b.getLTS() < timeOfStart)
	// return true;
	// return false;
	// }
	//
	// int timeOfStart = -1;

	private void setSearchAroundZoneForMySelf() {
		// log("search around zone computation: " +
		// searchAroundZoneComputations());
		if (!searchAroundZoneComputations()
				|| (me().fireTask != null && me().fireTask.isForSearchAroundZone))
			return;

		me().fireTask = null;
		FireZone zoneToSearchAround = null;
		Done1: for (FireZone fz : needSearchAround)
			for (Building b : fz.buildings)
				if ((me().noCommiSectorZone.buildings.contains(b))) {
					zoneToSearchAround = fz;
					break Done1;
				}

		if (zoneToSearchAround == null) {
			HashSet<Area> near50000MyZone = new HashSet<Area>();
			for (Building b : me().noCommiSectorZone.buildings)
				near50000MyZone.addAll(b.nearAreas50000);

			Done2: for (FireZone fz : needSearchAround)
				for (Building b : fz.buildings)
					if (near50000MyZone.contains(b)) {
						zoneToSearchAround = fz;
						break Done2;
					}
		}
		if (zoneToSearchAround != null) {
			Building b = getBestBuildingForSearchArondZone(zoneToSearchAround);
			me().fireTask = new FireTask(b, b, true);
			((PoliceForce) me()).searchAroundZoneBuilds.clear();
			for (Area a : b.nearAreas50000)
				// allright?
				if (a instanceof Building)
					((PoliceForce) me()).searchAroundZoneBuilds
							.add((Building) a);
		}

	}

	protected void noHearPolice() throws ActionCommandException {
		clearToRefuge();
		helpNearStuckAgents(worldModel.maxDistanceView);
		fireTaskNoHearComputations();
		doFireTask();
		setSearchAroundZoneForMySelf();
		SearchAroundZone();
		CheckForSearchAroundTemperature();
		clearTargets();
		helpNearStuckCVs(worldModel.maxDistanceView);
		helpMyZoneCVs();
		search();
	}

	int startOfSearchAroundTemperature = 0;
	ArrayList<Building> buildings = new ArrayList<Building>();

	protected void SearchAroundTemperature(Building buil)
			throws ActionCommandException {
		int minLTS;
		if (searchAround == null) {
			buildings.clear();
			buildings.addAll(buil.nearBuildings);
			searchAround = buil;
		}
		if (startOfSearchAroundTemperature == 0) {
			startOfSearchAroundTemperature = time;
		}

		for (EntityID id : worldModel.changeSet.getChangedEntities()) {
			if (((worldModel.getEntity(id) instanceof rescuecore2.standard.entities.Building))) {
				buildings.remove(worldModel.getArea(id));
			}
		}
		minLTS = getMinLTS(buildings);
		if (minLTS < startOfSearchAroundTemperature) {
			searchFireTemp(buildings);
		}
		if (minLTS >= startOfSearchAroundTemperature) {
			searchAround = null;
			startOfSearchAroundTemperature = 0;
			buildings = new ArrayList<Building>();
		}
	}

	protected boolean InRangestFire(Building bui) {
		boolean reasalt = false;
		ArrayList<Building> buildings = new ArrayList<Building>();
		buildings.addAll(bui.nearBuildings);
		for (Building building : buildings) {
			if (building.fireness() >= 1) {
				reasalt = true;
			}
		}
		for (EntityID id : worldModel.changeSet.getChangedEntities()) {
			if (worldModel.getEntity(id) instanceof rescuecore2.standard.entities.Building) {
				if (((Building) worldModel.getArea(id)).stFire > 0) {
					reasalt = true;
				}
			}
		}
		if (reasalt) {
			searchAround = null;
			startOfSearchAroundTemperature = 0;
		}
		return reasalt;
	}

	Building searchAround = null;

	private void CheckForSearchAroundTemperature()
			throws ActionCommandException {
		if (me().fireTask == null) {
			for (EntityID id : worldModel.changeSet.getChangedEntities()) {
				if (((worldModel.getEntity(id) instanceof rescuecore2.standard.entities.Building)
						&& ((Building) worldModel.getArea(id))
								.isTemperatureDefined()
						&& ((Building) worldModel.getArea(id)).getTemperature() > 0
						&& ((Building) worldModel.getArea(id)).fireness() <= 0 && !InRangestFire((Building) worldModel
							.getArea(id)))
						|| (searchAround != null && !InRangestFire(searchAround))) {
					if (searchAround == null) {
						SearchAroundTemperature(((Building) worldModel
								.getArea(id)));
					}
					if (searchAround != null)
						SearchAroundTemperature(searchAround);
				}
			}
		}
	}

	protected void act() throws ActionCommandException {
		if (time < 3 || me().hasBuriedness)
			rest();

		setIamOnFire();

		updateDistFromSelfWOB();
		updateLastBlock();

		for (EntityID eID : worldModel.changeSet.getChangedEntities()) {
			Entity e = worldModel.getEntity(eID);
			if (e instanceof rescuecore2.standard.entities.Area) {
				Area area = ((rescuecore2.standard.entities.Area) e).area;
				addToClearedIDs(area);
			}
		}

		fillSectorZoneAreas();

		if (noCommi)
			for (EntityID eID : worldModel.changeSet.getChangedEntities()) {
				if (worldModel.getEntity(eID) instanceof Agent) {
					Human h = (Human) worldModel.getEntity(eID);
					for (worldModel.Blockade b : worldModel.getArea(
							h.getPosition()).getBlockades()) {
						Coordinate c = new Coordinate(h.getX(), h.getY());
						if (!b.mainShape.contains(GeometryTools
								.coordToGeometry(c,
										worldModel.getTrafficSimulator().geom)))
							trapped.remove(h.getID().getValue());
					}
				}
			}
		if (noCommi || lowCommi) {
			if (strategy == NoCommiStrategy.TURNING)
				noCommiTurningStrategy();
			else
				noHearPolice();
		}

		// Center tasks
		clearRefugeTarget();
		helpNearStuckAgents(MAX_DIST_FOR_HELP);
		doFireTask();
		SearchAroundZone();
		CheckForSearchAroundTemperature();
		clearStuckAgents();
		helpNearStuckCVs(worldModel.maxDistanceView);
		helpMyZoneCVs();
		search();
	}

	private void noCommiTurningStrategy() throws ActionCommandException {
		if (noCommi || lowCommi) {
			SectorZone firstZone = myHum().noCommiSectorZone;
			while (true) {
				if (myHum().noCommiSectorZone.originalOwner.firstPosition instanceof Building
						|| myHum().noCommiSectorZone.originalOwner == myHum()) {
					noHearPolice();
				}
				myHum().noCommisectorZoneNum = (myHum().noCommisectorZoneNum + 1)
						% noHearSectorZones.size();
				myHum().noCommiSectorZone = noHearSectorZones
						.get(myHum().noCommisectorZoneNum);
				if (myHum().noCommiSectorZone == firstZone)
					break;
			}
		}
	}

	private void helpMyZoneCVs() throws ActionCommandException {
		ArrayList<Civilian> myZoneCVs = new ArrayList<Civilian>();
		for (Civilian cv : worldModel.getCivilians()) {
			if (!cv.isPositionDefined())
				continue;
			Entity e = worldModel.getEntity(cv.getPosition());
			if (!(e instanceof Area))
				continue;
			Area a = (Area) e;
			if (!(a instanceof Building))
				continue;
			if (a instanceof Building && ((Building) a).isOnFire())
				continue;

			if (!a.canBeVisited)
				continue;

			if (myHum().sectorZone.buildings.contains(a) && !addToClearedIDs(a))
				myZoneCVs.add(cv);
		}
		int minDist = Integer.MAX_VALUE;
		Civilian nearestCV = null;
		for (Civilian cv : myZoneCVs) {
			int dist = worldModel.getArea(cv.getPosition()).distFromeSelfWOB;
			if (minDist > dist) {
				nearestCV = cv;
				minDist = dist;
			}
		}
		if (nearestCV != null) {
			clearMyPosAgents(worldModel.getArea(nearestCV.getPosition()), true);
		}
	}

	private void SearchAroundFireZone() throws ActionCommandException {
		if (me().fireTask == null
				|| fireTaskFireZoneBuilder((Building) me().realFireTask.firedBuildingPart) == null
				|| lowCommi || noCommi)
			return;
		HashSet<Building> needToSearch = new HashSet<Building>();
		// log("arr::" + aroundOuterBuilding);
		for (Building b : aroundOuterBuilding) {
			// log("b::" + b.nearNotIgnitedBuildings);
			if (b.nearNotIgnitedBuildings != null
					&& b.nearNotIgnitedBuildings.size() > 0)
				needToSearch.addAll(b.nearNotIgnitedBuildings);
			else {
				for (Building a : b.nearBuildings)
					if (a.stFire == 0)
						needToSearch.add(a);
			}
		}
		// log("neady::" + needToSearch);
		// log("real::" + (Building) me().realFireTask.firedBuildingPart);
		needToSearch
				.removeAll((fireTaskFireZoneBuilder((Building) me().realFireTask.firedBuildingPart)).buildings);
		ArrayList<Building> needToSearch2 = new ArrayList<Building>();
		needToSearch2.addAll(needToSearch);
		moveToSee(needToSearch2, getMinLTS(needToSearch2));
	}

	private void SearchAroundZone() throws ActionCommandException {
		if (me().fireTask == null || !me().fireTask.isForSearchAroundZone)
			return;

		// log("Buildings to search Around: " + me().searchAroundZoneBuilds);
		for (EntityID changed : worldModel.changeSet.getChangedEntities()) {
			Entity e = worldModel.getEntity(changed);
			if (e instanceof rescuecore2.standard.entities.Building) {
				Area a = ((rescuecore2.standard.entities.Building) e).area;
				if (((Building) a).stFire > 0) {
					if (!lowCommi && !noCommi)
						sendInfo();
					else {
						((PoliceForce) myHum()).searchAroundZoneBuilds.clear();
						me().fireTask = null;
						me().realFireTask = null;
					}
					return;
				}

				((PoliceForce) myHum()).searchAroundZoneBuilds
						.remove((Building) a);
			}
		}
		moveToSee(((PoliceForce) myHum()).searchAroundZoneBuilds,
				getMinLTS(((PoliceForce) myHum()).searchAroundZoneBuilds));

		if (!lowCommi && !noCommi)
			sendInfo();
		else {
			doneSearchAroundZoneAreas.add(me().fireTask.firedBuildingPart);
			me().fireTask = null;
			me().realFireTask = null;
		}
	}

	private void fillSectorZoneAreas() {
		for (int i : trapped.values()) {
			Area area = worldModel.getAreaByInt(i);
			if (!(area instanceof Building))
				findNearestSectorZones(area);
		}
	}

	private void findNearestSectorZones(Area area) {
		double minDist = Integer.MAX_VALUE;
		SectorZone mySectorZone = null;
		if (lowCommi || noCommi) {
			for (SectorZone s : noHearSectorZones) {
				if (area.distance(s.center) < minDist) {
					minDist = area.distance(s.center);
					mySectorZone = s;
				}
			}
		}
		if (mySectorZone != null && !mySectorZone.areas.contains(area))
			mySectorZone.areas.add(area);

	}

	private void clearToRefuge() throws ActionCommandException {
		worldModel.Refuge refuge = null;
		if (nearRefuge != -1) {
			refuge = (worldModel.Refuge) worldModel.getAreaByInt(nearRefuge);
			if (addToClearedIDs(refuge)) {
				refuge = null;
				nearRefuge = -1;
			}
		}

		if (nearRefuge == -1) {
			int minDist = Integer.MAX_VALUE;
			for (Area a : worldModel.refuges)
				if (a.distFromeSelfWOB < minDist && !addToClearedIDs(a)
						&& myHum().noCommiSectorZone.refuges.contains(a)) {
					minDist = a.distFromeSelfWOB;
					refuge = (worldModel.Refuge) a;
				}
		}

		if (refuge != null) {
			nearRefuge = refuge.id;
			fastClearPath(refuge, refuge.getX(), refuge.getY());
		}
		nearRefuge = -1;
	}

	private boolean shouldHelpNearStuckAgent(int Area) {

		if (!noCommi
				&& !lowCommi
				&& !worldModel.isInChangeSet((worldModel.getAreaByInt(Area))
						.getID()))
			return false;
		return true;

	}

	private void helpNearStuckAgents(int distance)
			throws ActionCommandException {
		if (me().fireTask != null && !noCommi && !lowCommi)
			return;

		// if (me().duty == Duty.FireTasker)
		// distance *= 2;
		//
		// if (bigMap)
		// distance *= 1.5;
		// log("disss:" + distance);

		if (nearTrapped != -1) {
			Area area = worldModel.getAreaByInt(nearTrapped);
			if (addToClearedIDs(area)) {
				nearTrapped = -1;
			}
		}

		if (nearTrapped == -1) {
			// log("Finding a Near Stuck");
			int minDist = Integer.MAX_VALUE;
			HashMap<Integer, Integer> shouldRemove = new HashMap<>();
			HashMap<Integer, Integer> shouldAdd = new HashMap<>();
			for (int nhpPos : trapped.values()) {
				if (isItTrapped(worldModel.getAreaByInt(nhpPos), false)
						&& (Mathematic.getDistance(
								worldModel.getAreaByInt(nhpPos).getX(),
								worldModel.getAreaByInt(nhpPos).getY(),
								getMyPos().getX(), getMyPos().getY()) < distance
								&& (!(worldModel.getAreaByInt(nhpPos) instanceof Building) || !((Building) (worldModel
										.getAreaByInt(nhpPos))).isOnFire()) && worldModel
								.getAreaByInt(nhpPos).distFromeSelfWOB < minDist)
						&& !addToClearedIDs(worldModel.getAreaByInt(nhpPos))
						&& shouldHelpNearStuckAgent(nhpPos)) {

					minDist = worldModel.getAreaByInt(nhpPos).distFromeSelfWOB;
					nearTrapped = nhpPos;

				}
				// log("near trap :" + nearTrapped);
				shouldAdd.putAll(shouldAddToTrapped);
				shouldRemove.putAll(removeFromTrapped);
			}
			for (Entry<Integer, Integer> e : shouldRemove.entrySet())
				trapped.remove(e.getKey(), e.getValue());
			for (Entry<Integer, Integer> e : shouldAdd.entrySet())
				trapped.put(e.getKey(), e.getValue());
			removeFromTrapped.clear();
			shouldRemove.clear();
		}

		if (nearTrapped != -1) {
			clearMyPosAgents(worldModel.getAreaByInt(nearTrapped), false);
		}
		nearTrapped = -1;
	}

	// private boolean IsAnyPoliceInChangeset() {
	// for (EntityID e : worldModel.changeSet.getChangedEntities())
	// if (worldModel.getEntity(e) instanceof PoliceForce)
	// return true;
	// return false;
	// }

	//
	// private void whoshouldhelp(worldModel.Area area) {
	// sendMyStuckTask(area);// must send my id and my targ
	//
	// for (EntityID id : thosewhohelp.keySet())
	// if (id.Value() == area && id != me().getID()
	// && id.getValue() < me().getID().getValue()) {
	// helpinhim = false;
	// return;
	// }
	// helpinhim = true;
	// }

	private void helpNearStuckCVs(int cvDist) throws ActionCommandException {

		if (nearCVPos != -1) {
			Area area = worldModel.getAreaByInt(nearCVPos);
			if (addToClearedIDs(area))
				nearCVPos = -1;
		}

		if (nearCVPos == -1) {
			int minDist = Integer.MAX_VALUE;
			for (rescuecore2.standard.entities.Civilian cv : worldModel
					.getCivilians())
				if (cv.isPositionDefined()) {
					rescuecore2.worldmodel.Entity position = worldModel
							.getEntityByInt(cv.getPosition().getValue());
					if (!(position instanceof rescuecore2.standard.entities.Area))
						continue;
					Area area = worldModel.getAreaByInt(position.getID()
							.getValue());
					if (!addToClearedIDs(worldModel.getAreaByInt(position
							.getID().getValue()))
							&& !(position instanceof Refuge)
							&& (cv.deadtime - time > 10)
							&& (area instanceof Building && ((Building) area).stFire == 0)) {
						double distFromMe = Math.hypot(me().getX() - cv.getX(),
								me().getY() - cv.getY());
						if ((distFromMe < cvDist)) {
							if (minDist > area.distFromeSelfWOB) {
								minDist = area.distFromeSelfWOB;
								nearCVPos = position.getID().getValue();
							}
						}
					}
				}
		}

		if (nearCVPos != -1) {
			clearMyPosAgents(worldModel.getAreaByInt(nearCVPos), true);
		}

		nearCVPos = -1;
	}

	private Area changeFireTaskTarget(Area target) {
		Area testTarget = target;
		if (target instanceof Building && ((Building) target).stFire > 0) {
			ArrayList<Area> p = worldModel
					.getMinPath(getMyPos(), target, false);
			ArrayList<EntityID> path = new ArrayList<EntityID>();
			for (Area a : p)
				path.add(a.getID());
			ArrayList<EntityID> way = dijkstraCalculations(false, path, true);
			while (testTarget instanceof Building
					&& ((Building) testTarget).stFire > 0 && way.size() > 1) {
				way.remove(way.size() - 1);
				testTarget = worldModel.getArea(way.get(way.size() - 1));
			}
		}
		return testTarget;
	}

	private Human trappedInMyPos(boolean isUnTrappingCV) {
		for (EntityID e : worldModel.changeSet.getChangedEntities()) {
			Entity entity = worldModel.getEntity(e);
			if ((entity instanceof FireBrigade
					|| entity instanceof AmbulanceTeam || (isUnTrappingCV && entity instanceof Civilian))
					&& ((Human) entity).getPosition().getValue() == getMyPos().id) {
				Human human = (Human) entity;
				Coordinate agPos = new Coordinate(human.getX(), human.getY());
				if (worldModel.getTrafficSimulator().myShape == null
						|| !worldModel.getTrafficSimulator().myShape
								.contains(GeometryTools.coordToGeometry(agPos,
										worldModel.getTrafficSimulator().geom)))
					return human;
			}
		}
		return null;
	}

	private void doHeadFireTask() throws ActionCommandException {
		if (me().fireTask.headOrTail == 1)
			return;
		me().fireTask.agentPart = changeFireTaskTarget(me().fireTask.agentPart);
		if (!addToClearedIDs(me().fireTask.agentPart))
			clearMyPosAgents(me().fireTask.agentPart, false);
	}

	private FireZone fireTaskFireZoneBuilder(Building b) {
		for (FireZone fz : fireZoneBuilder.modelZones) {
			if (fz.buildings.contains(b))
				return fz;
		}
		return null;
	}

	Building targetmoveforfire = null;

	void movefortail(HashSet<Road> RoadsAround) throws ActionCommandException {
		// //if (noCommi && IsAnyPoliceInChangeset()) {
		// // use channel 0 to sent my duty
		// double maxDist = Integer.MIN_VALUE;
		// Area maxroad = null;
		// for (Road a : RoadsAround) {
		// double dist = Math.hypot((a.getX() - me().getX()),
		// (a.getY() - me().getY()));
		// if (maxDist < dist) {
		// maxDist = dist;
		// maxroad = a;
		// }
		// }}if(getMyPos()==mxroad)
		// anyoneistailing=false
		// if (anyoneistailing) {
		//
		// fastClear(maxroad);
		// }
		//
		ArrayList<EntityID> pathEntityID = new ArrayList<EntityID>();
		start = getMyPos();
		HashSet<Entrance> entrances = new HashSet<Entrance>();
		HashSet<Area> coppyroads = new HashSet<Area>();
		coppyroads.addAll(RoadsAround);

		path.clear();
		while (path.size() < 5) {
			// System.out.println("start : " + start+"time" +time);
			for (Area coppyroad : coppyroads)
				entrances.addAll(coppyroad.entrances);
			// log("start!!!!!"
			// + worldModel.getMinPathByHashSetfortail(start.entrances,
			// entrances, false));
			// log("start :" + start);
			// log("destination:" + coppyroads);
			path.addAll(worldModel.getMinPathByHashSetfortail(start.entrances,
					entrances, false));

			if (path.size() != 0)
				start = path.get(path.size() - 1);
			if (coppyroads.size() > 1)
				coppyroads.remove(start);
			else
				break;

		}
		// String s = "";
		// for (Area a : path)
		// s += a.id + " ";
		// log("pathhhhhhhh" + s);
		// log("starttt" + start);
		for (Area a : path)
			pathEntityID.add(a.getID());

		// log("pattail : " + path);
		fastClear(start, pathEntityID, start.getX(), start.getY());

	}

	protected void outerAroundFirezone(ArrayList<Building> fireZone) {
		aroundOuterBuilding.clear();
		for (Building fz : fireZone)
			aroundOuterBuilding.addAll(fz.nearBuildings);
		aroundOuterBuilding.removeAll(fireZone);
	}

	private void doTailFireTask(boolean shouldComeHear)
			throws ActionCommandException {
		if (me().fireTask.headOrTail == 0 && !shouldComeHear)
			return;
		ArrayList<Building> myFirezoneBuildings = new ArrayList<Building>();
		HashSet<Area> handy = new HashSet<Area>();
		FireZone fireTaskFirezone = fireTaskFireZoneBuilder((Building) me().realFireTask.firedBuildingPart);
		if (fireTaskFirezone != null) {
			myFirezoneBuildings.addAll(fireTaskFirezone.buildings);
			outerAroundFirezone(myFirezoneBuildings);
			HashSet<Road> aroundFireZoneRoads = new HashSet<Road>();
			// aroundOuterBuilding.clear();
			// aroundOuterBuilding.addAll(fireTaskFirezone.simulatedArounds);
			// log("aroundayenegB:::" + aroundOuterBuilding);
			double maxDist = Integer.MAX_VALUE;
			for (Building a : aroundOuterBuilding) {
				double dist = Math.hypot((a.getX() - fireTaskFirezone.centerX),
						(a.getY() - fireTaskFirezone.centerY));
				if (maxDist > dist)
					maxDist = dist;
			}

			for (Building a : aroundOuterBuilding) {
				if (Math.hypot((a.getX() - fireTaskFirezone.centerX),
						(a.getY() - fireTaskFirezone.centerY)) > maxDist
						+ worldModel.maxDistanceView)
					handy.add(a);
			}
			aroundOuterBuilding.removeAll(handy);

			// log("center " + fireTaskFirezone.centerX + "center "
			// + fireTaskFirezone.centerY);
			for (Building b : aroundOuterBuilding)
				aroundFireZoneRoads.addAll(b.nearRoads);

			// log("preroads :" + aroundFireZoneRoads);

			for (Area a : path)
				if (a == getMyPos())
					break;
				else
					a.checkedForTail = true;
			for (Road neadToRemove : aroundFireZoneRoads) {
				if (neadToRemove == getMyPos())
					neadToRemove.checkedForTail = true;
				if (neadToRemove.checkedForTail == true
						|| addToClearedIDs(neadToRemove)) {
					// log("addTO");
					handy.add(neadToRemove);
					continue;
				}
				// log("handy :" + handy);
				for (Entrance enter : neadToRemove.entrances)
					if (myFirezoneBuildings.contains(enter.neighbour.area)
							|| aroundOuterBuilding
									.contains(enter.neighbour.area)) {
						handy.add(neadToRemove);
						continue;
					}
			}

			// log("proroads :" + aroundFireZoneRoads);

			for (Road road : aroundFireZoneRoads)
				if (Math.hypot((road.getX() - fireTaskFirezone.centerX),
						(road.getY() - fireTaskFirezone.centerY)) > maxDist
						+ worldModel.maxDistanceView
						|| Math.hypot((road.getX() - fireTaskFirezone.centerX),
								(road.getY() - fireTaskFirezone.centerY)) < maxDist
								- worldModel.maxDistanceView)
					handy.add(road);
			aroundFireZoneRoads.removeAll(handy);
			// FirezoneZoning(aroundFireZoneRoads, fireTaskFirezone);

			if (shouldComeHear) {
				if (aroundFireZoneRoads == null || worldModel.refuges == null)
					return;
				if (getMyPos() == nearRefugeForFire) {
					checkForRefuge = true;
					nearRefugeForFire = null;
					nearAreaForFire = null;
					checkForArea = false;
				}
				if (getMyPos() == nearAreaForFire) {
					checkForArea = true;
				}
				// neara ro peida kon

				if (nearRefugeForFire == null || nearAreaForFire == null) {
					maxDist = Integer.MAX_VALUE;
					for (worldModel.Refuge a : worldModel.refuges) {
						double dist = worldModel.getMinPath(a.entrances,
								me().realFireTask.firedBuildingPart, false)
								.size();
						if (maxDist > dist) {
							maxDist = dist;
							nearRefugeForFire = a;
						}
					}
					maxDist = Integer.MAX_VALUE;
					for (Road road : aroundFireZoneRoads) {
						double dist = worldModel.getMinPath(road.entrances,
								nearRefugeForFire, false).size();

						if (maxDist > dist) {
							maxDist = dist;
							nearAreaForFire = road;
						}

					}
				} else if (checkForRefuge == false) {
					// log("dare mire");
					if (checkForArea == true)
						fastClear(nearRefugeForFire);
					else
						fastClear(nearAreaForFire);
				}

			}
			checkForRefuge = false;
			if (aroundFireZoneRoads.size() > 0)
				movefortail(aroundFireZoneRoads);
		} else {
			if (policeBuildingReachability((Building) me().realFireTask.firedBuildingPart)) {
				if (me().realFireTask.firedBuildingPart.LTS <= -1)
					moveToFireForPolice((Building) me().realFireTask.firedBuildingPart);
			} else {
				Building secondTarg = null;
				int minDist = Integer.MAX_VALUE;
				for (Building b : me().realFireTask.firedBuildingPart.nearBuildings)
					if (Math.hypot(b.getX() - me().getX(), b.getY()
							- me().getY()) < minDist
							&& policeBuildingReachability(b)) {
						minDist = (int) Math.hypot(b.getX() - me().getX(),
								b.getY() - me().getY());
						secondTarg = b;
					}
				moveToFireForPolice(secondTarg);
			}
		}

	}

	// private void goToMiddleFireTask() throws ActionCommandException {
	// ArrayList<Area> path = worldModel.getMinPath(
	// me().realFireTask.agentPart,
	// me().realFireTask.firedBuildingPart, false);
	// Area target = null;
	// log("path size in middle: " + path.size());
	// if (path.size() == 0 || path.size() == 1 || path.size() == 2) {
	// if (me().fireTask.headOrTail == 0)
	// target = me().realFireTask.firedBuildingPart;
	// else
	// target = me().realFireTask.firedBuildingPart;
	// } else if (me().fireTask.headOrTail == 0)
	// target = path.get(path.size() / 2 + 1);
	// else
	// target = path.get(path.size() / 2 - 1);
	// log("go to middle: " + target);
	// if (!wentToMiddle(target))
	// fastClear(target);
	// }

	private void doFireTask() throws ActionCommandException {
		if (me().fireTask == null || me().fireTask.isForSearchAroundZone)
			return;
		doHeadFireTask();
		doTailFireTask(false);

		if (me().fireTask.headOrTail == 0)
			doTailFireTask(true);
		SearchAroundFireZone();
		// goToMiddleFireTask();
		if (!lowCommi && !noCommi)
			sendInfo();
	}

	public void updateLastBlock() {
		if (lastBlock == null)
			return;
		Area area = worldModel.getArea(lastBlock.blockade.getPosition());
		int lastBlockID = lastBlock.getID().getValue();
		lastBlock = null;
		for (worldModel.Blockade b : area.getBlockades())
			if (b.getID().getValue() == lastBlockID) {
				lastBlock = b;
				return;
			}
	}

	private void clearMyPosAgents(Area mainTarg, boolean isUnTrappingCV)
			throws ActionCommandException {
		if (getMyPos().id == mainTarg.id) {
			if (noCommi) {
				ArrayList<Human> trappedInMyPos = new ArrayList<Human>();
				for (Entry<Integer, Integer> entry : trapped.entrySet())
					if (entry.getValue() == mainTarg.id)
						trappedInMyPos.add((Human) worldModel
								.getEntityByInt((entry.getKey())));
				for (Human h : trappedInMyPos) {
					if (h.firstPosition == getMyPos()) {
						Coordinate targPos = new Coordinate(h.firstX, h.firstY);
						if (targPos.distance(new Coordinate(getX(), getY())) <= worldModel.maxDistanceView) {
							if (worldModel.isInChangeSet(h.getID())) {
								if (isInBlock(h))
									fastClearPath(mainTarg, h.getX(), h.getY());
								else
									trapped.remove(h.getID().getValue());
							} else
								trapped.remove(h.getID().getValue());
						} else {
							// log("tu change setam nist . . .");
							fastClearPath(mainTarg, h.getX(), h.getY());
						}
					} else {
						// log("man tu position e avalesh nistam . . . "
						// + worldModel.isInChangeSet(h.getID()));
						if (worldModel.isInChangeSet(h.getID()))
							fastClearPath(mainTarg, h.getX(), h.getY());
						else
							trapped.remove(h.getID().getValue());

					}
				}
				// for (Human h : trappedInMyPos) {
				// Coordinate firstPos = new Coordinate(h.firstX, h.firstY);
				// Geometry coordGeometry = GeometryTools.coordToGeometry(
				// firstPos, worldModel.getTrafficSimulator().geom);
				// Entrance entranceBetween = null;
				// int i = lastMovePath.indexOf(getMyPos().getID());
				// if (lastMovePath.indexOf(getMyPos().getID()) == 0)
				// continue;
				// for (Entrance e : getMyPos().entrances)
				// if (e.neighbour.area.id == lastMovePath.get(i - 1)
				// .getValue())
				// entranceBetween = e.neighbour;
				// if (entranceBetween.neighbour.shapeInArea
				// .contains(coordGeometry)) {
				// trapped.remove(h.getID().getValue());
				// } else {
				// if (h.getPosition() == mainTarg.getID())
				// fastClearPath(mainTarg, h.firstX, h.firstY);
				// else
				// fastClear(mainTarg);
				//
				// }
				//
				// }

			}
			Human stuck = trappedInMyPos(isUnTrappingCV);
			if (stuck != null) {
				fastClearPath(mainTarg, stuck.getX(), stuck.getY());
			}
		} else {
			fastClear(mainTarg);
		}
	}

	private boolean isInBlock(Human h) {
		for (worldModel.Blockade b : worldModel.getArea(h.getPosition())
				.getBlockades()) {
			Coordinate c = new Coordinate(h.getX(), h.getY());
			Geometry geometry = GeometryTools.coordToGeometry(c,
					worldModel.getTrafficSimulator().geom);
			geometry = geometry
					.buffer(worldModel.getTrafficSimulator().agentRad);
			if (b.mainShape.contains(geometry)
					|| b.mainShape.intersects(geometry))
				return true;
		}
		return false;
	}

	private void clearTargets() throws ActionCommandException {
		ArrayList<EntityID> targs = new ArrayList<EntityID>();
		HashMap<Integer, Integer> shouldRemove = new HashMap<>();
		HashMap<Integer, Integer> shouldAdd = new HashMap<>();
		for (int nhP : trapped.values()) {
			Area area = worldModel.getAreaByInt(nhP);
			if (lowCommi || noCommi) {
				if (myHum().noCommiSectorZone.areas.contains(area)
						&& isItTrapped(area, false))
					targs.add(area.getID());
			} else {
				if (myHum().sectorZone.areas.contains(area)
						&& isItTrapped(area, false))
					targs.add(area.getID());
			}
			shouldRemove.putAll(removeFromTrapped);
			shouldAdd.putAll(shouldAddToTrapped);
		}

		for (Entry<Integer, Integer> e : shouldRemove.entrySet())
			trapped.remove(e.getKey(), e.getValue());
		for (Entry<Integer, Integer> e : shouldAdd.entrySet())
			trapped.put(e.getKey(), e.getValue());

		removeFromTrapped.clear();
		shouldAddToTrapped.clear();
		shouldRemove.clear();
		// shouldadd chera clear nemishe?

		if (targs.size() > 0) {
			Area target = null;
			int minDist = Integer.MAX_VALUE;
			for (EntityID e : targs) {
				Area area = worldModel.getArea(e);
				int dist = area.distFromeSelfWOB;
				if (minDist > dist) {
					minDist = dist;
					target = area;
				}
			}
			if (target != null) {
				if (target instanceof Building
						&& ((Building) target).isFirenessDefined()
						&& ((Building) target).isOnFire()) {
					ArrayList<Area> p = worldModel.getMinPath(getMyPos(),
							target, false);
					ArrayList<EntityID> path = new ArrayList<EntityID>();
					for (Area a : p)
						path.add(a.getID());
					ArrayList<EntityID> way = dijkstraCalculations(false, path);
					Area testTarget = target;
					while (testTarget instanceof Building
							&& ((Building) testTarget).isOnFire()
							&& way.size() > 1) {
						way.remove(way.size() - 1);
						testTarget = worldModel
								.getArea(way.get(way.size() - 1));
					}
					target = testTarget;
				}
				clearMyPosAgents(target, false);
			}
		}

	}

	private void clearRefugeTarget() throws ActionCommandException {
		if (me().refugeTarget != null) {
			if (addToClearedIDs(me().refugeTarget)) {
				sendRefuge(me().refugeTarget);
			} else
				fastClear(me().refugeTarget);
		}
	}

	private void clearStuckAgents() throws ActionCommandException {
		if (me().stuckTarget == null)
			return;

		if (isItTrapped(me().stuckTarget, true))
			clearMyPosAgents(me().stuckTarget, false);
		else
			sendInfo();
	}

	// ArrayList<Area> wentToMiddle = new ArrayList<Area>();
	// private boolean wentToMiddle(Area area) {
	// if (wentToMiddle.contains(area))
	// return true;
	// if (getMyPos().id == area.id) {
	// wentToMiddle.add(area);
	// return true;
	// }
	// return false;
	// }

	HashMap<Integer, Integer> removeFromTrapped = new HashMap<>();
	HashMap<Integer, Integer> shouldAddToTrapped = new HashMap<>();

	private boolean isItTrapped(Area area, boolean shouldRemove) {
		removeFromTrapped.clear();
		shouldAddToTrapped.clear();
		if (getMyPos().id == area.id) {
			Human stuck = trappedInMyPos(false);
			if (stuck == null) {
				if (trapped.containsValue(area.id)) {
					for (Entry<Integer, Integer> e : trapped.entrySet()) {
						if (e.getValue() == area.id) {
							removeFromTrapped.put(e.getKey(), e.getValue());
						}
					}
					if (shouldRemove) {
						for (Entry<Integer, Integer> e : removeFromTrapped
								.entrySet())
							trapped.remove(e.getKey(), e.getValue());
						removeFromTrapped.clear();
					}
				}
				return false;
			}
			shouldAddToTrapped.put(stuck.getID().getValue(), area.id);
			return true;
		}

		if (trapped.containsValue(area.getID().getValue()))
			return true;

		return false;
	}

	private boolean addToClearedIDs(Area target) {
		if (clearedIDs.contains(target.getID().getValue())) {
			return true;
		}
		if ((!(target instanceof Road) || !target.isBlockadesDefined() || target.blockades
				.size() == 0)
				&& ((target.isReachable && worldModel.isInChangeSet(target
						.getID())) || getMyPos().id == target.id)) {

			// ArrayList<Area> p = worldModel
			// .getMinPath(getMyPos(), target, false);
			// ArrayList<EntityID> path = new ArrayList<EntityID>();
			// for (Area a : p)
			// path.add(a.getID());
			ArrayList<Area> way = new ArrayList<Area>();
			ArrayList<EntityID> p2 = worldModel.getMinPathDijkByHash(
					target.getID(), false, true, worldModel, myHum());
			// ArrayList<EntityID> p2 = dijkstraCalculations(false, path);
			for (EntityID e : p2)
				way.add(worldModel.getArea(e));
			ArrayList<worldModel.Blockade> wayBlocks = new ArrayList<worldModel.Blockade>();
			for (worldModel.Area area : way) {
				if (area.LTS < 0) {
					return false;
				}
				Entrance lastEntrance = null;
				Entrance nextEntrance = null;
				if (way.indexOf(area) <= (way.size() - 2)) {
					for (Entrance e : area.entrances)
						if (e.neighbour.area.getID().getValue() == (way.get(way
								.indexOf(area) + 1)).getID().getValue()) {
							nextEntrance = e;
							break;
						}
				}
				if (way.indexOf(area) > 0)
					for (Entrance e : area.entrances)
						if (e.neighbour.area.getID().getValue() == way
								.get(way.indexOf(area) - 1).getID().getValue()) {
							lastEntrance = e;
							break;
						}
				if (way.indexOf(area) > 0) {
					Coordinate startPoint = new Coordinate(
							lastEntrance.center.x, lastEntrance.center.y);
					if (way.indexOf(area) <= (way.size() - 2)) {
						Coordinate endPoint = new Coordinate(
								nextEntrance.center.x, nextEntrance.center.y);
						if (endPoint.x != startPoint.x
								|| endPoint.y != startPoint.y)
							wayBlocks.addAll(getRealBlockInShape(endPoint,
									startPoint));
						// else {
						// // TODO XXX :D -- > Maryam
						// Geometry shape = lastEntrance.shapeInArea;
						// if (shape.getNumGeometries() == 0)
						// return false;
						// if (shape.getNumGeometries() == 1)
						// return false;
						// }
					}
				} else if (way.indexOf(area) <= (way.size() - 2)) {
					Coordinate startPoint = new Coordinate(me().getX(), me()
							.getY());
					Coordinate endPoint = new Coordinate(nextEntrance.center.x,
							nextEntrance.center.y);
					if (endPoint.x != startPoint.x
							|| endPoint.y != startPoint.y)
						wayBlocks.addAll(getRealBlockInShape(endPoint,
								startPoint));
				}
			}

			if (wayBlocks.size() == 0) {
				clearedIDs.add(target.id);
				return true;
			}
		}

		return false;
	}

	private void updateDistFromSelfWOB() {
		worldModel.clearAreas();
		Area area = getMyPos();
		ArrayList<Entrance> layer = new ArrayList<Entrance>();
		layer.addAll(area.entrances);
		for (Entrance e : layer)
			e.mark = true;
		area.distFromeSelfWOB = 0;
		int dist = 1;
		while (layer.size() > 0) {
			ArrayList<Entrance> newLayer = new ArrayList<Entrance>();
			for (Entrance enterance : layer) {
				if (!enterance.neighbour.mark) {
					enterance.neighbour.area.distFromeSelfWOB = dist;
					enterance.neighbour.mark = true;

					for (Entrance internal : enterance.neighbour.area.entrances)
						if (!internal.mark) {
							newLayer.add(internal);
							internal.mark = true;
						}
				}
			}
			dist++;
			layer = newLayer;
		}
	}

	private int getDistance(int targetX, int targetY) {
		long x, y;
		// x
		if (targetX > me().getX())
			x = targetX - me().getX();
		else
			x = me().getX() - targetX;
		// y
		if (targetY > me().getY())
			y = targetY - me().getY();
		else
			y = me().getY() - targetY;
		return (int) Math.sqrt(y * y + x * x);
	}

	private void Sclear(worldModel.Blockade block)
			throws ActionCommandException {

		Blockade blockade = block.blockade;
		int distToBlock = (int) findDistanceTo(blockade, me().getX(), me()
				.getY());
		if (distToBlock > clearDist - 520
				|| !worldModel.isInChangeSet(blockade.getID())) {
			ArrayList<Area> p = worldModel.getMinPath(getMyPos().entrances,
					worldModel.getArea(block.blockade.getPosition()), false);
			ArrayList<EntityID> way = new ArrayList<EntityID>();
			if (p != null)
				for (Area a : p)
					way.add(a.getID());
			ArrayList<Area> path = new ArrayList<Area>();
			ArrayList<EntityID> p2 = dijkstraCalculations(false, way, true);
			for (EntityID e : p2)
				path.add(worldModel.getArea(e));

			if (path == null || path.size() == 0) {
				path = new ArrayList<worldModel.Area>();
				path.add(getMyPos());
			}
			move(path, blockade.getX(), blockade.getY(), true);
		}
		setLastCleared(block);
		clear(blockade.getID());
	}

	Blockade LastClearedBlockade = null;
	int lastClearedBlockadeRepairCost = 0;

	protected void fastClear(Area target) throws ActionCommandException {
		fastClearPath(target, target.getX(), target.getY());
	}

	protected void fastClearPath(Area target, int x, int y)
			throws ActionCommandException {
		ArrayList<EntityID> path = worldModel.getMinPathDijk(target.getID(),
				false, true, worldModel, myHum());
		Area testTarget = target;
		while (testTarget instanceof Building
				&& ((Building) testTarget).stFire > 0 && path.size() > 1) {
			path.remove(path.size() - 1);
			testTarget = worldModel.getArea(path.get(path.size() - 1));
		}
		target = testTarget;
		fastClear(target, path, x, y);
	}

	int counterForClear = 0;
	boolean onBlockade = true;

	protected void chooseClear(worldModel.Blockade nearestBlock,
			Coordinate endPoint, int rad, Coordinate startPoint,
			ArrayList<Area> path, Area target, Coordinate targCoordinate)
			throws ActionCommandException {
		if (onBlockade && isOnBlockade()) {// this
											// condition
			// is
			// used to
			// prevent kernel
			// bug at the
			// beginning of
			// run(if agent is
			// on blockade, new
			// clear act
			// will not work)
			Sclear(nearestBlock);
		} else {
			onBlockade = false;
			SclearArea(nearestBlock, endPoint, rad, startPoint, path, target,
					targCoordinate);
			// SclearArea(nearestBlock, endPoint, rad, areaOfEndPoint,
			// firstPoint, path, target, targCoordinate);
		}
	}

	public boolean isOnBlockade() {
		StandardEntity se = (StandardEntity) worldModel.getEntity(me()
				.getPosition());
		if (se instanceof rescuecore2.standard.entities.Road) {
			Blockade blockade;
			rescuecore2.standard.entities.Road road = (rescuecore2.standard.entities.Road) se;
			if (road.isBlockadesDefined()) {
				for (EntityID id : road.getBlockades()) {
					blockade = (Blockade) worldModel.getEntity(id);
					if (blockade != null && blockade.isApexesDefined()) {
						if (blockade.getShape().contains(me().getX(),
								me().getY())) {
							return true;
						}
					}
				}
			}
		}
		return false;

	}

	public void moveForPolice(Area target, int x, int y, boolean djkstraPath,
			ArrayList<EntityID> pathID) throws ActionCommandException {
		if (pathID == null || pathID.size() == 0) {
			pathID = new ArrayList<EntityID>();
			pathID.add(target.getID());
		}
		move(pathID, x, y, djkstraPath);
	}

	// public int lastCycleOfMoveBeforeBlocade = -1;
	public void moveBeforeBlockade(Area target, Coordinate endPoint,
			LineSegment ls, int rad, ArrayList<EntityID> pathID)
			throws ActionCommandException {

		HashSet<worldModel.Blockade> badBlockadesNearMe = new HashSet<worldModel.Blockade>();

		for (worldModel.Blockade blockade : getBlocksInRange((int) ls
				.getLength() + rad)) {
			// log("chia midi kalak? :D"
			// + GeometryTools.printShape(blockade.mainShape, 0));
			if (blockade.mainShape
					.buffer(0)
					.getBoundary()
					.intersects(
							ls.toGeometry(worldModel.getTrafficSimulator().geom)))
				badBlockadesNearMe.add(blockade);
		}

		// HashSet<worldModel.Blockade> blocksOnWay = new
		// HashSet<worldModel.Blockade>();
		// for (worldModel.Blockade b : badBlockadesNearMe) {
		// log("MainShape: "
		// + GeometryTools.printShape(b.mainShape.buffer(0), 0));
		//
		// if (b.mainShape
		// .buffer(0)
		// .getBoundary()
		// .intersects(
		// ls.toGeometry(worldModel.getTrafficSimulator().geom))) {
		// log("Addeddd!" + GeometryTools.printLine(ls));
		// blocksOnWay.add(b);
		// }
		// }

		worldModel.Blockade onWay = null;
		onWay = nearestBlockade(badBlockadesNearMe);

		if (onWay == null) {
			return;
		}

		// String s = " ";
		// for (worldModel.Blockade b : badBlockadesNearMe)
		// s += GeometryTools.printShape(b.mainShape) + ";;; ";
		//
		// log("S:::: " + s);

		Geometry onwayShape = onWay.mainShape;

		try {
			for (worldModel.Blockade b : badBlockadesNearMe) {
				// log("b:: " + GeometryTools.printShape(b.mainShape));
				if (onwayShape.buffer(0).intersects(b.mainShape.buffer(0)))
					onwayShape = onwayShape.buffer(0).union(
							b.mainShape.buffer(0));
			}
		} catch (Exception e) {
			e.printStackTrace();

			if (logger.getWriter() != null)
				e.printStackTrace(logger.getWriter());

			if (logger.getWriter() != null)
				e.printStackTrace(logger.getWriter());

			onwayShape = onWay.mainShape;
		}

		Coordinate nearestPointOnway = null;
		Coordinate nearestPointOnBlockade = null;

		double min = Integer.MAX_VALUE;

		for (Coordinate a : onwayShape
				.buffer(0)
				.getBoundary()
				.intersection(
						ls.toGeometry(worldModel.getTrafficSimulator().geom))
				.getCoordinates()) {
			// log("a: " + GeometryTools.printPoint(a));
			// log ("booool: " +
			// onwayShape.contains(GeometryTools.coordToGeometry(a,
			// worldModel.getTrafficSimulator().geom)));
			double dist = a.distance(new Coordinate(me().getX(), me().getY()));
			if (dist < min) {
				min = dist;
				nearestPointOnBlockade = a;
			}
		}

		int SecureDist = rad + rad / 2;
		// if (commandHistory.get(time - 1).getAction() ==
		// StandardMessageURN.AK_MOVE)
		// SecureDist = rad * 10;
		// else
		// SecureDist = rad + rad / 2;

		double min2 = Integer.MAX_VALUE;
		for (Coordinate b : GeometryTools
				.coordToGeometry(nearestPointOnBlockade,
						worldModel.getTrafficSimulator().geom)
				.buffer(SecureDist)
				.intersection(
						ls.toGeometry(worldModel.getTrafficSimulator().geom))
				.getCoordinates()) {
			// log("b: " + GeometryTools.printPoint(b));
			// log("booool: "
			// + onwayShape.contains(GeometryTools.coordToGeometry(b,
			// worldModel.getTrafficSimulator().geom)));

			if (b.distance(new Coordinate(me().getX(), me().getY())) < min2
					&& !onwayShape.contains(GeometryTools.coordToGeometry(b,
							worldModel.getTrafficSimulator().geom))) {
				min2 = b.distance(new Coordinate(me().getX(), me().getY()));
				nearestPointOnway = b;
			}
		}

		if (nearestPointOnway == null) {
			return;
		}

		if (onwayShape.intersects(GeometryTools.coordToGeometry(
				nearestPointOnway, worldModel.getTrafficSimulator().geom)
				.buffer(rad / 2))) {
			log("Moving With Problem!");
		}

		ArrayList<EntityID> newPath = new ArrayList<EntityID>();
		for (EntityID id : pathID) {
			// log("Path id: " + id);
			Area a = worldModel.getArea(id);
			newPath.add(id);
			// log ("shape: " + GeometryTools.printShape(a.shape));
			if (a.shape.buffer(0).contains(
					GeometryTools.coordToGeometry(nearestPointOnway,
							worldModel.getTrafficSimulator().geom))) {
				// log("here! break.");
				break;
			}
		}

		// log("newPath: " + newPath);
		// lastCycleOfMoveBeforeBlocade = time;
		if (nearestPointOnway
				.distance(new Coordinate(me().getX(), me().getY())) > rad + rad
				/ 2)
			moveForPolice(target, (int) nearestPointOnway.x,
					(int) nearestPointOnway.y, false, newPath);
		else {
			endPoint = scaleEndPoint(new Coordinate(me().getX(), me().getY()),
					endPoint, clearDist - 10);

			LineSegment clearLine = new LineSegment(new Coordinate(me().getX(),
					me().getY()), endPoint);

			if (onwayShape.getBoundary().intersects(
					clearLine.toGeometry(worldModel.getTrafficSimulator().geom)
							.buffer(rad)))
				clearAreaComputation(endPoint, onWay);
		}
	}

	// protected worldModel.Blockade nearestBadBlockade(Area target,
	// ArrayList<EntityID> way) {
	//
	// int rad = worldModel.getTrafficSimulator().AGENT_RAD;
	// Coordinate endPoint = findingEndPoint(way, target);
	// Coordinate startPoint = new Coordinate(me().getX(), me().getY());
	// int minDistToBlock = Integer.MAX_VALUE;
	// HashSet<worldModel.Blockade> badBlockadesOfMyPos = target
	// .getBadBlockades(startPoint, endPoint, rad, geom);
	// if (badBlockadesOfMyPos != null) {
	// if (badBlockadesOfMyPos.size() != 0)
	// s += badBlockadesOfMyPos;
	// }
	// log("badBlockades: " + badBlockadesOfMyPos);
	// log("s: " + s);
	// minDistToBlock = Integer.MAX_VALUE;
	// worldModel.Blockade nearestBlock = null;
	// for (worldModel.Blockade badBlockade : badBlockadesOfMyPos) {
	// int dist = (int) findDistanceTo(badBlockade.blockade, me().getX(),
	// me().getY());
	// if (minDistToBlock > dist) {
	// minDistToBlock = dist;
	// nearestBlock = badBlockade;
	// }
	// }
	// return nearestBlock;
	// }

	private void reachedTarget(Area target, int x, int y, ArrayList<Area> path)
			throws ActionCommandException {
		int rad = worldModel.getTrafficSimulator().agentRad;
		Coordinate myPos = new Coordinate(me().getX(), me().getY());
		Coordinate targCoordinate = new Coordinate(x, y);
		if (getMyPos().getID() == target.getID()) {
			boolean shouldClear = false;
			int i = 0;
			for (Entrance ent : getMyPos().entrances) {
				if (ent.shapeInArea != null
						&& ent.shapeInArea.contains(GeometryTools
								.coordToGeometry(myPos,
										worldModel.getTrafficSimulator().geom))) {
					if (!ent.shapeInArea.contains(GeometryTools
							.coordToGeometry(targCoordinate,
									worldModel.getTrafficSimulator().geom)))
						shouldClear = true;
					break;
				} else {
					i++;
				}
			}
			if (i == getMyPos().entrances.size()) {
				shouldClear = true;
			}
			if (!shouldClear) {
				moveForPolice(target, x, y, true);
			} else {
				HashSet<worldModel.Blockade> badBlocks = getMyPos()
						.getBadBlockades(myPos, targCoordinate, rad,
								worldModel.getTrafficSimulator().geom);
				int minDistToBlock = Integer.MAX_VALUE;
				worldModel.Blockade nearestBlock = null;
				for (worldModel.Blockade badBlockade : badBlocks) {
					int dist = (int) findDistanceTo(badBlockade.blockade, me()
							.getX(), me().getY());
					if (minDistToBlock > dist) {
						minDistToBlock = dist;
						nearestBlock = badBlockade;
					}
				}
				if (nearestBlock != null) {
					chooseClear(nearestBlock, targCoordinate, rad, myPos, path,
							getMyPos(), targCoordinate);
				}
			}
			moveForPolice(target, x, y, true);
		}
	}

	private void moveIfReachable(ArrayList<EntityID> way, int x, int y,
			Area target) throws ActionCommandException {
		Coordinate myPos = new Coordinate(me().getX(), me().getY());
		Coordinate movePoint = null;
		ArrayList<Entrance> pathEntrances = new ArrayList<Entrance>();
		for (int i = 0; i < way.size() - 1; i++) {
			for (Entrance e : worldModel.getArea(way.get(i)).entrances) {
				if (e.neighbour.area == worldModel.getArea(way.get(i + 1))) {
					pathEntrances.add(e);
					pathEntrances.add(e.neighbour);
					break;
				}
			}
		}
		boolean canMove = false;
		for (int i = 0; i < pathEntrances.size() - 1; i++) {
			Entrance e = pathEntrances.get(i);
			Entrance e2 = pathEntrances.get(i + 1);
			if (i == 0) {
				if (e.shapeInArea != null
						&& e.shapeInArea.contains(GeometryTools
								.coordToGeometry(myPos,
										worldModel.getTrafficSimulator().geom))) {
					canMove = true;
					movePoint = e.center;
				} else
					break;

			} else if ((e.isItConnectedToNeighbour && i % 2 == 0)
					|| (e.internalEntrances.contains(e2) && i % 2 != 0)) {
				// log("e: " + e + "e2: " + e2 + " isitconnectedToneighbour: "
				// + e.isItConnectedToNeighbour + "e.internals: "
				// + e.internalEntrances.contains(e2));
				movePoint = e.center;
				canMove = true;
			} else
				break;

		}
		if (canMove && movePoint.distance(myPos) >= 4750) {
			moveForPolice(target, x, y, true, way);
		}
	}

	private Coordinate scaleEndPoint(Coordinate StartPoint,
			Coordinate endPoint, double value) {
		Vector2D v = new Vector2D(endPoint.x - StartPoint.x, endPoint.y
				- StartPoint.y);
		v = v.normalised().scale(value);
		Vector2D v2 = new Vector2D(StartPoint.x + v.getX(), StartPoint.y
				+ v.getY());
		return new Coordinate(v2.getX(), v2.getY());
	}

	/*
	 * private Double angleBetweenTwoLines(LineSegment ls1, LineSegment ls2) {
	 * Double Angle = Math.atan2(ls1.p0.y - ls1.p1.y, ls1.p0.x - ls1.p0.x) -
	 * Math.atan2(ls2.p0.y - ls2.p1.y, ls2.p0.x - ls2.p0.x); return Angle; }
	 */

	private Coordinate findEndPoint(ArrayList<EntityID> way,
			Coordinate startPoint) {

		// ArrayList<Entrance> endPointEntrances = new ArrayList<Entrance>();
		ArrayList<LineSegment> endPointLines = new ArrayList<LineSegment>();
		Coordinate endPoint = null;

		for (Entrance e : worldModel.getArea(way.get(0)).entrances) {
			if (e.neighbour.area.id == model.getEntity(way.get(1)).getID()
					.getValue()) {

				LineSegment MidleOftheLine = setMiddleOfLine(e.lineSegment);
				endPointLines.add(MidleOftheLine);
				endPoint = e.neighbour.center;
				// LineSegment startPlusEndPoint = new LineSegment(startPoint,
				// new Coordinate(e.neighbour.center.x,
				// e.neighbour.center.y));
				// log("stast_end!!! "
				// + GeometryTools.printLine(startPlusEndPoint));
				break;
			}
		}

		boolean hasNextArea = false;
		boolean isItSaaf = true;
		for (int i = 1; i <= way.size(); i++) {
			if (way.size() > i + 1 && isItSaaf) {
				hasNextArea = true;
				Area area = worldModel.getArea(way.get(i));
				Area nextArea = worldModel.getArea(way.get(i + 1));
				for (Entrance e : area.entrances) {
					if (e.neighbour.area.id == nextArea.id
							&& e.area.id == area.id) {

						LineSegment startPlusEndPoint = new LineSegment(
								startPoint, new Coordinate(
										e.neighbour.center.x,
										e.neighbour.center.y));

						if (i > 2 && isItConnectedToBuilding(nextArea)) {
							isItSaaf = false;
						}

						// log("stast_end "
						// + GeometryTools.printLine(startPlusEndPoint));
						for (LineSegment ls : endPointLines) {
							// log("ls: " + GeometryTools.printLine(ls));
							if (!GeometryTools.isIntersectBetweenLines(ls.p0,
									ls.p1, startPlusEndPoint.p0,
									startPlusEndPoint.p1)) {
								isItSaaf = false;
								break;
							}
						}

						if (isItSaaf) {
							LineSegment MidleOftheLine = setMiddleOfLine(e.lineSegment);
							endPointLines.add(MidleOftheLine);
							endPoint = new Coordinate(e.neighbour.center.x,
									e.neighbour.center.y);
							break;
						}
						break;
					}
				}
			}
		}

		if (!hasNextArea
				&& !(worldModel.getArea(way.get(1)) instanceof Building)) {

			Coordinate tempEnd = new Coordinate(worldModel.getArea(way.get(1))
					.getX(), worldModel.getArea(way.get(1)).getY());

			LineSegment startPlusEndPoint = new LineSegment(startPoint, tempEnd);

			LineSegment entrance = endPointLines.get(0);
			if (GeometryTools.isIntersectBetweenLines(entrance.p0, entrance.p1,
					startPlusEndPoint.p0, startPlusEndPoint.p1)) {
				endPoint = tempEnd;
			}
		}
		// endPoint = scaleEndPoint(startPoint, endPoint, clearDist - 10);
		// log("**2: " + GeometryTools.printLine(startPoint, endPoint));
		return endPoint;
	}

	private LineSegment setMiddleOfLine(LineSegment l) {
		// log("line " + GeometryTools.printLine(l));
		int secureLength = clearRad * 2 / 5;
		double mount = secureLength / (l.getLength() / 2);
		// log("mount: " + mount);
		if (mount > 1)
			mount = 1;
		// log("midPoint: " + GeometryTools.printPoint(l.midPoint()));
		Coordinate a = new LineSegment(l.midPoint(), l.p0).pointAlong(mount);
		Coordinate b = new LineSegment(l.midPoint(), l.p1).pointAlong(mount);

		// log("a: " + GeometryTools.printPoint(a));
		// log("b: " + GeometryTools.printPoint(b));
		// log("midle! Please :( "
		// + GeometryTools.printLine(new LineSegment(a, b)));
		return new LineSegment(a, b);

	}

	private worldModel.Blockade nearestBlockade(
			HashSet<worldModel.Blockade> badBlockadesOfMyPos) {
		worldModel.Blockade nearestBlock = null;
		int minDistToBlock = Integer.MAX_VALUE;
		for (worldModel.Blockade badBlockade : badBlockadesOfMyPos) {
			int dist = (int) findDistanceTo(badBlockade.blockade, me().getX(),
					me().getY());
			if (minDistToBlock > dist) {
				minDistToBlock = dist;
				nearestBlock = badBlockade;
			}
		}
		return nearestBlock;
	}

	public HashSet<worldModel.Blockade> getBadBlockades(Coordinate firstPoint,
			Coordinate secondPoint, int rad, GeometryFactory geom) {
		HashSet<worldModel.Blockade> badBlockades = new HashSet<worldModel.Blockade>();
		// LineSegment l = new LineSegment(firstPoint, secondPoint);
		// Geometry gLine = new LineSegment(new Coordinate(getMyPos().getX(),
		// getMyPos().getY()),secondPoint).toGeometry(geom).buffer(rad);
		// Geometry gLine = l.toGeometry(geom).buffer(rad);
		// log(" GLINE ! " + GeometryTools.printShape(gLine));
		for (worldModel.Blockade blockade : getBlocksInRange(clearDist - 10)) {
			// if (blockade.mainShape.intersects(gLine)) //new!!
			badBlockades.add(blockade);
		}
		return badBlockades;
	}

	private LineSegment nearestGuidlineInArea(Area area, Entrance targetEntrance) {
		ArrayList<LineSegment> guidlines = new ArrayList<LineSegment>();
		for (Entrance e : area.entrances) {
			if (targetEntrance.id == e.id
					&& e.area.getID().getValue() == targetEntrance.area.getID()
							.getValue())
				continue;

			LineSegment l = new LineSegment();
			l.p0 = e.center;
			l.p1 = targetEntrance.center;
			guidlines.add(l);
			// log("Guidlines!! " + GeometryTools.printLine(l));
		}
		double minDist = Integer.MAX_VALUE;
		LineSegment nearestGuidline = null;
		// log("MARKAZE AREA: "
		// + GeometryTools.printPoint(new Coordinate(area.getX(), area
		// .getY())));
		for (LineSegment l : guidlines) {
			// log("guideline: " + GeometryTools.printLine(l));
			Coordinate closestPoint = l.closestPoint(new Coordinate(
					area.getX(), area.getY()));
			// log ("closest on line " + GeometryTools.printPoint(closestPoint)
			// );
			double dist = closestPoint.distance(new Coordinate(area.getX(),
					area.getY())); // change:
									// markaze
									// area
			if (dist < minDist) {
				minDist = dist;
				nearestGuidline = l;
			}
		}
		if (nearestGuidline == null) {
			// log("Nearest null");
			nearestGuidline = new LineSegment(area.getX(), area.getY(),
					targetEntrance.center.x, targetEntrance.center.y);
		}
		return nearestGuidline;
	}

	static final int SECURE_DIST = 500; // change

	private void moveToGuidline(LineSegment nearestGuidline)
			throws ActionCommandException {
		int rad = worldModel.getTrafficSimulator().agentRad;
		Coordinate nearestPoint = nearestGuidline.closestPoint(new Coordinate(
				me().getX(), me().getY()));

		for (worldModel.Blockade b : getMyPos().blockades) {
			if (b.mainShape.intersects(GeometryTools.coordToGeometry(
					nearestPoint, worldModel.getTrafficSimulator().geom)
					.buffer(rad))) {
				return;
			}
		}
		move(getMyPos(), (int) nearestPoint.x, (int) nearestPoint.y, false);
	}

	private boolean isItConnectedToBuilding(Area a) {
		for (Entrance e : a.entrances) {
			if (e.neighbour.area instanceof Building) {
				return true;
			}
		}
		return false;
	}

	protected void shouldMoveToGuidline(ArrayList<Area> path)
			throws ActionCommandException {
		if (path.size() == 1)
			return;
		for (Entrance e : path.get(0).entrances) {
			// log("entrance : " + e.center);
			if (e.neighbour.area == path.get(1)) {

				if (e.lineSegment.getLength() < clearRad
						&& ((path.size() > 2 && !isItConnectedToBuilding(path
								.get(2))) || !isItConnectedToBuilding(path
								.get(0)))) {
					return; // age road barik bud move nazane
				}

				if (nearestGuidlineInArea(getMyPos(), e).distance(
						new Coordinate(me().getX(), me().getY())) > SECURE_DIST)
					moveToGuidline(nearestGuidlineInArea(getMyPos(), e));

				return;
			}
		}

	}

	protected void fastClear(Area target, ArrayList<EntityID> way, int x, int y)
			throws ActionCommandException {
		// log("target: " + target);
		Coordinate targCoordinate = new Coordinate(x, y);
		int rad = worldModel.getTrafficSimulator().agentRad;
		Area testTarget = target;

		while (testTarget instanceof Building
				&& ((Building) testTarget).isOnFire() && way.size() > 1) {
			way.remove(way.size() - 1);
			testTarget = worldModel.getArea(way.get(way.size() - 1));
		}

		target = testTarget;
		if (x == -1 || y == -1) {
			x = target.getX();
			y = target.getY();
		}
		if (way.size() == 0)
			way.add(target.getID());

		ArrayList<Area> path = new ArrayList<Area>();
		for (EntityID e : way)
			path.add(worldModel.getArea(e));

		reachedTarget(target, x, y, path);
		// moveIfReachable(way, x, y, target);

		Entrance tempEndPointEntrance = null;
		for (Entrance e : getMyPos().entrances) {
			if (e.neighbour.area.id == model.getEntity(way.get(1)).getID()
					.getValue()) {
				tempEndPointEntrance = e;
				break;
			}
		}

		Coordinate startPoint = nearestGuidlineInArea(getMyPos(),
				tempEndPointEntrance).closestPoint(
				new Coordinate(me().getX(), me().getY()));

		if (startPoint == tempEndPointEntrance.center) {
			// log("It is!");
			startPoint = GeometryTools
					.coordToGeometry(startPoint,
							worldModel.getTrafficSimulator().geom)
					.buffer(rad)
					.intersection(
							nearestGuidlineInArea(getMyPos(),
									tempEndPointEntrance).toGeometry(
									worldModel.getTrafficSimulator().geom))
					.getCoordinate();
			// log("New start: " + GeometryTools.printPoint(startPoint));
		}
		Coordinate endPoint = findEndPoint(way, startPoint);
		endPoint = scaleEndPoint(startPoint, endPoint, clearDist - 10);

		worldModel.Blockade nearestBlock = null;

		HashSet<worldModel.Blockade> badBlockadesNearMe = getBadBlockades(
				startPoint, endPoint, rad,
				worldModel.getTrafficSimulator().geom);

		// String blockades = "";
		// for (worldModel.Blockade b : badBlockadesNearMe) {
		// blockades += GeometryTools.printShape(b.mainShape, b.getID()
		// .getValue())
		// + " ";
		// }
		// log("bad Blocks near me ! " + blockades + " !!!! ");

		nearestBlock = null;
		nearestBlock = nearestBlockade(badBlockadesNearMe);

		int realBlockade = 0; // server bug
		if (nearestBlock != null) {
			for (int i = 1; i <= 5; i++) {
				if (commandHistory.size() < 6) {
					realBlockade = 1;
					break;
				}
				if (commandHistory.get(time - i).getAction() == StandardMessageURN.AK_CLEAR_AREA) {
					realBlockade++;
				}
			}
			if (realBlockade != 5)
				chooseClear(nearestBlock, endPoint, rad, startPoint, path,
						getMyPos(), targCoordinate);
		}

		ArrayList<EntityID> moveWay = new ArrayList<EntityID>();
		moveWay.addAll(way);

		// while (moveWay.size() > 2) {
		for (int j = 0; j < 2; j++) {
			if (moveWay.size() < 2)
				break;

			// log("moveWay! " + moveWay);
			endPoint = findEndPoint(moveWay, startPoint);
			// log("endP" + GeometryTools.printPoint(endPoint));
			LineSegment wayLine = new LineSegment(startPoint, endPoint);

			badBlockadesNearMe.clear();
			for (worldModel.Blockade blockade : getBlocksInRange((int) wayLine
					.getLength())) {
				if (blockade.mainShape.intersects(wayLine.toGeometry(worldModel
						.getTrafficSimulator().geom))) {
					badBlockadesNearMe.add(blockade);
				}
			}

			nearestBlock = null;
			nearestBlock = nearestBlockade(badBlockadesNearMe);

			// for (worldModel.Blockade b : badBlockadesNearMe) {
			// blockades += GeometryTools.printShape(b.mainShape, b.getID()
			// .getValue())
			// + " ";
			// }
			// log("bad Blocks near me2 ! " + blockades + " !!!! ");

			if (nearestBlock != null) {
				moveBeforeBlockade(target, endPoint, wayLine, rad, way);
			} else {
				ArrayList<EntityID> toRemove = new ArrayList<EntityID>();
				done: for (int i = 0; i < moveWay.size() - 1; i++) {
					Area area = worldModel.getArea(moveWay.get(i));
					Area nextArea = worldModel.getArea(moveWay.get(i + 1));
					for (Entrance e : area.entrances) {
						if (e.neighbour.area.id == nextArea.id
								&& e.area.id == area.id) {
							if (GeometryTools.isIntersectBetweenLines(
									e.lineSegment.p0, e.lineSegment.p1,
									wayLine.p0, wayLine.p1)) {
								toRemove.add(moveWay.get(i));
								// log("RemovedArea: " +
								// moveWay.get(i).getValue());
								break;
								// log("RemovedArea: "
								// + GeometryTools.printShape(
								// worldModel.getArea(e).shape, 0));
								// moveWay.remove(e);
							} else
								break done;

						}
					}
				}
				moveWay.removeAll(toRemove);
				startPoint = endPoint;
			}
		}
		moveForPolice(target, target.getX(), target.getY(), true, way);
	}

	Coordinate lastEndPoint = null;

	private void clearAreaComputation(Coordinate endPoint,
			worldModel.Blockade nearestBlock) throws ActionCommandException {
		setLastCleared(nearestBlock);
		endPoint = scaleEndPoint(new Coordinate(me().getX(), me().getY()),
				endPoint, clearDist - 10);
		lastEndPoint = endPoint;
		clearArea((int) endPoint.x, (int) endPoint.y);
	}

	private void setLastCleared(worldModel.Blockade nearestBlock) {
		lastClearedBlockadeRepairCost = nearestBlock.blockade.getRepairCost();
		LastClearedBlockade = nearestBlock.blockade;
	}

	private void SclearArea(worldModel.Blockade nearestBlock,
			Coordinate endPoint, int rad, Coordinate firstPoint,
			ArrayList<Area> path, Area target, Coordinate targCoordinate)
			throws ActionCommandException {
		// Coordinate myPos = new Coordinate(me().getX(), me().getY());
		double distToBlock = findDistanceTo(nearestBlock.blockade, me().getX(),
				me().getY());

		HashSet<worldModel.Blockade> badBlockadesInRange = new HashSet<worldModel.Blockade>();
		badBlockadesInRange.addAll(getBlocksInRange(clearDist));

		HashSet<worldModel.Blockade> badBlockadesNearMe = getBadBlockades(
				firstPoint, endPoint, rad,
				worldModel.getTrafficSimulator().geom); // TODO: firstPoint or
														// myPos?

		// LineSegment ls = new LineSegment(firstPoint, endPoint);

		LineSegment ls = GeometryTools.getClearLineSegment(myHum(),
				(int) endPoint.x, (int) endPoint.y, clearDist - rad, clearRad,
				worldModel.getTrafficSimulator().geom); // TODO:
														// clearLine
														// or
														// guideLine?
														// log("MyPOS:
														// " +
														// GeometryTools.printCircle(me().getX(),
														// me().getY(),
														// rad));
		// log("ClearLine: " + GeometryTools.printLine(ls));

		int SecureDist = rad + rad / 2;
		// if (lastCycleOfMoveBeforeBlocade == time -1)
		// SecureDist = rad * 10 + rad / 2;
		// else
		// SecureDist = rad * 2;

		if (distToBlock < SecureDist
				&& nearestBlock.mainShape.intersects(ls.toGeometry(worldModel
						.getTrafficSimulator().geom))) {
			shouldMoveToGuidline(path); // TODO: ?
			clearAreaComputation(endPoint, nearestBlock);
		}

		// Geometry area = GeometryTools.getClearArea(myHum(), (int) endPoint.x,
		// (int) endPoint.y, (int) clearDist - clearRad,
		// (int) clearRad - 750, worldModel.getTrafficSimulator().geom);
		// log("clear rectangle: " + GeometryTools.printShape(area));
		//
		// double surface = area.getArea();
		// double surfaceMostatil = surface;
		//
		// for (worldModel.Blockade b : badBlockadesInRange) {
		// area = area.buffer(0).difference(b.mainShape.buffer(0));
		// }
		// surface = surface - area.getArea();
		// // log("surface: " + surface);
		// // log(" surfaceMostatil / 2 " + surfaceMostatil / 2);
		// // double ourRate = surface * REPAIR_COST_FACTOR;
		// // log("Our Rate " + ourRate);
		//
		// if (surface >= surfaceMostatil / 2) { // TODO: naaa! Not right :))
		// log("OUR_RATE > KEY");
		// shouldMoveToGuidline(path);
		// clearAreaComputation(endPoint, nearestBlock);

		Geometry area = GeometryTools.getClearArea(myHum(), (int) endPoint.x,
				(int) endPoint.y, (int) clearDist - clearRad / 2,
				(int) clearRad - 750, worldModel.getTrafficSimulator().geom);
		// log("clear rectangle: " + GeometryTools.printShape(area));

		double surface = area.getArea();
		double ourRate;

		try {
			for (worldModel.Blockade b : badBlockadesInRange) {
				area = area.buffer(0).difference(b.mainShape.buffer(0));
				// log("Diffrence: " + GeometryTools.printShape(area));
			}
			surface = surface - area.getArea();
			ourRate = surface * REPAIR_COST_FACTOR + 0.2;
		} catch (Exception e) {
			e.printStackTrace();
			if (logger.getWriter() != null)
				e.printStackTrace(logger.getWriter());
			ourRate = REPAIR_RATE_KEY;
		}

		// log("our Rate: " + ourRate);
		if (ourRate >= REPAIR_RATE_KEY) {
			shouldMoveToGuidline(path);
			clearAreaComputation(endPoint, nearestBlock);
		} else {
			ArrayList<EntityID> pathID = new ArrayList<EntityID>();
			for (Area a : path)
				pathID.add(a.getID());

			// log("ClearLine: " +
			// GeometryTools.printShape(ls.toGeometry(worldModel.getTrafficSimulator().geom)));

			boolean isEven = true;
			boolean haveIntersection = false;
			int intersectPointNum = 0;
			HashSet<worldModel.Blockade> blocksOnWay = new HashSet<worldModel.Blockade>();

			LineSegment agentWay = new LineSegment(ls.p0, scaleEndPoint(ls.p0,
					ls.p1, ls.getLength() - rad));

			agentWay = new LineSegment(agentWay.p1, scaleEndPoint(ls.p1, ls.p0,
					ls.getLength() - rad));

			//
			// ls = new LineSegment(ls.p1, scaleEndPoint(ls.p1, ls.p0,
			// ls.getLength() + rad)); // az do taraf scale she.
			//
			// log("LS buffered "
			// + GeometryTools.printShape(agentWay.toGeometry(
			// worldModel.getTrafficSimulator().geom).buffer(rad)));

			for (worldModel.Blockade b : badBlockadesNearMe) {
				// log("Circum: "
				// + GeometryTools.printShape(b.circumstance.buffer(0), 0));

				if (b.mainShape
						.buffer(0)
						.getBoundary()
						.intersects(
								agentWay.toGeometry(
										worldModel.getTrafficSimulator().geom)
										.buffer(rad))) {
					haveIntersection = true;
					blocksOnWay.add(b);

					intersectPointNum = b.mainShape
							.buffer(0)
							.getBoundary()
							.intersection(
									ls.toGeometry(worldModel
											.getTrafficSimulator().geom))
							.getNumPoints();

					if (intersectPointNum % 2 != 0) {
						isEven = false;
						break;
					}
				} // TODO: ls shayad intersection nadashte bashe vali bufer
					// shodash dashte bashe! (shayad agent natune rad she vali
					// intersection ham nadashte bashe) #cantExplainWell :)) -->
					// Circumstance Or MainShape?
					// if circumstance intersects -> line+rad
					// intersectionsPointsnums with circusm
			}

			if (haveIntersection && isEven) {
				shouldMoveToGuidline(path);
				clearAreaComputation(endPoint, nearestBlock);
			}

			// if (commandHistory.get(time - 1).getAction() ==
			// StandardMessageURN.AK_MOVE
			// && haveIntersection && !isEven) {
			// clearAreaComputation(endPoint, nearestBlock);
			// }

			// if (haveIntersection && intersectPointNum != 0) {
			// if (!isEven) {
			// log("Not Even!!");
			// moveBeforeBlockade(target, firstPoint, endPoint, rad,
			// pathID);
			// } else {
			// log("Even!!");
			// shouldMoveToGuidline(path);
			// clearAreaComputation(endPoint, nearestBlock);
			// }
			// }
			// log("End.");
			// moveForPolice(target, (int) targCoordinate.x,
			// (int) targCoordinate.y, true, pathID);
		}
	}

	private ArrayList<worldModel.Blockade> getRealBlocksInRange(Entrance en1,
			Entrance en2) {
		ArrayList<worldModel.Blockade> blocks = new ArrayList<worldModel.Blockade>();
		ArrayList<Coordinate> coords = new ArrayList<Coordinate>();
		coords.add(en1.lineSegment.getCoordinate(0));
		coords.add(en1.lineSegment.getCoordinate(1));
		coords.add(en2.lineSegment.getCoordinate(0));
		coords.add(en2.lineSegment.getCoordinate(1));
		coords.add(en1.lineSegment.getCoordinate(0));
		Coordinate[] coordinates = { en1.lineSegment.getCoordinate(0),
				en1.lineSegment.getCoordinate(1),
				en2.lineSegment.getCoordinate(0),
				en2.lineSegment.getCoordinate(1) };
		for (worldModel.Blockade b : worldModel.getTrafficSimulator()
				.getBlockadesInRange(GeometryTools.makeRectangle(coordinates))) {
			Geometry mostatil = GeometryTools.createPolygon(coords);
			if (b.mainShape.intersects(mostatil)) {
				blocks.add(b);
			}
		}
		return blocks;
	}

	public void SclearNeareastBlock() throws ActionCommandException {
		updateLastBlock();
		if ((lastBlock == null || !lastBlock.isContain(worldModel
				.getArea(lastBlock.blockade.getPosition()).blockades))) {
			ArrayList<worldModel.Blockade> blockList = getBlocksInRange(1500);
			double minDist = Integer.MAX_VALUE;
			for (worldModel.Blockade b : blockList)
				if (findDistanceTo(b.blockade, this.getX(), this.getY()) < minDist) {
					minDist = findDistanceTo(b.blockade, this.getX(),
							this.getY());
					lastBlock = b;
				}
		}
		if (lastBlock == null)
			return;
		ArrayList<worldModel.Blockade> pathsBlock = getRealBlockInShape(
				new Coordinate(this.getX(), this.getY()), new Coordinate(
						lastBlock.blockade.getX(), lastBlock.blockade.getY()));
		if ((pathsBlock.size() == 1 && pathsBlock.get(0).getID().getValue() == lastBlock
				.getID().getValue()) || pathsBlock.size() == 0) {
			Sclear(lastBlock);
		} else {
			worldModel.Blockade nearest = lastBlock;
			int minDist = Integer.MAX_VALUE;
			for (worldModel.Blockade b : pathsBlock)
				if (findDistanceTo(b.blockade, this.getX(), this.getY()) < minDist) {
					minDist = (int) findDistanceTo(b.blockade, this.getX(),
							this.getY());
					nearest = b;
				}
			Sclear(nearest);
		}
	}

	private Vector2D rotate(double theta, Vector2D v) {
		double Deg2Rad = Math.PI / 180;
		theta = theta * Deg2Rad;
		double s = Math.sin(theta);
		double c = Math.cos(theta);
		double x = v.getX() * c - v.getY() * s;
		double y = v.getY() * c + v.getX() * s;
		Vector2D vector = new Vector2D(x, y);
		return vector;
	}

	private ArrayList<worldModel.Blockade> getRealBlockInShape(
			Coordinate endPoint, Coordinate startPoint) {
		// log("ep: " + endPoint + " sp: " + startPoint);
		double rad_clear = 1240.0;
		ArrayList<worldModel.Blockade> blocks = new ArrayList<worldModel.Blockade>();

		Vector2D enteghalV = new Vector2D(startPoint.x - endPoint.x,
				startPoint.y - endPoint.y);
		Vector2D v = (rotate(90, enteghalV.normalised())).normalised().scale(
				rad_clear);

		Coordinate rightUp = new Coordinate(endPoint.x + v.getX(), endPoint.y
				+ v.getY());
		Coordinate rightDown = new Coordinate(endPoint.x - v.getX(), endPoint.y
				- v.getY());
		Coordinate leftUp = new Coordinate(rightUp.x + enteghalV.getX(),
				rightUp.y + enteghalV.getY());
		Coordinate leftDown = new Coordinate(rightDown.x + enteghalV.getX(),
				rightDown.y + enteghalV.getY());
		ArrayList<Coordinate> coords = new ArrayList<Coordinate>();
		coords.add(leftDown);
		coords.add(leftUp);
		coords.add(rightUp);
		coords.add(rightDown);
		coords.add(leftDown);
		Coordinate[] coordinate = { leftDown, leftUp, rightUp, rightDown };
		Geometry mostatil = GeometryTools.createPolygon(coords);
		for (worldModel.Blockade b : worldModel.getTrafficSimulator()
				.getBlockadesInRange(GeometryTools.makeRectangle(coordinate))) {
			if (b.mainShape.intersects(mostatil)) {
				blocks.add(b);
			}
		}
		return blocks;
	}

	private double findDistanceTo(Blockade b, int x, int y) {
		List<Line2D> lines = GeometryTools2D.pointsToLines(
				GeometryTools2D.vertexArrayToPoints(b.getApexes()), true);
		double best = Integer.MAX_VALUE;
		Point2D origin = new Point2D(x, y);
		for (Line2D next : lines) {
			Point2D closest = GeometryTools2D.getClosestPointOnSegment(next,
					origin);
			double d = GeometryTools2D.getDistance(origin, closest);
			if (d < best)
				best = d;
		}
		return best;
	}

	// check that
	private void move(ArrayList<worldModel.Area> p, int x, int y,
			boolean dijkstra) throws ActionCommandException {
		ArrayList<EntityID> path = new ArrayList<EntityID>();
		for (worldModel.Area a : p)
			path.add(a.getID());
		move(path, x, y, dijkstra);
	}

	private void clearArea(int x, int y) throws ActionCommandException {
		sendClearArea(time, x, y);
		ActionCommandException ace = new ActionCommandException(
				StandardMessageURN.AK_CLEAR_AREA);
		throw ace;
	}

	@SuppressWarnings("unused")
	private void clear(worldModel.Area target) throws ActionCommandException {
		ArrayList<EntityID> way = worldModel.getMinPathDijk(target.getID(),
				false, true, worldModel, myHum());
		if (way == null || way.size() == 0) {
			way = new ArrayList<EntityID>();
			way.add(getMyPos().getID());
		}

		ArrayList<worldModel.Blockade> wayBlocks = new ArrayList<worldModel.Blockade>();
		for (EntityID a : way) {
			Area area = worldModel.getArea(a);
			if (area.isBlockadesDefined() && area.blockades.size() > 0) {
				wayBlocks.addAll(area.blockades);
			}
			Entrance entrance = null;
			if (way.indexOf(area) <= way.size() - 2) {
				for (Entrance e : area.entrances) {
					if (e.neighbour.area.getID().getValue() == way.get(
							way.indexOf(area) + 1).getValue()) {
						entrance = e;
						break;
					}
				}
				if (!entrance.isItConnectedToNeighbour) {
					wayBlocks.addAll(getRealBlocksInRange(entrance,
							entrance.neighbour));
				}
			}
		}
		if (wayBlocks.size() > 0) {
			worldModel.Blockade nearBlock = null;
			int minDistance = Integer.MAX_VALUE;
			for (worldModel.Blockade b : wayBlocks) {
				if (minDistance > getDistance(b.blockade.getX(),
						b.blockade.getY())) {
					minDistance = getDistance(b.blockade.getX(),
							b.blockade.getY());
					nearBlock = b;
				}
			}
			Sclear(nearBlock);
		}
		moveForPolice(target, target.getX(), target.getY(), true);
	}

	protected void searchFireTemp(ArrayList<worldModel.Building> buildings)
			throws ActionCommandException {
		worldModel.Building target = null;
		double minDist = Integer.MAX_VALUE;
		for (worldModel.Building building : buildings) {
			double dist = 0;
			dist = Math.hypot(searchAround.getX() - building.getX(),
					searchAround.getY() - building.getY());
			// log("bui: " + building + " dist: " + dist);
			if (minDist > dist) {
				minDist = dist;
				target = building;
			}
		}
		if (target == null)
			return;

		((PoliceForceAgent) this).moveToFireForPolice(target);
	}

	protected void searchFire(Building target) throws ActionCommandException {
		moveToFireForPolice(target);
	}

	protected int getDistToFireForPolice(Building building) {
		int minDist = Integer.MAX_VALUE;
		TreeSet<Road> roads = new TreeSet<Road>(new Comparator<Road>() {
			public int compare(Road r1, Road r2) {
				if (r1.distFromeSelfWOB < r2.distFromeSelfWOB)
					return -1;
				if (r1.distFromeSelfWOB > r2.distFromeSelfWOB)
					return 1;
				if (r1.getID().getValue() > r2.getID().getValue())
					return 1;
				if (r1.getID().getValue() < r2.getID().getValue())
					return -1;
				return 0;
			}
		});
		roads.addAll(building.getVisionRoads(worldModel).keySet());
		done: for (Road road : roads) {
			for (Coordinate point : building.getVisionRoads(worldModel).get(
					road)) {
				boolean i = true;
				for (worldModel.Blockade blockade : road.blockades)
					if (blockade.circumstance.contains(GeometryTools
							.coordToGeometry(point,
									worldModel.getTrafficSimulator().geom))) {
						i = false;
						break;
					}

				if (i == true) {
					if (me().getPosition().getValue() == road.getID()
							.getValue())
						return 1;
					minDist = road.distFromeSelfWOB;
					break done;
				}
			}
		}
		for (Building buil : building.visionBuildings.keySet()) {
			if (me().getPosition().getValue() == buil.getID().getValue())
				return 1;
			if (buil.distFromeSelfWOB < minDist)
				minDist = buil.distFromeSelfWOB;
			break;
		}
		if (minDist == Integer.MAX_VALUE)
			return 1000;
		return minDist;
	}

	protected void moveToFireForPolice(Building target)
			throws ActionCommandException {
		initMoveToFireComputation();
		worldModel.clearTargets();

		initMoveToFire();

		boolean isSecondTime = false;
		for (int i = 0; i < 2; i++) {
			for (Road road : target.getVisionRoads(worldModel).keySet()) {
				if ((!isSecondTime && !road.isGoodForFireSearch)
						|| !road.canBeVisited) {
					continue;
				}
				for (int j = 0; j < target.getVisionRoads(worldModel).get(road)
						.size(); j++) {
					double dist = Math.hypot(me().getX()
							- target.getVisionRoads(worldModel).get(road)
									.get(j).x, me().getY()
							- target.getVisionRoads(worldModel).get(road)
									.get(j).y);

					if (dist < worldModel.getTrafficSimulator().agentRad
							&& !worldModel.isInChangeSet(target.getID())) {
						target.getVisionRoads(worldModel).get(road).remove(j);
						if (target.getVisionRoads(worldModel).get(road).size() == 0) {

							target.getVisionRoads(worldModel).remove(road);
						}
						target.buildingReachabilityCalculated = false;
						fastClearPath(target, target.getX(), target.getY());

					}

					if (me().getPosition().getValue() == road.getID()
							.getValue()) {
						fastClearPath(
								road,
								((int) target.getVisionRoads(worldModel)
										.get(road).get(j).x), ((int) target
										.getVisionRoads(worldModel).get(road)
										.get(j).y));

					}
					road.setAreaAsTarget(true);
					break;
				}
			}
			isSecondTime = true;
		}
		for (Building building : target.visionBuildings.keySet()) {
			if (building.stFire == 0 && building.canBeVisited) {
				double dist = Math.hypot(
						me().getX() - target.visionBuildings.get(building).x,
						me().getY() - target.visionBuildings.get(building).y);

				if (dist < worldModel.getTrafficSimulator().agentRad
						&& !worldModel.isInChangeSet(target.getID())) {
					target.visionBuildings.remove(building);
					target.buildingReachabilityCalculated = false;
					fastClearPath(target, target.getX(), target.getY());
				}

				if (me().getPosition().getValue() == building.getID()
						.getValue()) {
					ArrayList<EntityID> path = new ArrayList<EntityID>();
					path.add(building.getID());
					Coordinate end = new Coordinate(
							(int) target.visionBuildings.get(building).x,
							(int) target.visionBuildings.get(building).y);
					fastClearPath(target, (int) end.x, (int) end.y);
				}
				building.setAreaAsTarget(true);
			}
		}

		int x = -1, y = -1;

		ArrayList<EntityID> path = worldModel.getMinPathDijk(false, true,
				worldModel, myHum());
		if (path == null || path.size() == 0) {
			// System.err.println("BAD Situation " + me().getID());
			randomWalk(false);

		}
		isSecondTime = false;
		for (int i = 0; i < 2; i++) {
			for (Road r : target.getVisionRoads(worldModel).keySet()) {
				if (!isSecondTime && !r.isGoodForFireSearch)
					continue;
				if (path.get(path.size() - 1).getValue() == r.getID()
						.getValue()) {
					for (int j = 0; j < target.getVisionRoads(worldModel)
							.get(r).size(); j++) {
						x = (int) target.getVisionRoads(worldModel).get(r)
								.get(j).x;
						y = (int) target.getVisionRoads(worldModel).get(r)
								.get(j).y;

						// bug server
						if (me().getX() == x && me().getY() == y
								&& !worldModel.isInChangeSet(target.getID())) {
							act();
						}
						Coordinate end = new Coordinate(x, y);
						if (me().getPosition().getValue() != r.getID()
								.getValue()) {
							fastClearPath(r, r.getX(), r.getY());
						} else {
							worldModel.Blockade b = findBlockForFireSearch(
									end.x, end.y);
							if (b == null) {
								isInMoveToFire = true;
								move(r, x, y, false);
							}
							fastClearPath(r, x, y);
						}
					}
				}
			}
			isSecondTime = true;
		}
		for (Building b : target.visionBuildings.keySet())
			if (b.stFire == 0
					&& path.get(path.size() - 1).getValue() == b.getID()
							.getValue()) {
				x = (int) target.visionBuildings.get(b).x;
				y = (int) target.visionBuildings.get(b).y;
				Coordinate end = new Coordinate(x, y);
				if (me().getPosition().getValue() != b.getID().getValue()) {
					fastClearPath(b, b.getX(), b.getY());
				} else {
					worldModel.Blockade block = findBlockForFireSearch(end.x,
							end.y);
					if (block == null) {
						isInMoveToFire = true;
						move(b, x, y, false);
					}
					fastClearPath(b, x, y);
				}
			}
	}

	protected worldModel.Blockade findBlockForFireSearch(double x, double y) {
		Coordinate myPos = new Coordinate(me().getX(), me().getY());
		Coordinate nextPoint = new Coordinate(x, y);
		HashSet<worldModel.Blockade> blocks = getMyPos().getBadBlockades(myPos,
				nextPoint, worldModel.getTrafficSimulator().agentRad,
				worldModel.getTrafficSimulator().geom);

		if (blocks.size() == 0)
			return null;
		double min = Integer.MAX_VALUE, dist;
		worldModel.Blockade nearest = null;
		for (worldModel.Blockade b : blocks) {
			dist = findDistanceTo(b.blockade, me().getX(), me().getY());
			if (dist < min) {
				min = dist;
				nearest = b;
			}
		}
		return nearest;
	}

	protected boolean policeBuildingReachability(Building b) {
		if (b.buildingReachabilityCalculated)
			return b.buildingReachability;
		if (worldModel.isInChangeSet(b.getID()) && !IamOnfire
				&& b.hasGoodVisionPointPolice(worldModel)) {
			b.buildingReachability = true;
			return true;
		}
		if (b.getVisionRoads(worldModel).size() == 0
				&& b.visionBuildings.size() == 0) {
			b.buildingReachability = false;
			return false;
		}
		if (b.isReachable && !IamOnfire
				&& b.hasGoodVisionPointPolice(worldModel)) {
			b.buildingReachability = true;
			return true;
		}
		if (b.getVisionRoads(worldModel).size() > 0) {
			b.buildingReachability = true;
			return true;
		}
		for (Building build : b.visionBuildings.keySet())
			if (build.stFire == 0) {
				b.buildingReachability = true;
				return true;
			}
		b.buildingReachability = false;
		return false;
	}

	public boolean IamOnfire = false;

	public void setIamOnFire() {
		IamOnfire = false;
		Area myPos = getMyPos();
		if (myPos instanceof Building && ((Building) myPos).isOnFire())
			IamOnfire = true;
	}
}