package agent;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Random;

import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Civilian;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.Road;
import rescuecore2.worldmodel.Entity;
import worldModel.Area;
import worldModel.WorldModel;

public class State {
	private WorldModel worldModel;
	private int fitness = 0;
	public int time = 0;
	public HashMap<AmbulanceTeam, Integer> lastSetTime = new HashMap<AmbulanceTeam, Integer>();
	public HashMap<AmbulanceTeam, worldModel.Area> lastSetPos = new HashMap<AmbulanceTeam, worldModel.Area>();
	public ArrayList<TaskAssign> tasks = new ArrayList<TaskAssign>();
	private Random random = new Random(50000);

	public State(WorldModel worldModel) {
		this.worldModel = worldModel;
	}

	public int getFitness() {
		if (fitness > 0)
			return fitness;
		else {
			for (TaskAssign t : tasks)
				if (t.human instanceof Civilian)
					fitness += 1;
				else
					fitness += 200;
			return fitness;
		}
	}

	public void generateRandom(int num, ArrayList<Human> humans,
			HashMap<AmbulanceTeam, HashMap<worldModel.Area, Integer>> map) {
		while (humans.size() > 0) {
			int rnd = random.nextInt(Math.min(10, humans.size()));
			Human h = humans.remove(rnd);
			/*if (h.isPositionDefined()
					&& h.getPosition().getValue() == 72021) {
				boolean a = false;
				if (h.isBuriednessDefined()
						&& h.deadtime > time
						+ (h.getBuriedness() / num))
					a = true;
				if (h.isBuriednessDefined() && time < 60)
					System.out.println("~~~~~~" + time + "   DT:"
							+ h.deadtime + "   Bury:" + h.getBuriedness()
							+ "   savernum:" + num + "   Final:" + a);
			}*/
			if (!goodEnough(h, num)) {
				continue;
			} else {
				// System.out.println("miam injaaaa asan???" + time);
				TaskAssign jadid = new TaskAssign();
				ArrayList<Integer> cTime = new ArrayList<Integer>();
				jadid.human = h;
				// System.out.println("human: " + h.getID().getValue());
				for (int j = 0; j < num; j++) {
					int minTime = Integer.MAX_VALUE;
					AmbulanceTeam minTAmb = null;
					for (AmbulanceTeam amb : lastSetTime.keySet()) {
						if (!amb.hasBuriedness
								// TODO:set isalive koja neveshte beshe?

								&& amb.isAlive
								&& !map.get(amb).containsKey(
										(worldModel.getArea(h.getPosition())))
								&& !jadid.ambs.contains(amb)
								&& h.distance.containsKey(lastSetPos.get(amb))) {
							// System.out.println("hame sharta ok" + amb);
							int currentTime = (int) (lastSetTime.get(amb) + h.distance
									.get(lastSetPos.get(amb)));
							if (currentTime < minTime) {
								minTime = currentTime;
								minTAmb = amb;
							}
						}
					}
					if (minTAmb == null) {
						// System.out.println("mintamb nulle");
						break;
					}
					cTime.add(minTime);
					jadid.ambs.add(minTAmb);
				}

				boolean isValid = false;
				int s = jadid.human.getBuriedness();
				for (int i = 0; i < jadid.ambs.size(); i++) {
					s -= h.deadtime - (cTime.get(i));
					if (s <= 0) {
						isValid = true;
						for (int j = i + 1; j < jadid.ambs.size(); j++) {
							jadid.ambs.remove(j);
							cTime.remove(j);
							j--;
						}
					}
				}
				if (isValid) {
					int b = jadid.human.getBuriedness();
					int size = jadid.ambs.size();
					for (int i = 1; i < size; i++) {
						b -= (cTime.get(i) - cTime.get(i - 1)) * i;
					}
					// TODO:check beshe
					Collections.sort(jadid.ambs, IDcomparator);
					for (int i = 0; i < size; i++) {
						AmbulanceTeam a = jadid.ambs.get(i);
						if (i < b % size)
							lastSetTime.put(a, lastSetTime.get(a)
									+ (b / size + 1));
						else
							lastSetTime.put(a, lastSetTime.get(a) + (b / size));
						jadid.time.add(lastSetTime.get(a));
						lastSetPos.put(a,
								((rescuecore2.standard.entities.Area) h
										.getPosition(worldModel)).area);
					}
					// /***
					if (jadid.human instanceof Civilian) {
						int toRefuge = Integer.MAX_VALUE;
						Area minDis = null;
						if (worldModel.refuges.size() == 0) {
							for (Area ali : h.distance.keySet()) {
								if (ali instanceof worldModel.Road
										&& h.distance.get(ali) < toRefuge) {
									toRefuge = h.distance.get(ali);
									if (toRefuge == 0)
										toRefuge = 1;
									minDis = ali;
								}
							}
							/*
							 * if (h.getID().getValue() == 2100539502)
							 * System.out.println("minDis   " + minDis +
							 * "---torefuge    " + toRefuge + "---human    " + h
							 * + "--" + h.getPosition() + "---neighbor    " +
							 * worldModel.getArea(h.getPosition())
							 * .getNeighbours() + "---keyset   " +
							 * h.distance.keySet());
							 */
						} else {
							for (Area arr : h.distance.keySet())
								if (arr instanceof worldModel.Refuge
										&& h.distance.get(arr) < toRefuge) {
									toRefuge = h.distance.get(arr);
									minDis = (worldModel.Refuge) arr;
								}
						}
						if (toRefuge < Integer.MAX_VALUE) {
							lastSetTime.put(jadid.ambs.get(0),
									lastSetTime.get(jadid.ambs.get(0))
											+ toRefuge);
							lastSetPos.put(jadid.ambs.get(0), minDis);
							jadid.time.set(0,
									lastSetTime.get(jadid.ambs.get(0)));
						}
					}
					tasks.add(jadid);
					// System.out.println("TASK!!:" + jadid.human + "  "
					// + jadid.ambs);
				}
			}
		}

	}

	private Comparator<Entity> IDcomparator = new Comparator<Entity>() {
		public int compare(Entity a1, Entity a2) {
			if (a1.getID().getValue() > a2.getID().getValue())
				return 1;
			if (a1.getID().getValue() < a2.getID().getValue())
				return -1;
			return 0;
		}
	};

	private boolean goodEnough(Human h, int saverNum) {
		if ((h.hasBuriedness || h instanceof Civilian)
				&& h.isPositionDefined()
				&& !isOnFire(worldModel.getEntity(h.getPosition()))
				&& h.deadtime > time
				&& (worldModel.getEntity(h.getPosition()) instanceof Building || (worldModel
						.getEntity(h.getPosition()) instanceof Road
						&& h.isDamageDefined() && h.getDamage() != 0))
				&& !isInRefuge(h)) {
			if (h.deadtime > time + (h.getBuriedness() / saverNum)) {
				return true;
			}
		}
		return false;
	}

	// public boolean isOnFire2(Entity building) {
	// if (building instanceof Building
	// && ((Building) building).isFierynessDefined()
	// && ((Building) building).getFieryness() != 0
	// && ((Building) building).getFieryness() != 5)
	// return true;
	// return false;
	// }

	public boolean isOnFire(Entity building) {
		if (building instanceof Building
				&& ((((Building) building).isFierynessDefined() && ((Building) building)
						.getFieryness() > 0) || ((worldModel.Building) ((Building) building).area).stFire == 1))
			return true;
		return false;
	}

	public boolean isInRefuge(Human h) {
		if (worldModel.getEntityByInt(h.getPosition().getValue()) instanceof Refuge)
			return true;
		return false;
	}
}
