package radar;

import java.util.ArrayList;
import java.util.BitSet;

public class Calulations {

	public static byte[] toByteArray(BitSet bits) {
		byte[] bytes = new byte[bits.length() / 8 + 1];
		for (int i = 0; i < bits.length(); i++) {
			if (bits.get(i)) {
				bytes[bytes.length - i / 8 - 1] |= 1 << (i % 8);
			}
		}
		return bytes;
	}

	public static BitSet fromByteArray(byte[] bytes) {
		BitSet bits = new BitSet();
		for (int i = 0; i < bytes.length * 8; i++) {
			if ((bytes[bytes.length - i / 8 - 1] & (1 << (i % 8))) > 0) {
				bits.set(i);
			}
		}
		return bits;
	}

	static int calcWithBitSet(BitSet bits, int num, int start, int powNumber) {
		int end = start + powNumber;
		ArrayList<Integer> inBase2 = toBase2(num);
		int subtract = powNumber - inBase2.size();
		for (int i = 0; i < inBase2.size(); i++)
			if (inBase2.get(i) == 1)
				bits.set(i + start + subtract, true);
		return end;
	}

	static ArrayList<Integer> toBase2(int num) {
		ArrayList<Integer> remainings = new ArrayList<Integer>();
		ArrayList<Integer> inBase2 = new ArrayList<Integer>();
		int distributed = num;
		while (distributed >= 2) {
			remainings.add(distributed % 2);
			distributed = distributed / 2;
		}
		remainings.add(distributed);
		for (int i = remainings.size() - 1; i >= 0; i--) {
			inBase2.add(remainings.get(i));
		}
		return inBase2;
	}

	public static int fromBase2(BitSet bits, int start, int powNumber) {
		int num = 0;
		for (int i = start; i < start + powNumber; i++)
			if (bits.get(i) == true)
				num = num + (int) Math.pow(2, (start + powNumber - i - 1));
		return num;
	}

	public static int findPow(int amount) {
		double i = Math.log(amount) / Math.log(2);
		if ((int) i == i)
			return (int) i;
		else
			return (int) i + 1;
	}
}
