package rescuecore2.standard.entities;

import java.util.ArrayList;

import rescuecore2.worldmodel.Entity;
import rescuecore2.worldmodel.EntityID;
import worldModel.Area;
import worldModel.Building;
import worldModel.Refuge;
import agent.FireTask;

/**
 * The PoliceForce object.
 */
public class PoliceForce extends Human {

	public FireTask fireTask = null;
	public FireTask realFireTask = null;
	public FireTask lastFireTask = null;

	public Area stuckTarget = null;
	public Area lastStuckTarget = null;
	public int groupNum = -1;
	
	public Refuge refugeTarget = null;
	public Refuge lastRefugeTarget = null;

	public ArrayList<Building> searchAroundZoneBuilds = new ArrayList<Building>();

	/**
	 * Construct a PoliceForce object with entirely undefined values.
	 * 
	 * @param id
	 *            The ID of this entity.
	 */
	public PoliceForce(EntityID id) {
		super(id);
	}

	/**
	 * PoliceForce copy constructor.
	 * 
	 * @param other
	 *            The PoliceForce to copy.
	 */
	public PoliceForce(PoliceForce other) {
		super(other);
	}

	@Override
	protected Entity copyImpl() {
		return new PoliceForce(getID());
	}

	@Override
	public StandardEntityURN getStandardURN() {
		return StandardEntityURN.POLICE_FORCE;
	}

	@Override
	protected String getEntityName() {
		return "Police force";
	}
}
