package shapeReconstruction;

public class MathUtil {
	public static double pointDistance(Point p1, Point p2) {
		/* 8 */double dx = p1.x - p2.x;
		/* 9 */double dy = p1.y - p2.y;
		/* 10 */return Math.sqrt(dx * dx + dy * dy);
	}

	public static boolean pointInTriangle(Point p, Triangle t) {
		/* 14 */return pointInTriangle(p, t.p1, t.p2, t.p3);
	}

	public static boolean pointInTriangle(Point p, Point t1, Point t2, Point t3) {
		/* 49 */double b0 = (t2.x - t1.x) * (t3.y - t1.y) - (t3.x - t1.x) * (
		/* 50 */t2.y - t1.y);
		/* 51 */double b1 = ((t2.x - p.x) * (t3.y - p.y) - (t3.x - p.x)
				* (t2.y - p.y))
				/
				/* 52 */b0;
		/* 53 */double b2 = ((t3.x - p.x) * (t1.y - p.y) - (t1.x - p.x)
				* (t3.y - p.y))
				/
				/* 54 */b0;
		/* 55 */double b3 = ((t1.x - p.x) * (t2.y - p.y) - (t2.x - p.x)
				* (t1.y - p.y))
				/
				/* 56 */b0;

		/* 58 */if ((b1 > 0.0D) && (b2 > 0.0D) && (b3 > 0.0D)) {
			/* 60 */return true;
		}

		/* 63 */return false;
	}

	public static boolean pointOnRightSideOfEdge(Edge edge, Point point) {
		/* 67 */return inClockWiseOrder(edge.start, edge.end, point);
	}

	public static boolean inClockWiseOrder(Point start, Point mid, Point end) {
		/* 71 */double e1x = start.x - mid.x;
		/* 72 */double e1y = start.y - mid.y;
		/* 73 */double e2x = end.x - mid.x;
		/* 74 */double e2y = end.y - mid.y;

		/* 76 */if (e1x * e2y - e1y * e2x >= 0.0D) {
			/* 77 */return true;
		}
		/* 79 */return false;
	}

	public static boolean pointInCircle(Point point, Circle circle) {
		if (pointDistance(point, circle.center) >= circle.radius) {
			return false;
		}
		return true;
	}

	public static Circle[] createCircles(Point p1, Point p2, double radius) {
		// int r = 1500;
		if (p1.equals(p2)) {
			// System.err.println("Equal!");
			return null;
		}

		if (radius == 0.0D) {
			System.err.println("R=0");
			return null;
		}

		/* 113 */Circle[] circles = new Circle[2];

		/* 115 */double pointDistance = pointDistance(p1, p2);

		/* 121 */double halfDistance = pointDistance / 2.0D;

		/* 123 */double midPointX = (p1.x + p2.x) / 2.0D;
		/* 124 */double midPointY = (p1.y + p2.y) / 2.0D;
		int m = 0;
		double move = radius * radius - halfDistance * halfDistance;
		while (m < 100) {
			if (move < 0.0D) {
				// System.out.println("RADIUS: " + radius);
				// System.out.println("rad: " + radius + " dis: " +
				// halfDistance);
				radius += 40000;
				move = radius * radius - halfDistance * halfDistance;
				m++;
			} else
				break;
		}
		if (move < 0.0D) {
			System.err.println("Move<0");
			return null;
		}

		double moveOnPerpendicular = Math.sqrt(move);

		double xDirection = p1.y - p2.y;
		/* 147 */double yDirection = p2.x - p1.x;

		/* 149 */double x = midPointX + moveOnPerpendicular * xDirection /
		/* 150 */pointDistance;
		/* 151 */double y = midPointY + moveOnPerpendicular * yDirection /
		/* 152 */pointDistance;

		/* 156 */circles[0] = new Circle(x, y, radius);

		/* 158 */x = midPointX - moveOnPerpendicular * xDirection
				/ pointDistance;
		/* 159 */y = midPointY - moveOnPerpendicular * yDirection
				/ pointDistance;

		/* 161 */circles[1] = new Circle(x, y, radius);
		/* 162 */return circles;
	}

	public static Circle createCircle(Point p1, Point p2, Point p3) {
		/* 169 */return null;
	}

	public static Edge perpendicularEdge(Point p1, Point p2) {
		/* 182 */return null;
	}

	public static long nanosecondsInMilliseconds(double nanoseconds) {
		/* 186 */return Math.round(nanoseconds / 1000000.0D);
	}
}