package shapeReconstruction;

public class Point {
	public double x;
	public double y;

	public worldModel.Building building = null;

	public Point(Point p) {
		this.x = p.x;
		this.y = p.y;
	}

	public Point(double x, double y) {
		this.x = x;
		this.y = y;
	}

	public Point(double x, double y, worldModel.Building v) {
		this.building = v;
		this.x = x;
		this.y = y;
	}

	public int getX() {
		return (int) this.x;
	}

	public int getY() {
		return (int) this.y;
	}

	public boolean equals(Object o) {
		return equals((Point) o);
	}

	public boolean equals(Point another) {
		if ((Math.abs(another.x - this.x) < 0.0001D)
				&& (Math.abs(another.y - this.y) < 0.0001D)) {
			return true;
		}

		return false;
	}

	public double distance(Point to) {
		double d = to.x - this.x;
		double d1 = to.y - this.y;
		return Math.sqrt(d * d + d1 * d1);
	}

	public String toString() {
		return "(" + this.x + ", " + this.y + ")";
	}

}
