package worldModel;

import java.util.ArrayList;

import rescuecore2.worldmodel.EntityID;

import com.vividsolutions.jts.geom.Coordinate;
import com.vividsolutions.jts.geom.Geometry;

public class Blockade {
	public rescuecore2.standard.entities.Blockade blockade = null;
	public Geometry circumstance = null;
	public Geometry shape = null;
	public Geometry mainShape = null;
	public int AGENT_RAD = -1;

	public Blockade(rescuecore2.standard.entities.Blockade blockade, int AGENT_RAD) {
		this.blockade = blockade;
		this.AGENT_RAD = AGENT_RAD;
		mainShape = GeometryTools.createPolygonFromApexes(blockade.getApexes());
		circumstance = mainShape.buffer(AGENT_RAD, 1);
		if (mainShape.getArea() > circumstance.getArea()) {
			fixBlockade();
		}
		shape = circumstance.buffer(10, 1);
	}

	private void fixBlockade() {
		ArrayList<Coordinate> coords = new ArrayList<Coordinate>();
		for (int i = 0; i < blockade.getApexes().length; i += 2)
			coords.add(new Coordinate(blockade.getApexes()[i], blockade
					.getApexes()[i + 1]));

		for (int i = 0; i < coords.size() - 1; i++)
			for (int j = i + 1; j < coords.size(); j++) {
				long x1 = (long) coords.get(i).x;
				long x2 = (long) coords.get(j).x;
				long y1 = (long) coords.get(i).y;
				long y2 = (long) coords.get(j).y;
				if (x1 == x2 && y1 == y2) {
					coords.remove(j);
					j--;
				}
			}
		coords.add(coords.get(0));
		// System.out.println("coords.size " + coords.size());
		// for (int i = 0; i < coords.size(); i++)
		// System.out.println(GeometryTools.printPoint(coords.get(i)));
		Geometry mainshape = GeometryTools.createPolygon(coords);
		Geometry circumstance = mainshape.buffer(AGENT_RAD, 1);
		int t = 0;
		ArrayList<Coordinate> newCoords = null;
		olagh: while (mainshape.getArea() > circumstance.getArea()
				|| !circumstance.contains(mainshape)) {
			if (t == 5) {
				break;
			}
			t++;
			for (int i = 0; i < coords.size() - 3; i++)
				for (int j = i + 2; j < coords.size() - 1; j++) {
					Coordinate c1 = coords.get(i);
					Coordinate c2 = coords.get(i + 1);
					Coordinate c3 = coords.get(j);
					Coordinate c4 = coords.get(j + 1);
					if ((c1.x != c4.x && c1.y != c4.y)
							&& GeometryTools.isIntersectBetweenLines(c1, c2,
									c3, c4)) {
						// System.out.println("line 1 "
						// + GeometryTools.printLine(new LineSegment(c1,
						// c2)));
						// System.out.println("line 2 "
						// + GeometryTools.printLine(new LineSegment(c3,
						// c4)));
						newCoords = new ArrayList<Coordinate>();
						for (int x = 0; x <= i; x++)
							newCoords.add(coords.get(x));
						for (int y = j; y >= i + 1; y--)
							newCoords.add(coords.get(y));
						for (int y = j + 1; y < coords.size(); y++)
							newCoords.add(coords.get(y));

						// newCoords.add(newCoords.get(0));
						// System.out
						// .println("newcoords.size " + newCoords.size());
						// for (int h = 0; h < newCoords.size(); h++)
						// System.out.println(GeometryTools
						// .printPoint(newCoords.get(h)));

						mainshape = GeometryTools.createPolygon(newCoords);
						circumstance = mainshape.buffer(AGENT_RAD, 1);
						// System.out.println("main shape "
						// + GeometryTools.printShape(mainshape));
						// System.out.println("circumstance "
						// + GeometryTools.printShape(circumstance));
						coords = newCoords;
						continue olagh;
					}
				}
		}
	}

	public EntityID getID() {
		return blockade.getID();
	}

	@Override
	public String toString() {
		return GeometryTools.printShape(mainShape);
	}

	public boolean isContain(ArrayList<Blockade> list) {
		boolean isContain = false;
		for (Blockade b : list)
			if (this.getID().getValue() == b.getID().getValue()) {
				isContain = true;
				break;
			}
		return isContain;
	}

}
