package worldModel;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map.Entry;

import rescuecore2.standard.entities.AmbulanceCentre;
import rescuecore2.standard.entities.FireStation;
import rescuecore2.standard.entities.PoliceOffice;
import rescuecore2.standard.entities.Road;
import rescuecore2.worldmodel.Entity;
import rescuecore2.worldmodel.EntityID;
import agent.FireBrigadeAgent;

import com.vividsolutions.jts.geom.Coordinate;

public class Building extends Area {
	private static final long serialVersionUID = -4945518194910849804L;
	public boolean checkedfortail = false;

	public boolean haveZone = false;
	public boolean visited = false;
	public int fireZoneNum = -1;
	public int lastFieryness = -1;
	public int stFire = 0;
	public int counterForSimulate = 0;
	public int timeOfStartOfFire = -1;
	public int lastFireness = 0;
	public boolean isSimulatedForFire = false;
	public int assigned = 0;
	public int sumlooked = 0;
	public boolean itWasSimulated = false;
	public boolean fireRisk = false;

	public int lasttimesearchtem = -1;

	public int falsebuildingReachabilityassigend = 0;

	public transient ArrayList<Building> nearNotIgnitedBuildings = new ArrayList<Building>();
	public transient int maxDistanceExtingiush = 0;
	public HashMap<Building, Coordinate> visionBuildings = new HashMap<Building, Coordinate>();
	public transient HashMap<worldModel.Road, ArrayList<Coordinate>> visionRoads = null;
	public HashMap<Integer, int[]> visionRoadsInts = null;
	public ArrayList<Integer> areasInRange = new ArrayList<>();
	public int distToFire = -1;
	public boolean distToFireCalculated = false;
	public boolean shouldSend = false;
	public transient int saidTime = -1;
	// variables for nohear
	public int toBeAssignedNum = 0;
	public transient ArrayList<Integer> owners = new ArrayList<Integer>();
	public double value = Integer.MAX_VALUE;
	public transient HashSet<Building> nearForSimulator = new HashSet<>();
	public double volume = 0;

	public void setTransients(WorldModel worldModel) {
		visionRoads = new HashMap<>();
		for (Entry<Integer, int[]> e : visionRoadsInts.entrySet()) {
			ArrayList<Coordinate> temp = new ArrayList<>();
			for (int i = 0; i < e.getValue().length; i += 2)
				temp.add(new Coordinate(e.getValue()[i], e.getValue()[i + 1]));
			visionRoads.put(worldModel.roads.get(e.getKey()), temp);
		}
		owners = new ArrayList<Integer>();
		nearForSimulator = new HashSet<>();
	}

	public rescuecore2.standard.entities.Building serverBuilding() {
		return (rescuecore2.standard.entities.Building) serverArea;
	}

	public Building(rescuecore2.standard.entities.Building building) {
		super(building);
	}

	public boolean isFirenessDefined() {
		return ((rescuecore2.standard.entities.Building) serverArea)
				.isFierynessDefined();
	}

	public boolean isTemperatureDefined() {
		return ((rescuecore2.standard.entities.Building) serverArea)
				.isTemperatureDefined();
	}

	public int getTemperature() {
		return ((rescuecore2.standard.entities.Building) serverArea)
				.getTemperature();
	}

	public int fireness() {
		if (serverBuilding().isFierynessDefined())
			return serverBuilding().getFieryness();
		else
			return -1;
	}

	public int getGroundArea() {
		return serverBuilding().getGroundArea();
	}

	public int getFloors() {
		return serverBuilding().getFloors();
	}

	public HashMap<worldModel.Road, ArrayList<Coordinate>> getVisionRoads(
			WorldModel worldModel) {
		if (visionRoads != null)
			return visionRoads;
		visionRoads = new HashMap<worldModel.Road, ArrayList<Coordinate>>();
		visionRoadsInts = new HashMap<>();
		for (worldModel.Road road : nearRoads) {
			ArrayList<Coordinate> visionPoints = FireBrigadeAgent
					.getVisionPoints(worldModel, road, this,
							worldModel.maxDistanceExtinguish, Math.min(
									worldModel.maxDistanceView,
									worldModel.maxDistanceExtinguish),
							worldModel.getTrafficSimulator().geom);
			if (visionPoints != null && visionPoints.size() != 0) {
				visionRoads.put(road, visionPoints);
				int[] ints = new int[visionPoints.size() * 2];
				int i = 0;
				for (Coordinate c : visionPoints) {
					ints[i] = ((int) c.x);
					ints[i + 1] = ((int) c.y);
					i += 2;
				}
				visionRoadsInts.put(worldModel.roadToIndex.get(road), ints);
			}
		}
		for (EntityID entityId : getNeighbours()) {
			Entity entity = worldModel.getEntity(entityId);
			if (entity instanceof Road) {
				worldModel.Road r = (worldModel.Road) worldModel.getArea(entity
						.getID());
				if (!visionRoads.containsKey(r)) {
					ArrayList<Coordinate> rPoint = new ArrayList<Coordinate>();
					Coordinate point = new Coordinate(r.getX(), r.getY());
					if (Math.hypot(point.x - this.getX(), point.y - this.getY()) < worldModel.maxDistanceExtinguish)
						rPoint.add(point);
					if (rPoint != null && rPoint.size() > 0) {
						visionRoads.put(r, rPoint);
						int[] ints = new int[rPoint.size() * 2];
						int i = 0;
						for (Coordinate c : rPoint) {
							ints[i] = ((int) c.x);
							ints[i + 1] = ((int) c.y);
							i += 2;
						}
						visionRoadsInts
								.put(worldModel.roadToIndex.get(r), ints);
					}
				}
			}
		}
		return visionRoads;
	}

	public boolean hasGoodVisionPoint(WorldModel wo) {
		for (worldModel.Road r : this.getVisionRoads(wo).keySet()) {
			if (r.canBeVisited && r.isReachable)
				return true;
		}

		for (Building b : this.visionBuildings.keySet()) {
			if (b.stFire == 0 && b.isReachable && b.canBeVisited) {
				return true;
			}
		}
		return false;
	}

	public boolean hasGoodVisionPointPolice(WorldModel wo) {
		for (worldModel.Road r : this.getVisionRoads(wo).keySet()) {
			if (r.canBeVisited)
				return true;
		}
		for (Building b : this.visionBuildings.keySet()) {
			if (b.stFire == 0 && b.canBeVisited)
				return true;
		}
		return false;
	}

	public int getFieryness() {
		return fireness();
	}

	public boolean isNotIgnitable() {
		return (this instanceof worldModel.Refuge
				|| this.serverArea instanceof PoliceOffice
				|| this.serverArea instanceof AmbulanceCentre || this.serverArea instanceof FireStation);
	}

	public boolean isIgnitable() {
		return !isNotIgnitable();
	}

	public void setFireness(int fireness) {
		serverBuilding().setFieryness(fireness);
	}

	public boolean isOnFire() {
		return ((rescuecore2.standard.entities.Building) serverArea).isOnFire();
	}

	public double totalWallArea = -1;

}
